﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;
using System.Data.SqlClient;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;
using Excel = Microsoft.Office.Interop.Excel;
using System.Reflection;

namespace YFDYFKnowledgeDiscovery.Analysis
{
    public class CommentEmotionClassification
    {
        static SqlConnection conn = DBHelper.getConnection();

        public static void commentEmotionFeatureExtraction()
        {
            List<string> featureList = new List<string>();
            List<string> niceCommentList = new List<string>();
            List<string> badCommentList = new List<string>();
            string sql = "select comment from commentsfortraining where score<4 and score!=-1";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                badCommentList.Add(dt.Rows[i][0].ToString());
                string tempStr = dt.Rows[i][0].ToString();
                for (int j = 0; j < tempStr.Length - 1; j++)
                {
                    string tempFeature = "" + tempStr[j] + tempStr[j + 1];
                    int index = featureList.IndexOf(tempFeature);
                    if (index == -1)
                    {
                        featureList.Add(tempFeature);
                    }
                }
            }
            int badCount = dt.Rows.Count;
            sql = "select comment from commentsfortraining where score=5";
            dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                niceCommentList.Add(dt.Rows[i][0].ToString());
                string tempStr = dt.Rows[i][0].ToString();
                for (int j = 0; j < tempStr.Length - 1; j++)
                {
                    string tempFeature = "" + tempStr[j] + tempStr[j + 1];
                    int index = featureList.IndexOf(tempFeature);
                    if (index == -1)
                    {
                        featureList.Add(tempFeature);
                    }
                }
            }
            int niceCount = dt.Rows.Count;
            double badCommentPro = (double)badCount / ((double)badCount + (double)niceCount);
            double[] featurePro = new double[featureList.Count];
            double[] badFeaturePro = new double[featureList.Count];
            double[] badFeatureWeight = new double[featureList.Count];
            for (int i = 0; i < featureList.Count; i++)
            {
                featurePro[i] = 0.0;
                badFeaturePro[i] = 0.0;
                badFeatureWeight[i] = 0.0;
            }
            for (int i = 0; i < featureList.Count; i++)
            {
                for (int j = 0; j < badCommentList.Count; j++)
                {
                    int index = badCommentList[j].IndexOf(featureList[i]);
                    if (index != -1)
                    {
                        featurePro[i]++;
                        badFeaturePro[i]++;
                    }
                }
            }
            for (int i = 0; i < featureList.Count; i++)
            {
                for (int j = 0; j < niceCommentList.Count; j++)
                {
                    int index = niceCommentList[j].IndexOf(featureList[i]);
                    if (index != -1)
                    {
                        featurePro[i]++;
                    }
                }
            }
            double totalFeature = 0.0;
            for (int i = 0; i < featureList.Count; i++)
            {
                totalFeature += featurePro[i];
            }
            for (int i = 0; i < featureList.Count; i++)
            {
                featurePro[i] = featurePro[i] / totalFeature;
                badFeaturePro[i] = badFeaturePro[i] / totalFeature;
                if (featurePro[i] == 0)
                {
                    badFeatureWeight[i] = 0.0;
                }
                else
                {
                    double temp = badFeaturePro[i] / (featurePro[i] * badCommentPro);
                    if (temp == 0)
                    {
                        badFeatureWeight[i] = 0.0;
                    }
                    else
                    {
                        badFeatureWeight[i] = 1000 * badFeaturePro[i] * Math.Log(temp);
                    }
                }
                sql = "insert into KDCommentFeature(commentfeatureid,commentfeaturename,weight) values(newid(),'" + featureList[i] + "','" + badFeatureWeight[i] + "')";
                int ret = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public static double avgValue()
        {
            double total = 0;
            double sum = 0;
            string sql = "select comment from commentsfortraining where score!=4 and score!=-1";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            total += dt.Rows.Count;
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string tempStr = dt.Rows[i][0].ToString();
                sql = "select commentfeaturename,weight from KDCommentFeature where weight>0.01 or weight<0";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int j = 0; j < dt.Rows.Count; j++)
                {
                    int index = tempStr.IndexOf(dt.Rows[j][0].ToString());
                    if (index != -1)
                    {
                        sum += Convert.ToDouble(dt.Rows[j][1].ToString());
                    }
                }
            }
            double avg = (double)sum / total;
            return avg;
        }

        public static void classifyComments()
        {
            double avg = avgValue();
            string sql = "select id,comments from GoodComments where comments!='' and scores=-1";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string id = dt.Rows[i][0].ToString();
                double logisticValue = classifyCommentEmotion(dt.Rows[i][1].ToString(), avg);
                sql = "update GoodComments set scores='" + logisticValue + "' where id='" + id + "'";
                int ret = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public static double classifyCommentEmotion(string comment, double avg)
        {
            double logisticValue = 0.0;
            double sum = 0;
            string sql = "select commentfeaturename,weight from KDCommentFeature where weight>0.01 or weight<0";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                int index = comment.IndexOf(dt.Rows[i][0].ToString());
                if (index != -1)
                {
                    sum += Convert.ToDouble(dt.Rows[i][1].ToString());
                }
            }
            logisticValue = 1.0 / (1 + Math.Exp(sum - avg));
            return logisticValue;
        }
    }
}
