﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Analysis
{
    public class ContentAnalysis
    {
        public void diseasePreprocess()
        {
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease0.txt", Encoding.Default);
            for (int i = 0; i < lines.Length; i++)
            {
                String[] values = lines[i].Split(new string[] { "-" }, StringSplitOptions.RemoveEmptyEntries);
                lines[i] = values[values.Length - 1];
                lines[i] = lines[i].Replace("NOS", "").Replace(" ", "").Replace("，流行性感冒病毒被标明", "").Replace("，流行性感冒病毒未标明", "");
                if (lines[i].Equals("49") == true)
                {
                    lines[i] = lines[i].Replace("49", "");
                }
                if (lines[i].Equals(")") == true)
                {
                    lines[i] = lines[i].Replace(")", "");
                }
                if (lines[i].Equals("Ⅲ级") == true)
                {
                    lines[i] = lines[i].Replace("Ⅲ级", "");
                }
                if (lines[i].Equals("D]") == true)
                {
                    lines[i] = lines[i].Replace("D]", "");
                }
                if (lines[i].Equals("M]") == true)
                {
                    lines[i] = lines[i].Replace("M]", "");
                }
                if (lines[i].Equals("为胎儿苯丙酮尿症给予的孕产妇医疗") == true)
                {
                    lines[i] = lines[i].Replace("为胎儿苯丙酮尿症给予的孕产妇医疗", "胎儿苯丙酮尿症");
                }
                if (lines[i].Equals("药物反应") == true)
                {
                    lines[i] = lines[i].Replace("药物反应", "");
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease1.txt", lines, Encoding.UTF8);
        }

        public void diseaseGroupBy()
        {
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease1.txt", Encoding.Default);
            string[] linesGroupBy = new string[lines.Length];
            int linesGroupByNum = 0;
            linesGroupBy[linesGroupByNum] = lines[0];
            linesGroupByNum++;
            for (int i = 1; i < lines.Length; i++)
            {
                int flag = 1;
                for (int j = 0; j < linesGroupByNum; j++)
                {
                    if (lines[i].Equals(linesGroupBy[j]) == true)
                    {
                        flag = 0;
                        break;
                    }
                }
                if (flag == 1)
                {
                    linesGroupBy[linesGroupByNum] = lines[i];
                    linesGroupByNum++;
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", linesGroupBy, Encoding.UTF8);
        }

        public void diseaseLevel()
        {
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", Encoding.Default);
            string[] levels = new string[lines.Length];
            for (int i = 0; i < levels.Length; i++)
            {
                levels[i] = "2";
            }
            for (int i = 0; i < lines.Length; i++)
            {
                int flag = 1;
                for (int j = 0; j < lines.Length; j++)
                {
                    if (i != j)
                    {
                        string tempStr = lines[j].Replace(" ", "");
                        int index = lines[i].IndexOf(tempStr);
                        if (tempStr.Equals("") == false && index >= 0)
                        {
                            flag = 0;
                            break;
                        }
                    }
                }
                if (flag == 1)
                {
                    levels[i] = "1";
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\level.txt", levels, Encoding.UTF8);
        }

        public void diseaseContent()
        {
            string[] levels = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\level.txt", Encoding.Default);
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", Encoding.Default);
            string[] level1Name = new string[levels.Length];
            int level1Num = 0;
            string[] level2Name = new string[levels.Length];
            int level2Num = 0;
            for (int i = 0; i < lines.Length; i++)
            {
                if (levels[i].Equals("1") == true)
                {
                    level1Name[level1Num] = lines[i];
                    level1Num++;
                }
                else
                {
                    level2Name[level2Num] = lines[i];
                    level2Num++;
                }
            }
            string[] reference1 = new string[40000];
            string[] reference2 = new string[40000];
            int referenceNum = 0;
            for (int i = 0; i < level1Num; i++)
            {
                for (int j = 0; j < level2Num; j++)
                {
                    string tempStr = level1Name[i].Replace(" ", "");
                    int index = level2Name[j].IndexOf(tempStr);
                    if (tempStr.Equals("") == false && index >= 0)
                    {
                        reference1[referenceNum] = level1Name[i];
                        reference2[referenceNum] = level2Name[j];
                        referenceNum++;
                    }
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\reference1.txt", reference1, Encoding.UTF8);
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\reference2.txt", reference2, Encoding.UTF8);
        }

        public void populationPreprocess()
        {
            string[] context = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\context.txt", Encoding.Default);
            string[] population = new string[context.Length];
            int populationNum = 0;
            for (int i = 0; i < context.Length; i++)
            {
                String[] values = context[i].Split(new string[] { "," }, StringSplitOptions.RemoveEmptyEntries);
                if (values[3].Equals("taboo") == true)
                {
                    population[populationNum] = values[2];
                    populationNum++;
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\population.txt", population, Encoding.UTF8);
        }

        public void populationContent()
        {/*
            string[] population = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\population.txt", Encoding.Default);
            string[] topPopulation = new string[534];
            int[] countPopulation = new int[534];
            int topPopulationNum = 0;
            topPopulation[topPopulationNum] = population[0];
            countPopulation[topPopulationNum] = 0;
            topPopulationNum++;
            for (int i = 0; i < population.Length; i++)
            {
                int flag = 0;
                for (int j = 0; j < topPopulationNum; j++)
                {
                    if (population[i].Equals(topPopulation[j]) == true)
                    {
                        countPopulation[j]++;
                        flag = 1;
                        break;
                    }
                }
                if (flag == 0)
                {
                    topPopulation[topPopulationNum] = population[i];
                    countPopulation[topPopulationNum] = 0;
                    topPopulationNum++;
                }
            }
            for (int i = 0; i < topPopulationNum; i++)
            {
                int maxI = i;
                for (int j = i + 1; j < topPopulationNum; j++)
                {
                    if (countPopulation[maxI] < countPopulation[j])
                    {
                        maxI = j;
                    }
                }
                if (maxI != i)
                {
                    string tempStr = topPopulation[i];
                    int tempInt = countPopulation[i];
                    topPopulation[i] = topPopulation[maxI];
                    countPopulation[i] = countPopulation[maxI];
                    topPopulation[maxI] = tempStr;
                    countPopulation[maxI] = tempInt;
                }
            }
            string[] countStr = new string[countPopulation.Length];
            for (int i = 0; i < countPopulation.Length; i++)
            {
                countStr[i] = (countPopulation[i] + 1).ToString();
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\topPopulation.txt", topPopulation, Encoding.UTF8);
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\countPopulation.txt", countStr, Encoding.UTF8);
            */
            /*
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\topPopulation.txt", Encoding.Default);
            string[] levels = new string[lines.Length];
            for (int i = 0; i < levels.Length; i++)
            {
                levels[i] = "2";
            }
            for (int i = 0; i < lines.Length; i++)
            {
                int flag = 1;
                for (int j = 0; j < lines.Length; j++)
                {
                    if (i != j)
                    {
                        string tempStr = lines[j].Replace(" ", "");
                        int index = lines[i].IndexOf(tempStr);
                        if (tempStr.Equals("") == false && index >= 0)
                        {
                            flag = 0;
                            break;
                        }
                    }
                }
                if (flag == 1)
                {
                    levels[i] = "1";
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\levelPopulation.txt", levels, Encoding.UTF8);
            */
            ///*
            string[] levels = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\levelPopulation.txt", Encoding.Default);
            string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\topPopulation.txt", Encoding.Default);
            string[] level1Name = new string[levels.Length];
            int level1Num = 0;
            string[] level2Name = new string[levels.Length];
            int level2Num = 0;
            for (int i = 0; i < lines.Length; i++)
            {
                if (levels[i].Equals("1") == true)
                {
                    level1Name[level1Num] = lines[i];
                    level1Num++;
                }
                else
                {
                    level2Name[level2Num] = lines[i];
                    level2Num++;
                }
            }
            string[] reference1 = new string[40000];
            string[] reference2 = new string[40000];
            int referenceNum = 0;
            for (int i = 0; i < level1Num; i++)
            {
                for (int j = 0; j < level2Num; j++)
                {
                    string tempStr = level1Name[i].Replace(" ", "");
                    int index = level2Name[j].IndexOf(tempStr);
                    if (tempStr.Equals("") == false && index >= 0)
                    {
                        reference1[referenceNum] = level1Name[i];
                        reference2[referenceNum] = level2Name[j];
                        referenceNum++;
                    }
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\topPopulation1.txt", reference1, Encoding.UTF8);
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\结果\\topPopulation2.txt", reference2, Encoding.UTF8);
            //*/
        }

        public void symptomPreprocess()
        {
            string[] symptomAll = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\symptom0.txt", Encoding.Default);
            string[] disease = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", Encoding.Default);
            string[] symptom = new string[symptomAll.Length];
            int symptomNum = 0;
            for (int i = 0; i < symptomAll.Length; i++)
            {
                int flag = 1;
                for (int j = 0; j < disease.Length; j++)
                {
                    if (symptomAll[i].Equals(disease[j]) == true)
                    {
                        flag = 0;
                        break;
                    }
                }
                if (flag == 1)
                {
                    symptom[symptomNum] = symptomAll[i];
                    symptomNum++;
                }
            }
            for (int i = 0; i < symptomNum; i++)
            {
                for (int j = 0; j < disease.Length; j++)
                {
                    int index = symptom[i].IndexOf(disease[j]);
                    if (index >= 0)
                    {
                        symptom[i].Replace(disease[j], "");
                    }
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\symptom1.txt", symptom, Encoding.UTF8);
        }

        public void symptomInteraction()
        {
            string[] symptomAll = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\symptom0.txt", Encoding.Default);
            string[] disease = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", Encoding.Default);
            string[] interaction = new string[symptomAll.Length];
            int interactionNum = 0;
            for (int i = 0; i < symptomAll.Length; i++)
            {
                for (int j = 0; j < disease.Length; j++)
                {
                    if (symptomAll[i].Replace(" ", "").Equals(disease[j].Replace(" ", "")) == true)
                    {
                        interaction[interactionNum] = symptomAll[i];
                        interactionNum++;
                        break;
                    }
                }
            }
            System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\symptomDiseaseInteraction.txt", interaction, Encoding.UTF8);
        }
    }
}
