﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Excel = Microsoft.Office.Interop.Excel;
using System.Reflection;
using System.Data;
using System.Runtime.InteropServices;
using System.Data.SqlClient;
namespace YFDYFKnowledgeDiscovery.Common
{
    public class ExcelHelper
    {
        private Excel.Application excelApp = null;
        private Excel.Workbook workBook = null;
        private Excel.Workbooks workBooks = null;

        public ExcelHelper(string filePath)
        {
            excelApp = new Excel.Application();
            excelApp.Visible = false;
            workBooks = excelApp.Workbooks;
            workBook = workBooks.Open(filePath);

        }
        public List<ExcelSheet> getSheetName()
        {
            List<ExcelSheet> resultList = new List<ExcelSheet>();
            Excel.Sheets sheets = workBook.Sheets;
            //SqlConnection conn = DBHelper.getConnection();
            //string sql = "select ID,sheetName,sheetType from tc_hongguanjingji";
            //DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            //DBHelper.CloseConnection(conn);
            //if (dt == null || dt.Rows.Count == 0)
            //{
            //return null;
            //}
            //else
            //{
            for (int i = 1; i <= sheets.Count; i++)
            {
                //for (int j = 0; j < dt.Rows.Count; j++)
                //{
                //if (((Excel.Worksheet)sheets[i]).Name.Equals(dt.Rows[j]["sheetName"].ToString()))
                //{
                //int ID=Convert.ToInt32(dt.Rows[j]["ID"].ToString());
                //int type=Convert.ToInt32(dt.Rows[j]["sheetType"].ToString());
                resultList.Add(new ExcelSheet((Excel.Worksheet)sheets[i]));
                //break;
                //}
                //}

            }
            //}
            return resultList;
        }

        //public List<ExcelHeader> readSheetHeader(Excel.Worksheet sheet)
        //{
        //    if (sheet == null)
        //        return null;
        //    List<ExcelHeader> result = new List<ExcelHeader>();
        //    int columnNumber = sheet.UsedRange.Columns.Count;
        //    Excel.Range rg = (Excel.Range)sheet.UsedRange;
        //    string year = "";
        //    string month = "";
        //    int r = 1, c = 1;
        //    //Excel.Range tempRg = (Excel.Range)rg.Cells[1, 1];

        //    while (c <= rg.Columns.Count)
        //    {
        //        //获取年份
        //        Excel.Range tempRg = (Excel.Range)rg.Cells[1, c];
        //        if (tempRg.Value2 == null || string.IsNullOrEmpty(tempRg.Value2.ToString()))
        //        {
        //            break;
        //        }
        //        ExcelHeader tempHeader = new ExcelHeader();
        //        if ((bool)tempRg.MergeCells == true)
        //        {
        //            Excel.Range mergeRange = tempRg.MergeArea;
        //            int rowCount = mergeRange.Rows.Count;
        //            int colCount = mergeRange.Columns.Count;
        //            int tempCol = 1;
        //            while (tempCol <= colCount)
        //            {
        //                //获取年份
        //                Excel.Range tempRange = (Excel.Range)(mergeRange.Cells[1, tempCol]);
        //                if (tempRange == null
        //                        || tempRange.Value2 == null
        //                        || string.IsNullOrEmpty(tempRange.Value2.ToString()))
        //                {

        //                }
        //                else
        //                {
        //                    year = tempRange.Value2.ToString();
        //                    int yearValue = 0;
        //                    bool flag = int.TryParse(year, out yearValue);
        //                    if (flag)
        //                    {
        //                        tempHeader.HeaderYear = yearValue;
        //                        tempHeader.HeaderType = 2;
        //                    }
        //                    else
        //                    {
        //                        tempHeader.HeaderContent = year;
        //                        tempHeader.HeaderType = 1;
        //                    }
        //                }
        //                //year =string.IsNullOrEmpty(tempRange.Value2.ToString())?year:tempRange.Value2.ToString();
        //                Excel.Range monthRange = (Excel.Range)rg.Cells[2, c + tempCol - 1];


        //                if (monthRange == null
        //                        || monthRange.Value2 == null
        //                        || string.IsNullOrEmpty(monthRange.Value2.ToString()))
        //                {
        //                    tempHeader.HeaderQuarter = -1;
        //                }
        //                else
        //                {
        //                    month = monthRange.Value2.ToString();
        //                    if (month == "第一季度")
        //                        tempHeader.HeaderQuarter = 1;
        //                    else if (month == "第二季度")
        //                        tempHeader.HeaderQuarter = 2;
        //                    else if (month == "第三季度")
        //                        tempHeader.HeaderQuarter = 3;
        //                    else if (month == "第四季度")
        //                        tempHeader.HeaderQuarter = 4;
        //                    else
        //                        tempHeader.HeaderQuarter = -1;
        //                }
        //                result.Add(tempHeader);
        //                // Console.WriteLine("["+year+","+month+"]");
        //                tempCol++;
        //            }
        //            c += colCount;
        //        }
        //    }
        //    return result;
        //}



        public List<List<string>> ReadExcelContent(Excel.Worksheet sheet)
        {

            int rowNumber = sheet.UsedRange.Rows.Count;
            int colNumber = sheet.UsedRange.Columns.Count;
            List<List<string>> result = new List<List<string>>();
            bool flag = false;
            
            for (int i = 0; i < rowNumber; i++)
            {
                int tmp = 0;
                List<string> value = new List<string>();
                for (int j = 0; j < colNumber; j++)
                {
                    string temp = "";
                    Excel.Range er = (Excel.Range)sheet.Cells[i + 1, j + 1];
                    if (er.Text == null)
                    {
                        tmp++;
                    }
                    else
                    {
                        if (er.Text.ToString().IndexOf("#") != -1) 
                        {
                            er.ColumnWidth=150;
                        }
                        temp = er.Text.ToString().Trim().Replace(" ", "").Replace("\n", "");
                    }
                    value.Add(temp);
                }
                if (tmp < colNumber)
                {
                    result.Add(value);
                }
            }
            return result;

        }


        /// <summary>
        /// 导入【固定投资】信息
        /// </summary>
        /// <param name="header"></param>
        /// <param name="sheet"></param>
        /// <param name="zhibiao"></param>
        /// <returns></returns>
        //public List<string> ReadExcelContent2(List<ExcelHeader> header, Excel.Worksheet sheet, int zhibiao)
        //{
        //    int rowNumber = sheet.UsedRange.Rows.Count;
        //    List<string> sqls = new List<string>();
        //    bool flag = false;
        //    string areaCode = "";

        //    for (int i = 3; i < rowNumber; i++)
        //    {
        //        string id = "";
        //        string tradecode = "All";
        //        for (int j = 0; j < header.Count; j++)
        //        {
        //            ExcelHeader tempHeader = header[j];
        //            if (tempHeader.HeaderType == 1 && tempHeader.HeaderContent == "编号")
        //            {
        //                if (((Excel.Range)sheet.Cells[i, j + 1]).Value2 == null)
        //                {
        //                    if (((Excel.Range)sheet.Cells[i, j + 3]).Value2 == null)
        //                    {
        //                        flag = true;
        //                        break;
        //                    }
        //                    else
        //                    {
        //                        id = areaCode;
        //                        tradecode = ((Excel.Range)sheet.Cells[i, j + 3]).Value2.ToString();
        //                    }

        //                }
        //                else
        //                {
        //                    id = ((Excel.Range)sheet.Cells[i, j + 1]).Value2.ToString();
        //                    areaCode = id;
        //                }
        //            }

        //            else if (tempHeader.HeaderType == 2)
        //            {
        //                //数值类型
        //                int year = tempHeader.HeaderYear;
        //                int quarter = tempHeader.HeaderQuarter;
        //                string value = "";
        //                if (((Excel.Range)sheet.Cells[i, j + 1]).Value2 == null)
        //                {
        //                    continue;
        //                }
        //                else
        //                {
        //                    value = ((Excel.Range)sheet.Cells[i, j + 1]).Value2.ToString();
        //                    value = value.Replace(" ", "");
        //                    if (string.IsNullOrEmpty(value))
        //                        continue;
        //                    if (quarter == -1)
        //                    {
        //                        string sql = "insert into tb_hongguanjingji2(areacode,tradecode,zhibiao," +
        //                       " yearvalue,value) values(" + id + ",'" + tradecode + "'," + zhibiao + "," + year
        //                       + "," + value + ")";
        //                        //Console.WriteLine(i + ":" + sql);
        //                        sqls.Add(sql);
        //                    }
        //                    else
        //                    {
        //                        string sql = "insert into tb_hongguanjingji2(areacode,tradecode,zhibiao," +
        //                          " yearvalue,quartervalue,value) values(" + id + ",'" + tradecode + "'," + zhibiao + "," + year
        //                          + "," + quarter + "," + value + ")";
        //                        // Console.WriteLine(i + ":" + sql);
        //                        sqls.Add(sql);
        //                    }
        //                }


        //            }
        //        }
        //        if (flag)
        //            break;
        //    }
        //    return sqls;
        //}
        public void close()
        {
            //workBooks.Save();
            workBook.Close(false);
            //NAR(workBook);
            workBook = null;
            workBooks.Close();
            // NAR(workBooks);
            workBooks = null;
            excelApp.Quit();
            //Kill(excelApp);
            // NAR(excelApp);
            Kill(excelApp);
            excelApp = null;

            GC.Collect();
        }



        [DllImport("User32.dll", CharSet = CharSet.Auto)]
        public static extern int GetWindowThreadProcessId(IntPtr hwnd, out int ID);
        public static void Kill(Excel.Application excel)
        {
            IntPtr t = new IntPtr(excel.Hwnd);   //得到这个句柄，具体作用是得到

            int k = 0;
            GetWindowThreadProcessId(t, out k);
            //得到本进程唯一标志k   
            System.Diagnostics.Process p = System.Diagnostics.Process.GetProcessById(k);   //得到对进程k的引用   
            p.Kill();     //关闭进程k   

        }

    }
}