﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Common
{
    public class ExpressionSplitWordHelper
    {
        //*为提取词；%为任意数字匹配；@为任意字母匹配；&为任意字母或数字匹配；其他为字符串匹配
        static String[] Expressions = new String[] { 
        // "本品为复方制剂，其组份为|*",
        // "主要成份及其化学名称为：|*",
        // "主要成分及其化学名称为：|*", 
        // "主要成分及其化学名称为|*",
        // "主要成分及其化学名称：|*",
        // "主要成份及化学名称：|*",
        // "本品主要组成成分为：|*",
        // "主要成分及化学名称：|*" ,
        // "本品主要由|*|组成",
        // "主要有效成分为|*",
        // "主要化学成分为|*",
        // "主要成份名称：|*",
        // "主要组成成份：|*",
        // "主要中药成分：|*",
        // "主要组成成分：|*",
        // "主要组成成分为",
        // "主要化学成分|*",
        // "要组成成分：|*",
        // "每粒胶囊含有|*",
        // "主要组成成分:",
        // "主要成份为|*",
        // "主要成分为|*",
        // "主要成份是|*",
        // "主要成分是|*",
        // "主要成份：|*",
        // "主要成分：|*",
        // "主要成份，|*",
        // "每1000ml含|*",
        // "主要成份|*",
        // "主要成分|*",
        // "每毫升含|*",
        // "每10ml含|*",
        // "每100ml含|*",
        // "每100毫升|*",
        // "每100g|*",
        // "每1000ml|*",
        // "主要含|*",
        // "主要为|*",
        // "主要由|*",
        // "每片含|*",
        // "每粒含|*",
        //"本品为复方制剂，其主要组分为：|*",
        //"本品为复方制剂，其组分为|*",
        //"本品为复方制剂，每10毫升|*",
        //"本品为复主制剂，其组分为：|*",
        //"本品为复方制剂，内含|*",
        //"本品为复方制剂，每支|*",
        //"本品为复方制剂，每贴|*",
        //"本品为复方制剂，每枚|*",
        //"本品为复方制剂，每粒|*",
        //"本品为复方制剂，每克|*",
        //"本品为复方制剂，每包|*",
        //"本品为复方制剂，含有|*",
        //"本品主要化学成份为|*",
        //"每粒硬胶囊分别含有|*",
        //"本品有效成份为|*",
        //"本品活性成份为|*",
        //"本品活性成分为|*",
        //"本品主要组分为|*",
        //"本品主要成为|*",
        //"每支10毫升含|*",
        //"每瓶500ml：含|*",
        //"本药成分为|*",
        //"本品成分为|*",
        //"本品成份为|*",
        //"本品每袋含|*",
        //"每粒胶囊含|*",
        //"每个胶囊含|*",
        //"本品主药为|*",
        //"活性成份为：|*",
        //"化学名称为：|*",
        //"每10毫升含|*",
        //"活性成份为|*",
        //"化学成分为|*",
        //"每袋中含|*",
        //"每10克含|*",
        //"活性成份：|*",
        //"活性成分：|*",
        //"活性成份|*",
        //"化学名为：|*",
        //"化学名称：|*",
        //"每支10mL|*",
        //"每粒中含|*",
        //"化学名：|*",
        //"每袋含|*",
        //"本品含|*",
        //"每支含|*",
        //"每丸含|*",
        //"每瓶含|*",
        //"本品为|*",
        //"本品是|*",
        //"成份：|*",
        //"每片|*",
        //"每喷|*",
        //"含有|*",
        //"含|*",
        //"*|%|毫克",
        //"*|%|克",
        //"*|%|g",
        //"*|%|mg",
        //"*|%|μg",
        //没有说明书的症状
        "主要用于治疗|*",
        "主要适用于|*",
        "本品主要用于|*",
        "本品仅适用于|*",
        "本品适用于|*",
        "本品可用于|*",
        "本品仅用于|*",
        "本品用于|*",
        "主要用于|*",
        "应用于|*",
        "适用于|*",
        "故可于|*",
        "还可于|*",
        "治疗|*",
        "*|用于|*",
        "主治|*",
        "可用于|*",
        "辅助用于|*",
        "仅用于|*",
        "另可于|*",
        "可于|*",
        //"*|适用于|*",
        //"*|用于|*"
        "*"
        };

        public static List<string> expressionSplitWord(String sentence)
        {
            List<string> splitList = new List<string>();
            int n = 0;
            int finishFlag = 1;
            while (n<Expressions.Length)
            {
                String tempSentence = sentence;
                finishFlag = 1;
                String[] indexValues = Expressions[n].Split(new string[] { "|" }, StringSplitOptions.RemoveEmptyEntries);
                int flag = 0;
                for (int i = 0; i < indexValues.Length; i++)
                {
                    if (indexValues[i].Equals("*") == true)
                    {
                        flag = 1;
                    }
                    else
                    {
                        if (indexValues[i].Equals("%") == true)
                        {
                            int startId = -1;
                            int numberLength = 0;
                            for (int j = 0; j < tempSentence.Length; j++)
                            {
                                if (tempSentence[j] >= '0' && tempSentence[j] <= '9')
                                {
                                    if (startId == -1)
                                    {
                                        startId = j;
                                        numberLength++;
                                    }
                                    else
                                    {
                                        numberLength++;
                                    }
                                }
                            } 
                            if (flag == 1)
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    splitList.Add(tempSentence.Substring(0, startId));
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                    flag = 0;
                                }
                            }
                            else
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                }
                            }
                        }
                        else if (indexValues[i].Equals("@") == true)
                        {
                            int startId = -1;
                            int numberLength = 0;
                            for (int j = 0; j < tempSentence.Length; j++)
                            {
                                if ((tempSentence[j] >= 'a' && tempSentence[j] <= 'z') || ((tempSentence[j] >= 'A' && tempSentence[j] <= 'Z')))
                                {
                                    if (startId == -1)
                                    {
                                        startId = j;
                                        numberLength++;
                                    }
                                    else
                                    {
                                        numberLength++;
                                    }
                                }
                            }
                            if (flag == 1)
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    splitList.Add(tempSentence.Substring(0, startId));
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                    flag = 0;
                                }
                            }
                            else
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                }
                            }
                        }
                        else if (indexValues[i].Equals("&") == true)
                        {
                            int startId = -1;
                            int numberLength = 0;
                            for (int j = 0; j < tempSentence.Length; j++)
                            {
                                if ((tempSentence[j] >= 'a' && tempSentence[j] <= 'z') || (tempSentence[j] >= 'A' && tempSentence[j] <= 'Z') || (tempSentence[j] >= '0' && tempSentence[j] <= '9'))
                                {
                                    if (startId == -1)
                                    {
                                        startId = j;
                                        numberLength++;
                                    }
                                    else
                                    {
                                        numberLength++;
                                    }
                                }
                            }
                            if (flag == 1)
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    splitList.Add(tempSentence.Substring(0, startId));
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                    flag = 0;
                                }
                            }
                            else
                            {
                                if (startId > 0 && numberLength != -1)
                                {
                                    tempSentence = tempSentence.Substring(startId + numberLength);
                                }
                            }
                        }
                        else
                        {
                            int index = tempSentence.IndexOf(indexValues[i].ToString());
                            if (index != -1)
                            {
                                if (flag == 1)
                                {
                                    splitList.Add(tempSentence.Substring(0, index));
                                    tempSentence = tempSentence.Substring(index + indexValues[i].Length);
                                    flag = 0;
                                }
                                else
                                {
                                    tempSentence = tempSentence.Substring(index + indexValues[i].Length);
                                }
                            }
                            else
                            {
                                finishFlag = 0;
                                break;
                            }
                        }
                    }
                }
                if (flag == 1)
                {
                    splitList.Add(tempSentence);
                }
                if (finishFlag == 1)
                {
                    break;
                }
                else
                {
                    n++;
                }
            }
            if (finishFlag == 1)
            {
                return splitList;
            }
            else
            {
                return null;
            }
        }
    }
}
