﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HtmlAgilityPack;
using System.Text;
using System.Net;
using System.IO;

/// <summary>
/// HTMLHelper 的摘要说明
/// </summary>
public class HTMLHelper
{

    /// <summary>
    /// 根据URL地址获取HTML Document
    /// </summary>
    /// <param name="urlStr">URL地址</param>
    /// <returns>HTMLDocument</returns>
    public static HtmlDocument getHTMLContentByURL(string urlStr, Encoding encoding)
    {
        HtmlWeb web = new HtmlWeb();
        web.OverrideEncoding = encoding;
        HtmlDocument document = null;
        try
        {
            document = web.Load(urlStr);
        }
        catch
        {
            document = null;
        }
        return document;
    }

    public static HtmlNodeCollection getHTMLNodeByXpath(string xpath, HtmlDocument document)
    {
        HtmlNodeCollection results = null;
        try
        {
            HtmlNode rootNode = document.DocumentNode;
            results = rootNode.SelectNodes(xpath);
        }
        catch
        {
            results = null;
        }
        return results;
    }


    public static List<string> getNodeContent(HtmlNodeCollection nodeList, string attr)
    {
        List<string> result = new List<string>();
        string url = "";
        string name = "";
        if (nodeList == null)
            return result;
        foreach (HtmlNode tempNode in nodeList)
        {
            name = tempNode.InnerText;
            if (attr == "")
            {
                result.Add(name);
            }
            else
            {
                url = tempNode.GetAttributeValue(attr, url);
                if (!string.IsNullOrEmpty(url))
                {
                    result.Add(name + "|" + url);
                }
            }
        }
        return result;
    }
    public static HtmlAgilityPack.HtmlDocument getDocumentByHttpRequest(string strRequestUri)
    {// 初始化HttpWebRequest
        HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(strRequestUri);

        // 封装Cookie
        Uri uri = new Uri(strRequestUri);
        Cookie cookie = new Cookie("Name", ""); // 设置key、value形式的Cookie
        CookieContainer cookies = new CookieContainer();
        cookies.Add(uri, cookie);
        httpRequest.CookieContainer = cookies;
        //System.Net.WebProxy proxy = new WebProxy("1.179.143.178", 3128);

        //httpRequest.Proxy = proxy;

        // 封装Http Header
        httpRequest.Method = "Post";
        httpRequest.Referer = "";
        httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.89 Safari/537.36";
        httpRequest.Accept = "text/plain, */*; q=0.01";
        httpRequest.ContentType = "application/x-www-form-urlencoded; charset=UTF-8";
        httpRequest.Timeout = 1000 * 30;
        httpRequest.KeepAlive = true;

        // 通过流写入请求数据
        byte[] bytes = System.Text.Encoding.UTF8.GetBytes(""); // 编码形式按照个人需求来设置
        httpRequest.ContentLength = bytes.Length;
        Stream requestStream = httpRequest.GetRequestStream();
        requestStream.Write(bytes, 0, bytes.Length);
        requestStream.Close(); // 不要忘记关闭流

        // 获得应答报文
        HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
        Stream responseStream = httpResponse.GetResponseStream();
        StreamReader reader = new StreamReader(responseStream, System.Text.Encoding.Default);
        string strResponse = reader.ReadToEnd();
       return null;
        reader.Close();
        responseStream.Close();

    }

}