﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SqlClient;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Common
{
    public class StatisticSplitWordHelper
    {
        static SqlConnection conn = DBHelper.getConnection();

        public static String[] conjection = { "、", ",", "，", ".", "。", " ", "：", ":", "；", ";", "以及", "及", "/"
                                                , "和", "或", "与", "并", "合并","(","又" };

        public static List<string> getSentence(String tableName,String columnName,String whereStr)
        {
            String sql = "";
            if (whereStr != null)
            {
                sql = "select " + columnName + " from " + tableName + " " + whereStr;
            }
            else
            {
                sql = "select " + columnName + " from " + tableName;
            }
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            List<string> sentenceList = new List<string>();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String[] values = dt.Rows[i][0].ToString().Split(conjection, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    sentenceList.Add(values[j].ToString());
                }
            }
            return sentenceList;
        }

        public static List<string> getWordList(List<string> sentenceList)
        {
            List<string> wordList = new List<string>();
            for (int i = 0; i < sentenceList.Count; i++)
            {
                String tempStr = sentenceList[i].ToString();
                for (int j = 0; j < tempStr.Length; j++)
                {
                    int index = wordList.IndexOf(""+tempStr[j]);
                    if (index == -1)
                    {
                        wordList.Add("" + tempStr[j]);
                    }
                }
            }
            return wordList;
        }

        public static List<string> splitSentence(List<string> sentenceList,List<string> wordList,double param)
        {
            long total = 0;
            List<string> splitMaxLenList = new List<string>();
            int[,] arr = new int[wordList.Count, wordList.Count];
            for (int i = 0; i < wordList.Count; i++)
            {
                for (int j = 0; j < wordList.Count; j++)
                {
                    arr[i, j] = 0;
                }
            }
            for (int i = 0; i < sentenceList.Count; i++)
            {
                String tempStr = sentenceList[i].ToString();
                for (int j = 0; j < tempStr.Length-1; j++)
                {
                    int index1 = wordList.IndexOf(""+tempStr[j]);
                    int index2 = wordList.IndexOf(""+tempStr[j+1]);
                    if (index1 != -1 && index2!=-1)
                    {
                        arr[index1, index2]++;
                        total++;
                    }
                }
            }
            int[] visited = new int[wordList.Count];
            for (int i = 0; i < wordList.Count; i++)
            {
                double paramOnce = 0.0;
                int startId = i;
                for (int j = 0; j < wordList.Count; j++)
                {
                    visited[j] = 0;
                }
                String sequence = "";
                for (int j = 0; j < wordList.Count; j++)
                {
                    if (((double)arr[i, j] / total) > param)
                    {
                        sequence += wordList[i]+wordList[j];
                        startId = j;
                        visited[i] = 1;
                        visited[j] = 1;
                        paramOnce = param;
                        break;
                    }
                }
                if (sequence.Equals("") == true)
                {
                    continue;
                }
                double multiple = 1.0;
                while (true)
                {
                    int flag = 0;
                    for (int j = 0; j < wordList.Count; j++)
                    {
                        if (visited[j] == 0)
                        {
                            flag = 1;
                            visited[j] = 1;
                            double tempMultiple = multiple * ((double)arr[startId, j] / total);
                            double tempParamOnce = paramOnce * param;
                            if (tempMultiple > paramOnce)
                            {
                                startId = j;
                                multiple = tempMultiple;
                                paramOnce = tempParamOnce;
                                sequence += wordList[j];
                                break;
                            }
                        }
                    }
                    if (flag == 0)
                    {
                        break;
                    }
                }
                if (sequence.Length>=2)
                {
                    splitMaxLenList.Add(sequence);
                }
            }
            return splitMaxLenList;
        }
    }
}
