﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace YFDYFKnowledgeDiscovery.Common
{
    public static class StringHelper
    {
        /// <summary>
        /// 处理得到字符串中的特殊字符，诸如空格、单引号等
        /// </summary>
        /// <param name="str"></param>
        /// <returns></returns>
        public static string FilterStr(this string str)
        {
            if (str != null)
                return str.Trim().Replace("\r", "").Replace("\n", "").Replace("&nbsp;", "").Replace("'", "").Replace(" ", "").Replace("\t", "").Replace("&hellip;", "").Replace("&nbsp","");
            return null;
        }

        public static float stringSimilarity(string str1, string str2)
        {
            float similarity = 0.0f;
            int index1 = str1.IndexOf(str2);
            int index2 = str2.IndexOf(str1);
            if (index1 != -1 || index2 != -1)
            {
                similarity = 1.0f;
            }
            else
            {
                float count = 0.0f;
                for (int i = 0; i < str1.Length; i++)
                {
                    string temp = str1.Substring(i, 1);
                    int tempIndex = str2.IndexOf(temp);
                    if (tempIndex != -1)
                    {
                        count++;
                    }
                }
                similarity = count / str1.Length;
            }
            return similarity;
        }

        public static string deleteSignature(string str,string frontFlag, string tailFlag)
        {
            string result = str;
            string tempResult = result;
            int frontIndex = tempResult.IndexOf(frontFlag);
            int tailIndex = tempResult.IndexOf(tailFlag);
            while (frontIndex != -1 && tailIndex != -1)
            {
                if (frontIndex < tailIndex)
                {
                    result = tempResult.Substring(0, frontIndex);
                    if (tailIndex + 1 < tempResult.Length)
                    {
                        result += tempResult.Substring(tailIndex + 1);
                    }
                    tempResult = result;
                    frontIndex = tempResult.IndexOf(frontFlag);
                    tailIndex = tempResult.IndexOf(tailFlag);
                }
                else if (frontIndex > tailIndex)
                {
                    result = tempResult.Substring(tailIndex + 1, frontIndex - tailIndex - 1);
                    tempResult = result;
                    frontIndex = tempResult.IndexOf(frontFlag);
                    tailIndex = tempResult.IndexOf(tailFlag);
                }
            }
            return result;
        }
    }
}
