﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Word = Microsoft.Office.Interop.Word;
using System.Reflection;

/// <summary>
/// WordHelper 的摘要说明
/// </summary>
public class WordHelper
{
	private Word.Application _word;
       private Word.Document _doc;

       public WordHelper(string filePath)
       {
           _word = new Word.Application();
           _word.Visible = false;
           object fileName = filePath;
           Object Nothing = Missing.Value;
           object isVisible = false;
           object readOnly = true;
           _doc = _word.Documents.Open(ref fileName, ref Nothing, ref readOnly,
            ref Nothing, ref Nothing, ref Nothing, ref Nothing, ref Nothing,
            ref Nothing, ref Nothing, ref Nothing, ref isVisible, ref Nothing,
            ref Nothing, ref Nothing, ref Nothing);
          
       }


       public void ReadWordContent(List<String> result)
       {
           int i = 1;
           foreach (Word.Paragraph tempPara in _doc.Paragraphs)
           {
               string text = tempPara.Range.Text.Trim();
               text = text.Replace("\r", "");
               text = text.Replace("\n", "");
               if (!string.IsNullOrEmpty(text))
               {
                   result.Add(tempPara.Range.Text.Trim());
               }
           }
       }

       public List<WordTableContent> ReadWordTable(int i)
       {
           Word.Table dt = GetTable(i);
           List<WordTableContent> resultList=ReadTableContent(dt);
           return resultList;
       }
       /// <summary>
       /// 获取第N个表格
       /// </summary>
       /// <returns></returns>
       public Word.Table GetTable(int i)
       {
           if (_doc == null || _doc.Content.Tables.Count == 0)
               return null;
           else
           {
               Word.Table tb = _doc.Content.Tables[1];
               return tb;
           }
       }

       public List<WordTableContent> ReadTableContent(Word.Table tb)
       {
           if (tb == null)
               return null;
           else
           {
               List<WordTableContent> resultList = new List<WordTableContent>();
               foreach (Word.Row tr in tb.Rows)
               {
                   string text = tr.Cells[1].Range.Text.Trim();
                   text=text.Replace("\r","");
                   text = text.Replace("\n", "");
                   string[] strs = text.Split('：');
                   if (strs.Length == 2)
                   {
                       WordTableContent tempContent = new WordTableContent(strs[0], strs[1]);
                       resultList.Add(tempContent);
                   }
               }
               return resultList;
           }
       }

       public void close()
       {
           _doc.Close();
           _doc = null;
           _word.Quit();
           _word = null;
           GC.Collect();
       }



    }
