﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;
using Excel = Microsoft.Office.Interop.Excel;
using System.Data.SqlClient;
using System.Data;
using System.Reflection;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class ExcelDao
    {

        static SqlConnection conn = DBHelper.getConnection();

        public static void ReadExcel(String filePathName)
        {
            ExcelHelper excel = new ExcelHelper(filePathName);
            List<ExcelSheet> sheets = excel.getSheetName();
            if (sheets != null)
            {
                for (int i = 0; i < sheets.Count; i++)
                {
                    Excel.Worksheet tempSheet = sheets[i].WorkSheet;
                    List<List<string>> result = excel.ReadExcelContent(tempSheet);
                }
            }
            excel.close();
            excel = null;
            GC.Collect();
        }

        public static void writeExcel(String filePathName)
        {
            Excel.Application xapp = new Excel.Application();
            try
            {
                Excel.Workbook xbook = xapp.Workbooks._Open(filePathName, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value);
                Excel.Worksheet xsheet = (Excel.Worksheet)xbook.Sheets[1];
                Excel.Range rng = null;
                string sql = null;
                DataTable dt = null;
                rng = xsheet.get_Range("A1", Missing.Value);
                rng.Value2 = "药品";
                sql = "select medicinename from medicine order by medicinename";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("A" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("B1", Missing.Value);
                rng.Value2 = "成分";
                //sql = "select componentname from component";
                sql = "select ComponentName from Component order by ComponentName";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("B" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("C1", Missing.Value);
                rng.Value2 = "症状（包含功能）";
                //sql = "select symptomName from symptom";
                sql = "select symptomName from symptom order by symptomName";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("C" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("D1", Missing.Value);
                rng.Value2 = "疾病";
                sql = "select diseasename from disease order by diseasename";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("D" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("E1", Missing.Value);
                rng.Value2 = "保健品";
                sql = "select name from HealthProductInstruction order by name";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("E" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("F1", Missing.Value);
                rng.Value2 = "中药材";
                sql = "select name from ChineseMedicineMaterialInstruction order by name";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("F" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("G1", Missing.Value);
                rng.Value2 = "医疗器械";
                sql = "select name from MedicalInstrumentInstruction order by name";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("G" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("H1", Missing.Value);
                rng.Value2 = "人群";
                sql = "select populationName from population order by populationName";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("H" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("J1", Missing.Value);
                rng.Value2 = "人体部位";
                sql = "select positionname from body order by positionname";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("J" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("K1", Missing.Value);
                rng.Value2 = "科室";
                sql = "select officename from office order by officename";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("K" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                rng = xsheet.get_Range("L1", Missing.Value);
                rng.Value2 = "食物";
                sql = "select foodname from Food group by foodname";
                dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    Excel.Range rng2 = xsheet.get_Range("L" + (i + 2), Missing.Value);
                    rng2.Value2 = dt.Rows[i][0].ToString();
                }
                xbook.SaveAs(@filePathName, Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value,
                    Excel.XlSaveAsAccessMode.xlNoChange, Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value);
                xapp.Workbooks.Close();
            }
            catch
            {
                xapp.Workbooks.Close();
            }
        }
    }
}
