﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class GoodPopulation
    {
        static SqlConnection conn = DBHelper.getConnection();

        public List<string> getPopulationList()
        {
            List<string> populationList = new List<string>();
            try
            {
                string popSql = "SELECT populationName FROM Population";
                DataTable dtpop = DBHelper.ExecuteWithReset(popSql, conn);

                for (int i = 0; i < dtpop.Rows.Count; i++)
                {
                    populationList.Add(dtpop.Rows[i]["populationName"].ToString());
                }
                return populationList;
            }
            catch
            {
                return null;
            }
        }

        /// <summary>
        /// 保健品
        /// </summary>
        public void DealWithGoodAndPopulation()
        {
            List<string> goodsList = new List<string>();
            List<string> populationList = new List<string>();
            try
            {
                string popSql = "SELECT populationName FROM Population";
                DataTable dtpop = DBHelper.ExecuteWithReset(popSql, conn);

                for (int i = 0; i < dtpop.Rows.Count; i++)
                {
                    populationList.Add(dtpop.Rows[i]["populationName"].ToString());
                }

                string sql = "SELECT name,tabooPopulation,approveNumber,indicationPopulation,type,url FROM HealthProductInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string tabooPopulation = dt.Rows[i]["tabooPopulation"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string indicationPopulation = dt.Rows[i]["indicationPopulation"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in populationList)
                    {
                        if (tabooPopulation.Contains(s)) //属于禁忌人群
                        {
                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','" + approveNumber + "','" + type + "','" + url + "','来源于禁忌人群')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (indicationPopulation.Contains(s)) //属于适宜人群
                        {
                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }
        /// <summary>
        /// 中西药
        /// </summary>
        public void DealWithGoodAndPopulation_ZhongXiYao()
        {
            List<string> goodsList = new List<string>();
            List<string> populationList = getPopulationList();
            try
            {
                //string popSql = "SELECT populationName FROM Population";
                //DataTable dtpop = DBHelper.ExecuteWithReset(popSql, conn);

                //for (int i = 0; i < dtpop.Rows.Count; i++)
                //{
                //    populationList.Add(dtpop.Rows[i]["populationName"].ToString());
                //}

                string sql = "SELECT name,approveNumber,specialPopulation,tabooPopulation,indicationPopulation,type,url FROM MedicineInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string specialPopulation = dt.Rows[i]["specialPopulation"].ToString();
                    string tabooPopulation = dt.Rows[i]["tabooPopulation"].ToString();
                    string indicationPopulation = dt.Rows[i]["indicationPopulation"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in populationList)
                    {
                        if (tabooPopulation.Contains(s)) //属于禁忌人群
                        {
                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','" + approveNumber + "','" + type + "','" + url + "','来源于禁忌人群')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (indicationPopulation.Contains(s)) //属于适宜人群
                        {
                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else
                        {
                            if (specialPopulation != null && specialPopulation.Trim() != "")
                            {
                                if (getIsOrNot(specialPopulation)!=null) //禁忌
                                {
                                    if (specialPopulation.Contains(s))
                                    {
                                        string tabooDesc = getIsOrNot(specialPopulation);
                                        sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','" + approveNumber + "','" + type + "','" + url + "','" + tabooDesc + "')";
                                        int result = DBHelper.ExecuteNoResult(sql, conn);
                                    }
                                }
                                else
                                {
                                    var specialPops = specialPopulation.Split('。');
                                    foreach (var ss in specialPops)
                                    {
                                        if (ss.Contains(s))
                                        {
                                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','" + ss + "','" + approveNumber + "','" + type + "','" + url + "')";
                                            int result = DBHelper.ExecuteNoResult(sql, conn);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch
            {

            }
        }

        /// <summary>
        /// 中药材
        /// </summary>
        public void DealWithGoodAndPopulation_ZhongYaoCai()
        {
            List<string> goodsList = new List<string>();
            List<string> populationList = getPopulationList();
            try
            {
                //string popSql = "SELECT populationName FROM Population";
                //DataTable dtpop = DBHelper.ExecuteWithReset(popSql, conn);

                //for (int i = 0; i < dtpop.Rows.Count; i++)
                //{
                //    populationList.Add(dtpop.Rows[i]["populationName"].ToString());
                //}

                string sql = "SELECT name,indicationAndTaboo,type,url FROM ChineseMedicineMaterialInstruction  where indicationAndTaboo!=''";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string indicationAndTaboo = dt.Rows[i]["indicationAndTaboo"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();
                   
                    foreach (string s in populationList)
                    {
                        var pops = indicationAndTaboo.Split('。');
                        foreach (var p in pops)
                        {
                            if (p.Contains(s)) //包含
                            {
                                if (getIsOrNot(p)!=null) //忌
                                {
                                    string tabooDesc = getIsOrNot(p);
                                    sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','','" + type + "','" + url + "','" + tabooDesc + "')";
                                    int result = DBHelper.ExecuteNoResult(sql, conn);
                                }
                            }
                        }
                    }
                }
            }
            catch
            {

            }
        }
        /// <summary>
        ///没有说明书的药品
        /// </summary>
        public void DealWithGoodAndPopulation_NonInstruction()
        {
            List<string> goodsList = new List<string>();
            List<string> populationList = getPopulationList();
            try
            {
                string sql = "SELECT medicineName,approveNumber,population,taboo,type,url FROM MedicineNonInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["medicineName"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string population = dt.Rows[i]["population"].ToString();
                    string taboo = dt.Rows[i]["taboo"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in populationList)
                    {
                        if (taboo.Contains(s)) //属于禁忌人群
                        {
                            sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','" + approveNumber + "','" + type + "','" + url + "','来源于禁忌人群')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }

                        if (population != null && population.Trim() != "") //population中含有禁忌、适应、（不）建议人群
                        {
                            //第一步：分词；第二步：替换个别词（孕妇及哺乳期妇女用药、儿童用药、孕妇用药）
                            var pops = population.Split('。');

                            for (int pi = 0; pi < pops.Count(); pi++)
                            {
                                pops[pi] = pops[pi].Replace("孕妇及哺乳期妇女用药", "").Replace("儿童用药", "").Replace("孕妇用药", "");

                                if (getIsOrNot(pops[pi])!=null)
                                {
                                    if (pops[pi].Contains(s))
                                    {
                                        string tabooDesc = getIsOrNot(pops[pi]);
                                        sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url,tabooDesc) values('" + name + "','" + s + "','taboo','" + approveNumber + "','" + type + "','" + url + "','" + tabooDesc + "')";
                                        int result = DBHelper.ExecuteNoResult(sql, conn);
                                    }
                                }
                                else
                                {
                                    if (pops[pi].Contains(s))
                                    {
                                        sql = "insert into GoodPopulation(goodName,populationName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','" + pops[pi] + "','" + approveNumber + "','" + type + "','" + url + "')";
                                        int result = DBHelper.ExecuteNoResult(sql, conn);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch
            {

            }
        }

        string getIsOrNot(string s)
        { 
            List<string> tabooList = new List<string>()
            {
                "禁止长期、大面积或大量使用",
                "不能长期、大面积或大量使用",
                "不宜服用或遵医嘱",
                "忌贴腰部和腹部",
                "老年患者需减量服用",
                "严禁大面积使用",
                "禁止长期用",
                "禁内服",
                "禁止用于",
                "不宜应用",
                "不宜使用",
                "不宜服用",
                "不适用",
                "不推荐",
                "禁止",
                "不宜",
                "忌用",
                "禁用",
                "慎用",
                "慎服",
                "谨慎",
                "禁服",
                "忌服"
            };

            foreach(string t in tabooList)
            {
                if (s.Contains(t))
                {
                    return t;
                }
            }

            //if (s.Contains("禁用") || s.Contains("忌") || s.Contains("慎") || s.Contains("不宜") || s.Contains("勿") || s.Contains("不可")) //禁忌
            //{
            //    return true;
            //}
            return null;
        }
    }
}
