﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;
using Excel = Microsoft.Office.Interop.Excel;
using System.Data.SqlClient;
using System.Data;
using System.Reflection;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class ImportDao
    {
        static SqlConnection conn = DBHelper.getConnection();

        public void importYFMedicine()
        {
            string[] lines = System.IO.File.ReadAllLines(@"D:\YFMedicine.csv", Encoding.Default);
            for (int i = 0; i < lines.Length; i++)
            {
                String[] values = lines[i].Split(new string[] { "," }, StringSplitOptions.RemoveEmptyEntries);
                if (values.Length == 2)
                {
                    string sql = "insert into YFMedicine(medicineName,approveNumber) values('" + values[0] + "','" + values[1] + "')";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else
                {
                    string sql = "insert into YFMedicine(medicineName) values('" + values[0] + "')";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
        }

        public void handleYFMedicine()
        {
            string sql = "select medicinename from yfmedicine where medicineName not in (select name from MedicineInstruction) and medicineName not in (select medicinename from MedicineNonInstruction) and (medicinename like '%(%)%' or medicinename like '%（%）%') group by medicinename";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String temp = dt.Rows[i][0].ToString().Trim();
                int preIndex = temp.IndexOf("(");
                int tailIndex = temp.IndexOf(")");
                String word = "";
                if (preIndex != -1)
                {
                    word = temp.Substring(0, preIndex);
                    word += temp.Substring(tailIndex + 1);
                } 
                preIndex = temp.IndexOf("（");
                tailIndex = temp.IndexOf("）");
                if (preIndex != -1)
                {
                    word = temp.Substring(0, preIndex);
                    word += temp.Substring(tailIndex + 1);
                }
                sql = "update yfmedicine set medicinename='" + word + "' where medicinename='" + temp + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public void handleYFMedicine2()
        {
            string sql = "select medicinename from yfmedicine where medicineName not in (select name from MedicineInstruction) and medicineName not in (select medicinename from MedicineNonInstruction) group by medicinename";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            sql = "select name from MedicineInstruction";
            DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
            sql = "select medicinename from MedicineNonInstruction";
            DataTable dt3 = DBHelper.ExecuteWithReset(sql, conn);
            float[] similarity = new float[dt2.Rows.Count + dt3.Rows.Count];
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String temp = dt.Rows[i][0].ToString();
                int k = 0;
                for (int j = 0; j < dt2.Rows.Count; j++)
                {
                    String temp2 = dt2.Rows[j][0].ToString();
                    similarity[k] = Common.StringHelper.stringSimilarity(temp, temp2);
                    k++;
                }
                for (int j = 0; j < dt3.Rows.Count; j++)
                {
                    String temp3 = dt3.Rows[j][0].ToString();
                    similarity[k] = Common.StringHelper.stringSimilarity(temp, temp3);
                    k++;
                }
                int maxSimilarity = 0;
                for (int j = 1; j < similarity.Length; j++)
                {
                    if (similarity[maxSimilarity] < similarity[j])
                    {
                        maxSimilarity = j;
                    }
                }
                if (similarity[maxSimilarity] > 0.6)
                {
                    string replaceName = "";
                    if (maxSimilarity > dt2.Rows.Count)
                    {
                        replaceName = dt3.Rows[maxSimilarity - dt2.Rows.Count][0].ToString();
                    }
                    else
                    {
                        replaceName = dt2.Rows[maxSimilarity][0].ToString();
                    }
                    sql = "update yfmedicine set replacename='" + replaceName + "' where medicinename='" + temp + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
        }

        public void importDisease()
        {
            string[] disease = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\结果\disease2.txt", Encoding.Default);
            string[] level = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\结果\level.txt", Encoding.Default);
            for (int i = 0; i < disease.Length; i++)
            {
                string sql = "insert into disease(diseaseName,nameLevel) values('" + disease[i] + "'," + level[i] + ")";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public void importDiseaseContext()
        {
            string[] disease = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\结果\disease2.txt", Encoding.Default);
            for (int i = 0; i < disease.Length; i++)
            {
                if (System.IO.File.Exists(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\" + disease[i] + ".txt"))
                {
                    //string[] text = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\" + disease[i] + ".txt");
                    //string sql = "insert into baikedisease(diseaseName,url,text) values('" + disease[i] + "','" + text[1] + "','" + text[2] + "')";
                    //int result = DBHelper.ExecuteNoResult(sql, conn);
                    string sql = "select diseasename from baikedisease where diseasename='" + disease[i] + "'";
                    DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                    if (dt.Rows.Count == 0)
                    {
                        string[] text = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\" + disease[i] + ".txt");
                        if (text[2].Length < 3500)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text) values('" + disease[i] + "','" + text[1] + "','" + text[2] + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 7000)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 10500)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 14000)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3,text4) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 17500)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3,text4,text5) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 21000)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3,text4,text5,text6) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 24500)
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3,text4,text5,text6,text7) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500, 3500) + "','" + text[2].Substring(21000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else
                        {
                            sql = "insert into baikedisease(diseaseName,url,text,text2,text3,text4,text5,text6,text7,text8) values('" + disease[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500, 3500) + "','" + text[2].Substring(21000, 3500) + "','" + text[2].Substring(24500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
        }

        public void importSymptomContext()
        {
            string[] symptom = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\结果\symptom0.txt", Encoding.Default);
            for (int i = 0; i < symptom.Length; i++)
            {
                if (System.IO.File.Exists(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\symptomdata\" + symptom[i] + ".txt"))
                {
                    string sql = "select symptomname from baikesymptom where symptomname='" + symptom[i] + "'";
                    DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                    if (dt.Rows.Count == 0)
                    {
                        string[] text = System.IO.File.ReadAllLines(@"D:\Big Data & Cloud Computing\项目\益丰大药房数据分析项目\临时\symptomdata\" + symptom[i] + ".txt");
                        if (text[2].Length < 3500)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text) values('" + symptom[i] + "','" + text[1] + "','" + text[2] + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 7000)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 10500)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 14000)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3,text4) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 17500)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3,text4,text5) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 21000)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3,text4,text5,text6) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if (text[2].Length < 24500)
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3,text4,text5,text6,text7) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500, 3500) + "','" + text[2].Substring(21000) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else
                        {
                            sql = "insert into baikesymptom(symptomName,url,text,text2,text3,text4,text5,text6,text7,text8) values('" + symptom[i] + "','" + text[1] + "','" + text[2].Substring(0, 3500) + "','" + text[2].Substring(3500, 3500) + "','" + text[2].Substring(7000, 3500) + "','" + text[2].Substring(10500, 3500) + "','" + text[2].Substring(14000, 3500) + "','" + text[2].Substring(17500, 3500) + "','" + text[2].Substring(21000, 3500) + "','" + text[2].Substring(24500) + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
        }
    }
}
