﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class MedicineInstrument
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        //public static String[] conjection = { "、", ",", "，", ".", "。", " ", "：", ":", "；", ";", "以及", "及", "/"
        //                                        , "和", "或", "与", "并", "合并","又","对","使用" ,"应","用于","在","要","引起"
        //                                       ,"产生","同","必须","可","服用","服","需","故","而","为","于","不能","且","但"};

        public static String[] conjection = { "、", ",", "，", ".", "。", " ", "：", ":", "；", ";", "以及", "及", "/"
                                                , "和", "或", "与", "并" };

        public static String[] adjective = { };

        public static String[] preposition = { "于", "在", "的" };

        public static String[] other = { "各种","各型","多种", "如", "等", "情况下", "大小", "形状","（1）","（2）"
                                           , "内科", "泌尿科", "皮肤科", "眼科"
                                           , "毫克", "毫升", "等味", " ", "本品", "苗医", "中医", "其他", "其它", "医院", "无改善"
                                           , "以下", "作用", "科", "由","因","该药物"
                                           ,"均有效","有效","见上述证候者","患者","者","加强","进行期","期间","此","某些","症见","病人"
                                           ,"所致","均有明显疗效","有明显疗效","有辅助保护功能","有保护功能","有","保护功能","保健功能"
                                           ,"药物","药","某些","也有一定疗效","也","亦","功效","功能","症状"," ","\"","调节","主"
                                           ,"病例","禁用","慎用","不推荐使用","不推荐","慎服","不宜应用","不宜服用","不宜使用","不应服用","不应使用"
                                           ,"不得服用","不得","不应","的安全性","尚不清楚","尚不明确","尚不健全"
                                           ,"不宜","忌用","尽量避免","禁","慎","忌","?","单位","为"};

        //public static string[] wanted = { "人", "者", "女", "儿", "老", "孕", "妇", "男" };

        public static string[] notWanted = { "化学名", "分子式", "分子量", "结构", "-"};

        /// <summary>
        /// 从临时表中获取成分并更新flag字段
        /// </summary>
        public void GetComponentFromLinshi()
        {
            try
            {
                List<string> componentList = new List<string>();
                string sql = "SELECT  distinct(component) FROM LinShiMedicineInstrument where component!='' and flag is null order by component desc";
                var  result = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < result.Rows.Count; i++)
                {
                    var sentente = result.Rows[i][0].ToString(); ;
                    if (ExpressionSplitWordHelper.expressionSplitWord(sentente) != null) //匹配上
                    {
                        //string updateSql = "update LinShiMedicineInstrument set flag='1' where component='" + sentente + "'";
                        //int uNum = DBHelper.ExecuteNoResult(updateSql, conn);
                        var dealedSentence = ExpressionSplitWordHelper.expressionSplitWord(sentente);
                        foreach (var s in dealedSentence)
                        {
                            String[] values = s.Split(conjection, StringSplitOptions.RemoveEmptyEntries); //使用连词分割，如，。 、
                            for (int j = 0; j < values.Length; j++)
                            {
                                int flag = 1;
                                for (int listI = 0; listI < notWanted.Count(); listI++)
                                {
                                    int index = values[j].IndexOf(notWanted[listI]);
                                    if (index != -1)
                                    {
                                        flag = 0;
                                        //values[j] = values[j].Substring(index + auxiliaryVerbPrepositionList[listI].Length);
                                        listI = 0;
                                        break;
                                    }
                                }

                                //String[] deleteValues = new String[] { };
                                //for (int k = 0; k < deleteValues.Length; k++)
                                //{
                                //    int index = values[j].IndexOf(deleteValues[k]);
                                //    if (index >= 0)
                                //    {
                                //        flag = 0;
                                //        break;
                                //    }
                                //}
                                if (flag == 1)
                                {
                                    String value = values[j];
                                    value = value.Trim();
                                    value = Common.SemanticHelper.DealWithCPSymobol(value, "【", "】");
                                    value = Common.SemanticHelper.DealWithCPSymobol(value, "[", "]");
                                    value = Common.SemanticHelper.DealWithCPSymobol(value, "（", "）");
                                    value = Common.SemanticHelper.DealWithCPSymobol(value, "(", ")");
                                    for (int k = 0; k < other.Length; k++) //删除其他
                                    {
                                        value = value.Replace(other[k], "");
                                    }
                                    //String[] firstReplace = { "1", "—", "】" };
                                    //for (int k = 0; k < firstReplace.Length; k++)
                                    //{
                                    //    value = value.Replace(firstReplace[k], "");
                                    //}

                                    int chineseFlag = 0;
                                    for (int k = 0; k < value.Length; k++)
                                    {
                                        if (Convert.ToInt32(Convert.ToChar(values[j].Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                                        {
                                            chineseFlag = 1;
                                            break;
                                        }
                                    }
                                    if (value.Length > 1 && chineseFlag==1)
                                    {
                                        string insertSql = "insert into LinShiComponent(component) values('" + value + "')";
                                        int aa = DBHelper.ExecuteNoResult(insertSql, conn);
                                        //string sqlInsert = "insert into LinShiPopulation(population) values('" + value.Trim() + "')";
                                        //int result = DBHelper.ExecuteNoResult(sqlInsert, conn);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
    }
}
