﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class MedicineSymptom
    {
        static SqlConnection conn = DBHelper.getConnection();

        public List<string> getSymptomList()
        {
            List<string> symptomList = new List<string>();
            try
            {
                string popSql = "SELECT distinct(symptomName) FROM Symptom";
                DataTable dtpop = DBHelper.ExecuteWithReset(popSql, conn);

                for (int i = 0; i < dtpop.Rows.Count; i++)
                {
                    symptomList.Add(dtpop.Rows[i]["symptomName"].ToString());
                }
                return symptomList;
            }
            catch
            {
                return null;
            }
        }

        /// <summary>
        /// 医疗器械
        /// </summary>
        public void DealWithGoodAndPopulation_YiLiaoQiXie()
        {
            List<string> goodsList = new List<string>();
            List<string> symptomList = getSymptomList();
            try
            {
                string sql = " SELECT name,approveNumber,adaption,type,url FROM MedicalInstrumentInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string adaption = dt.Rows[i]["adaption"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in symptomList)
                    {
                        if (adaption.Contains(s.Trim())) //适应症
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }
        /// <summary>
        /// 中西药
        /// </summary>
        public void DealWithGoodAndPopulation_ZhongXiYao()
        {
            List<string> goodsList = new List<string>();
            List<string> symptomList = getSymptomList();
            try
            {
                string sql = "select name,mainFunction,indication,taboo,approveNumber,type,url from MedicineInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string mainFunction = dt.Rows[i]["mainFunction"].ToString();
                    string indication = dt.Rows[i]["indication"].ToString();
                    string taboo = dt.Rows[i]["taboo"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in symptomList)
                    {
                        if (mainFunction.Contains(s.Trim()) || indication.Contains(s.Trim()))
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        if (taboo.Contains(s.Trim()))
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','taboo','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }

        /// <summary>
        /// 保健品
        /// </summary>
        public void DealWithGoodAndPopulation_BaoJianPin()
        {
            List<string> goodsList = new List<string>();
            List<string> symptomList = getSymptomList();
            try
            {
                string sql = "SELECT name,healthFunction,approveNumber,type,url FROM HealthProductInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string healthFunction = dt.Rows[i]["healthFunction"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in symptomList)
                    {
                        if (healthFunction.Contains(s.Trim()))
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }

        /// <summary>
        /// 中药材
        /// </summary>
        public void DealWithGoodAndPopulation_ZhongYaoCai()
        {
            List<string> goodsList = new List<string>();
            List<string> symptomList = getSymptomList();
            try
            {
                string sql = "SELECT name,mainFunction,clinicalApplication,type,url FROM ChineseMedicineMaterialInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string mainFunction = dt.Rows[i]["mainFunction"].ToString();
                    string clinicalApplication = dt.Rows[i]["clinicalApplication"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in symptomList)
                    {
                        if (mainFunction.Contains(s.Trim()) || clinicalApplication.Contains(s.Trim())) //包含
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','indication','','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }
        /// <summary>
        /// 没有说明书
        /// </summary>
        public void DealWithGoodAndPopulation_NonInstruction()
        {
            List<string> goodsList = new List<string>();
            List<string> symptomList = getSymptomList();
            try
            {
                string sql = "SELECT medicineName,approveNumber,type,indication,taboo,url FROM MedicineNonInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["medicineName"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string indication = dt.Rows[i]["indication"].ToString();
                    string taboo = dt.Rows[i]["taboo"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in symptomList)
                    {
                        if (indication.Contains(s.Trim())) 
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','indication','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        if (taboo.Contains(s.Trim())) 
                        {
                            sql = "insert into GoodSymptom(goodName,symptomName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s.Trim() + "','taboo','" + approveNumber + "','" + type + "','" + url + "')";
                            int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {

            }
        }

        bool getIsOrNot(string s)
        {
            if (s.Contains("禁") || s.Contains("忌") || s.Contains("慎") || s.Contains("不宜") || s.Contains("勿") || s.Contains("不可")) //禁忌
            {
                return true;
            }
            return false;
        }

        public List<string> getSymptomAndDisease()
        {
            List<string> list = new List<string>();
            try
            {
                string sql = "SELECT symptomAndDiseaseName,symptomOrDisease From symptomAndDisease";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    list.Add(dt.Rows[i][0].ToString() + "@@" + dt.Rows[i][1].ToString());
                }
            }
            catch
            {

            }
            return list;
        }

        public int countSymptomAndDisease(List<string> list)
        {
            //--insert into SymptomAndDisease(symptomAndDiseaseName) select symptomname from Symptom where symptomname not in (select diseasename from disease) group by symptomname
            //--update SymptomAndDisease set symptomOrDisease='symptom' where symptomOrDisease is null
            //--insert into SymptomAndDisease(symptomAndDiseaseName) select diseasename from Disease group by diseaseName
            //--update SymptomAndDisease set symptomOrDisease='disease' where symptomOrDisease is null
            //--update SymptomAndDisease set isDetail=1 where SymptomAndDiseasename in (select symptomname from baikesymptom)
            //--update SymptomAndDisease set isDetail=1 where SymptomAndDiseasename in (select diseasename from BaiKeDisease)
            //--update SymptomAndDisease set isDetail=0 where isdetail is null
            int count = 0;
            string sql = "";
            try
            {
                for(int i=0;i<list.Count;i++)
                {
                    String[] value = list[i].ToString().Split(new string[] { "@@" }, StringSplitOptions.RemoveEmptyEntries);
                    if (value[1].Equals("symptom") == true)
                    {
                        sql = "SELECT count(1) From goodSymptom where symptomname='" + value[0] + "' and indicationOrTaboo='indication'";
                        DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                        count = Convert.ToInt32(dt.Rows[0][0].ToString());
                    }
                    else
                    {
                        sql = "SELECT count(1) From goodDisease where diseasename='" + value[0] + "' and indicationOrTaboo='indication'";
                        DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                        count = Convert.ToInt32(dt.Rows[0][0].ToString());
                    }
                    sql = "update symptomAndDisease set countInMedicine=" + count + " where symptomAndDiseaseName='" + value[0] + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
            return count;
        }

        public int countSymptomAndDiseaseFromYFMedicine(List<string> list)
        {
            //--insert into SymptomAndDisease(symptomAndDiseaseName) select symptomname from Symptom where symptomname not in (select diseasename from disease) group by symptomname
            //--update SymptomAndDisease set symptomOrDisease='symptom' where symptomOrDisease is null
            //--insert into SymptomAndDisease(symptomAndDiseaseName) select diseasename from Disease group by diseaseName
            //--update SymptomAndDisease set symptomOrDisease='disease' where symptomOrDisease is null
            //--update SymptomAndDisease set isDetail=1 where SymptomAndDiseasename in (select symptomname from baikesymptom)
            //--update SymptomAndDisease set isDetail=1 where SymptomAndDiseasename in (select diseasename from BaiKeDisease)
            //--update SymptomAndDisease set isDetail=0 where isdetail is null
            int count = 0;
            string sql = "";
            try
            {
                for (int i = 0; i < list.Count; i++)
                {
                    String[] value = list[i].ToString().Split(new string[] { "@@" }, StringSplitOptions.RemoveEmptyEntries);
                    if (value[1].Equals("symptom") == true)
                    {
                        sql = "SELECT count(1) From goodSymptom where symptomname='" + value[0] + "' and indicationOrTaboo='indication' and goodName in (select replaceName from YFMedicine)";
                        DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                        count = Convert.ToInt32(dt.Rows[0][0].ToString());
                    }
                    else
                    {
                        sql = "SELECT count(1) From goodDisease where diseasename='" + value[0] + "' and indicationOrTaboo='indication' and goodName in (select replaceName from YFMedicine)";
                        DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                        count = Convert.ToInt32(dt.Rows[0][0].ToString());
                    }
                    sql = "update symptomAndDisease set countInYFMedicine=" + count + " where symptomAndDiseaseName='" + value[0] + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch
            {

            }
            return count;
        }
    }
}
