﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    /// <summary>
    /// 症状DAO
    /// </summary>
    public class Symptom
    {
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 获取症状列表
        /// </summary>
        /// <returns></returns>
        public List<String> getSymptomList_NonInstruction()
        {
            List<String> symptomList = new List<string>();
            try
            {
                string sql = "select indication from LinShiMedicineNonInstruction where FLag is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    symptomList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return symptomList;
        }

        /// <summary>
        /// 获取症状列表
        /// </summary>
        /// <returns></returns>
        public List<String> getSymptomList()
        {
            List<String> symptomList = new List<string>();
            try
            {
                string sql = "SELECT distinct(mainFunction) FROM ChineseMedicineMaterialInstruction where mainFunction is not null and mainFunction !=''";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    symptomList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return symptomList;
        }
        /// <summary>
        /// 从临时表中导入Analysis表
        /// </summary>
        public void SavaSymptomFromLinShi()
        {
            try
            {
                string sql = "SELECT symptom FROM LinShiSymptomSemantics  where symptom!='' group by symptom";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    var symptom = dt.Rows[i][0].ToString();
                    string sqlInsrt = "insert into Analysis(text,name) values('" + symptom + "','symptom')";
                    int result = DBHelper.ExecuteNoResult(sqlInsrt, conn);
                }
            }
            catch
            {

            }
           
        }

        internal void InsertSymptom(string symptom)
        {
            try
            {
                string sql = "insert into LinShiSymptomSemantics(symptom) values('" + symptom + "')";
                //string sql = "insert into Analysis(text,name) values('" + symptom + "','symptom')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {

            }
        }

        public List<string> getDisease()
        {
            List<String> diseaseList = new List<string>();
            try
            {
                string sql = "select symptomAndDiseaseName from symptomAndDisease where isDetail=0 and symptomOrDisease='disease' order by countInMedicine desc";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    diseaseList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return diseaseList;
        }

        public List<string> getSymptom()
        {
            List<String> symptomList = new List<string>();
            try
            {
                string sql = "select symptomAndDiseaseName from symptomAndDisease where isDetail=0 and symptomOrDisease='symptom' order by countInMedicine desc";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    symptomList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return symptomList;
        }

        public void insertBaikeDiseaseUrl(string diseaseName,string url)
        {
            try
            {
                string sql = "insert into baikedisease(diseaseName,url) values('" + diseaseName + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {

            }
        }

        public void insertBaikeSymptomUrl(string symptomName, string url)
        {
            try
            {
                string sql = "insert into baikesymptom(symptomName,url) values('" + symptomName + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {

            }
        }

        public List<string> getDiseaseUrl()
        {
            List<string> urlList = new List<string>();
            try
            {
                string sql = "select url from baikedisease --where text is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }

        public List<string> getSymptomUrl()
        {
            List<string> urlList = new List<string>();
            try
            {
                string sql = "select url from baikesymptom where url not in (select url from baikesymptomdetail) --where text is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }

        public void updateBaikeDisease(string text,string url)
        {
            try
            {
                if (text.Length < 4000)
                {
                    string sql = "update baikedisease set text='" + text + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 8000)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 12500)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 16000)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 20000)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 24000)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000,4000) + "',text6='" + text.Substring(20000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 28000)
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000, 4000) + "',text6='" + text.Substring(20000, 4000) + "',text7='" + text.Substring(24000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else
                {
                    string sql = "update baikedisease set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000, 4000) + "',text6='" + text.Substring(20000, 4000) + "',text7='" + text.Substring(24000, 4000) + "',text8='" + text.Substring(28000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch (Exception ex)
            {

            }
        }

        public void insertBaikeDiseaseDetail(string name, string title, string text, string url)
        {
            try
            {
                string sql = "insert into baikediseasedetail(diseasename,title,text,url) values('" + name + "','" + title + "','" + text + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {

            }
        }

        public void insertBaikeSymptomDetail(string name, string title, string text, string url)
        {
            try
            {
                string sql = "insert into baikesymptomdetail(symptomname,title,text,url) values('" + name + "','" + title + "','" + text + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {

            }
        }

        public void updateBaikeSymptom(string text, string url)
        {
            try
            {
                if (text.Length < 4000)
                {
                    string sql = "update baikeSymptom set text='" + text + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 8000)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 12500)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 16000)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 20000)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 24000)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000, 4000) + "',text6='" + text.Substring(20000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else if (text.Length < 28000)
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000, 4000) + "',text6='" + text.Substring(20000, 4000) + "',text7='" + text.Substring(24000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
                else
                {
                    string sql = "update baikeSymptom set text='" + text.Substring(0, 4000) + "', text2='" + text.Substring(4000, 4000) + "', text3='" + text.Substring(8000, 4000) + "',text4='" + text.Substring(12000, 4000) + "',text5='" + text.Substring(16000, 4000) + "',text6='" + text.Substring(20000, 4000) + "',text7='" + text.Substring(24000, 4000) + "',text8='" + text.Substring(28000) + "'  where url='" + url + "'";
                    int result = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
            catch (Exception ex)
            {

            }
        }
    }
}
