﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    /// <summary>
    /// 39健康网药品通
    /// </summary>
    public class YaoPinTong
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 插入疾病的地址
        /// </summary>
        /// <param name="url">疾病的地址</param>
        public void InsertYaoPinShuoMingUrl(string name, string url,string type="中西药")
        {
            try
            {
                string sql = "insert into YaoPinTongJianKang(name,url,type) values('" + name + "','" + url + "','" + type + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        public void UpdateShuoMingShuByUrl(string shuoming, string url)
        {
            try
            {
                string sql = "update YaoPinTongJianKang set shuoming='" + shuoming + "' where url='" + url + "'";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        private string cutStr(string s)
        {
            if (s.Length > 4000)
                return s.Substring(0, 4000);
            return s;
        }
        /// <summary>
        /// 从数据库中读取url
        /// </summary>
        /// <returns></returns>
        public List<String> getUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from YaoPinTongJianKang where LEN(url)>0 and shuoming is null and  TYPE='医疗器械'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
        /// <summary>
        /// 获取中西药分类并存入临时表中
        /// </summary>
        /// <param name="fenleiUrl"></param>
        /// <param name="totalPage"></param>
        /// <param name="totalCount"></param>
        public void insertLinShiZhongXiYao(string fenleiUrl, int totalPage, int totalCount)
        {
            try
            {
                string sql = "insert into LinShiZhongXiYao(url,totalPage,totalCount) values('" + fenleiUrl + "','" + totalPage + "','" + totalCount + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        /// <summary>
        /// 获取中药材分类并存入临时表中
        /// </summary>
        /// <param name="fenleiUrl"></param>
        /// <param name="totalPage"></param>
        /// <param name="totalCount"></param>
        public void insertLinShiZhongYaoCai(string fenleiUrl, int totalPage, int totalCount)
        {
            try
            {
                string sql = "insert into LinShiZhongYaoCai(url,totalPage,totalCount) values('" + fenleiUrl + "','" + totalPage + "','" + totalCount + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }
        /// <summary>
        /// 从临时数据库中读取url和总页数
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, int> getUrlFromLinShiZhongYaoCai()
        {
            Dictionary<string, int> dic = new Dictionary<string, int>();
            try
            {
                string sql = "select url,totalPage from LinShiZhongYaoCai";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    dic.Add(dt.Rows[i][0].ToString(), Convert.ToInt32(dt.Rows[i][1].ToString()));
                }
            }
            catch
            {

            }
            return dic;
        }

        /// <summary>
        /// 从临时数据库中读取url和总页数
        /// </summary>
        /// <returns></returns>
        public Dictionary<string, int> getUrlFromLinShiZhongXiYao()
        {
            Dictionary<string, int> dic = new Dictionary<string, int>();
            try
            {
                string sql = "select url,totalPage from LinShiZhongXiYao";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    dic.Add(dt.Rows[i][0].ToString(), Convert.ToInt32(dt.Rows[i][1].ToString()));
                }
            }
            catch
            {

            }
            return dic;
        }

        public DataTable getContent()
        {
            DataTable dt = null;
            try
            {
                string sql = "select name,shuoming,type,url from YaoPinTongJianKang";
                dt = DBHelper.ExecuteWithReset(sql, conn);
            }
            catch
            {

            }
            return dt;
        }

        public void insertDetail(String name,String title,String text,String type,String url)
        {
            try
            {
                string sql = "insert into yaopintongdetail(name,title,text,type,url) values('" + name + "','" + title + "','" + text + "','" + type + "','" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }

        public DataTable getDetail(String type)
        {
            DataTable dt = null;
            try
            {
                if (type.Equals("医疗器械") == true)
                {
                    string sql = "select name,shuoming,type,url from YaoPinTongJianKang where type='" + type + "'";
                    dt = DBHelper.ExecuteWithReset(sql, conn);
                }
                else
                {
                    string sql = "select name,title,text,type,url from yaopintongdetail where type='" + type + "' and title not like '%有售%'";
                    dt = DBHelper.ExecuteWithReset(sql, conn);
                }
            }
            catch
            {

            }
            return dt;
        }

        public bool isExist(String tableName,String url)
        {
            bool rs = true;
            try
            {
                String sql = "select count(1) from " + tableName + " where url='" + url + "'";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                if (dt.Rows[0][0].ToString().Equals("0") == true)
                {
                    rs = false;
                }
            }
            catch
            {

            }
            return rs;
        }

        public void saveInstruction(String sql)
        {
            try
            {
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
    }
}
