﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    public class ZhongGuoJianKangWang
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 插入疾病的地址
        /// </summary>
        /// <param name="url">疾病的地址</param>
        public void InsertJiBingUrl(string url)
        {
            try
            {
                string sql = "insert into ZhongGuoJianKangWang(url) values('" + url + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.Write(ex.Message);
            }
        }

        public void UpdateJiBingAttributeByUrl(string url, ZhongGuoJianKangWangModel model)
        {
            string sql = "update ZhongGuoJianKangWang set name='" + cutStr(model.Name) + "',alias='" + cutStr(model.Alias) + "',position='" + cutStr(model.Position) +
                "',office='" + cutStr(model.Office) + "',symptom='" + cutStr(model.Symptom) + "',basicDescribe='" + cutStr(model.BasicDescribe) +
                "',cause='" + cutStr(model.Cause) + "',symptomsSigns='" + cutStr(model.SymptomsSigns) + "',inspectionTesting='" + cutStr(model.InspectionTesting) + "',diagnosis='" + cutStr(model.Diagnosis) +
                "',complication='" + cutStr(model.Complication) + "',preventiveCare='" + cutStr(model.PreventiveCare) + "',treatment='" + cutStr(model.Treatment) + "'" +
                " where url='" + url + "'";
            try
            {
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        private string cutStr(string s)
        {
            if (s.Length > 4000)
                return s.Substring(0, 4000);
            return s;
        }
        /// <summary>
        /// 从数据库中读取url
        /// </summary>
        /// <returns></returns>
        public List<String> getUrl()
        {
            List<String> urlList = new List<string>();
            try
            {
                string sql = "select url from ZhongGuoJianKangWang where LEN(url)>0 and name is null";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    urlList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return urlList;
        }
        /// <summary>
        /// 从数据库中读取身体位置
        /// </summary>
        /// <returns></returns>
        public List<String> getValue(String tableName,String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        /// <summary>
        /// 从数据库中读取身体位置
        /// </summary>
        /// <returns></returns>
        public List<String> getValue(String tableName, String valueName, List<String> list)
        {
            List<String> valueList = list;
            try
            {
                string sql = "select " + valueName + " from " + tableName + " where LEN(" + valueName + ")>0";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        /// <summary>
        /// 插入身体位置词条
        /// </summary>
        /// <returns></returns>
        public void insertValue(String valueName,String text)
        {
            try
            {
                string sql = "insert into analysis(text,name) values('" + text + "','" + valueName + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
        /// <summary>
        /// 从数据库中读取不重复身体位置
        /// </summary>
        /// <returns></returns>
        public List<String> getValueGroup(String valueName)
        {
            List<String> valueList = new List<string>();
            try
            {
                string sql = "select text from analysis where name='" + valueName + "' group by text";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    valueList.Add(dt.Rows[i][0].ToString());
                }
            }
            catch
            {

            }
            return valueList;
        }
        /// <summary>
        /// 插入不重复身体位置词条
        /// </summary>
        /// <returns></returns>
        public void insertValueGroup(String tableName,String valueName,String text)
        {
            try
            {
                string sql = "insert into " + tableName + "(" + valueName + ") values('" + text + "')";
                int result = DBHelper.ExecuteNoResult(sql, conn);
            }
            catch
            {

            }
        }
    }
}
