﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Dao
{
    /// <summary>
    /// 商品与疾病关联
    /// </summary>
    public class good_disease
    {
        static SqlConnection conn = DBHelper.getConnection();

        /// <summary>
        /// 获取疾病
        /// </summary>
        /// <returns></returns>
        public List<string> getdisease() 
        {
            List<string> diseaseList = new List<string>();
            try
            {
                string disSql = "select diseaseName from Disease";
                DataTable distable = DBHelper.ExecuteWithReset(disSql, conn);

                for (int i = 0; i < distable.Rows.Count; i++)
                {
                    diseaseList.Add(distable.Rows[i]["diseaseName"].ToString());
                }
                return diseaseList;
            }

            catch
            {
                return null;
            }

        }

        /// <summary>
        /// 中药
        /// </summary>
        public void chineseMedicine()
        {

            List<string> diseaseList = getdisease();
            try
            {
                string CMSql = "SELECT name,mainFunction,indicationAndTaboo,clinicalApplication,type,url FROM ChineseMedicineMaterialInstruction";
                DataTable CMtable = DBHelper.ExecuteWithReset(CMSql, conn);

                for (int i = 0; i < CMtable.Rows.Count; i++)
                {
                    string name= CMtable.Rows[i]["name"].ToString();
                    string mainfunction = CMtable.Rows[i]["mainFunction"].ToString();
                    string indicationAndTaboo = CMtable.Rows[i]["indicationAndTaboo"].ToString();
                    string clinicalApplication = CMtable.Rows[i]["clinicalApplication"].ToString();
                    string type = CMtable.Rows[i]["type"].ToString();
                    string url = CMtable.Rows[i]["url"].ToString();
                
                foreach (string s in diseaseList)
                {
                    if(mainfunction.Contains(s) || clinicalApplication.Contains(s))
                    {
                        string sql = "insert into GoodDisease(goodName,diseaseName,indicationOrTaboo,type,url) values('"+name +"','"+s+"','indication','"+type+"','"+url+"')";
                        int result = DBHelper.ExecuteNoResult(sql, conn);
                    }
                    else 
                    {
                        var andtaboo = indicationAndTaboo.Split('。');
                        foreach(var p in andtaboo)
                        {
                            if(p.Contains(s))
                            {
                                if (getIsOrNot(p)) //忌
                                {
                                    string sql = "insert into GoodDisease(goodName,diseaseName,indicationOrTaboo,type,url) values('"+name +"','"+s+"','taboo','"+type+"','"+url+"')";
                                    int result = DBHelper.ExecuteNoResult(sql, conn);
                                }
                            }
                        }
                    }
                }

                }
            }

            catch
            {

            }
        }

        /// <summary>
        /// 判断是否为禁忌
        /// </summary>
        bool getIsOrNot(string s)
        {
            if (s.Contains("禁") || s.Contains("忌") || s.Contains("慎") || s.Contains("不宜") || s.Contains("勿") || s.Contains("不可")) //禁忌
            {
                return true;
            }
            return false;
        }

        /// <summary>
        /// 保健品
        /// </summary>
        public void healthProduct()
        {
            List<string> diseaseList = getdisease();

            try
            {
                string sql = "select name,approveNumber,healthFunction,attention,type,url from HealthProductInstruction";
                DataTable dt = DBHelper.ExecuteWithReset(sql, conn);

                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string name = dt.Rows[i]["name"].ToString();
                    string approveNumber = dt.Rows[i]["approveNumber"].ToString();
                    string healthFunction = dt.Rows[i]["healthFunction"].ToString();
                    string attention = dt.Rows[i]["attention"].ToString();
                    string type = dt.Rows[i]["type"].ToString();
                    string url = dt.Rows[i]["url"].ToString();

                    foreach (string s in diseaseList)
                    {
                        if (healthFunction.Contains(s))
                        {
                             sql = "insert into GoodDisease(goodName,diseaseName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','indication','"+approveNumber+"','" + type + "','" + url + "')";
                             int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                        else if(attention.Contains(s))
                        {
                             sql = "insert into GoodDisease(goodName,diseaseName,indicationOrTaboo,approveNumber,type,url) values('" + name + "','" + s + "','taboo','"+approveNumber+"','" + type + "','" + url + "')";
                             int result = DBHelper.ExecuteNoResult(sql, conn);
                        }
                    }
                }
            }
            catch
            {
 
            }
        }
    }
}
