﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class BaiKeSemantics
    {
        Dao.BaiKe dao = new Dao.BaiKe();

        public void saveBaiKeDetail()
        {
            DataTable dt = dao.getTextFromBaiKe();
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String text = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = text.Split(new string[] { "||||" }, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        int index = values[j].LastIndexOf("||");
                        String title = "";
                        if (index != -1)
                        {
                            title = values[j].Substring(0, index);
                            title = title.Replace("&nbsp;", "").Replace("||", "").Replace(" ", "");
                            String value = values[j].Substring(index+2);
                            dao.insertYaoPinDetail(title, value, yaopin);
                        }
                    }
                }
            }
        }

        public void saveYaoPinChengFen()
        {
            DataTable dt = dao.getYaoPinChengFenFromBaiKeDetail();
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "成分";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(new string[] { "、", ",", ".", " ", "，", "：", ":", "。", "及", "；", ";" }, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        int flag=0;
                        for (int k = 0; k < values[j].Length; k++)
                        {
                            if (Convert.ToInt32(Convert.ToChar(values[j].Substring(k, 1))) < Convert.ToInt32(Convert.ToChar(128)))
                            {
                                values[j] = values[j].Replace(values[j][k] + "", "@");
                            }
                        }
                        String[] deleteValues = { "成分", "成份", "组分", "组份", "本品", "为", "辅料", "-", "．", "分子", "的", "化学", "名称", "说明" };
                        for (int k = 0; k < deleteValues.Length; k++)
                        {
                            int index = values[j].IndexOf(deleteValues[k]);
                            if (index >= 0)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        if (flag == 0)
                        {
                            String value = values[j].Replace("每片含", "").Replace("每毫升含", "").Replace("每克含", "").Replace("毫克", "").Replace("毫升", "").Replace("等味", "").Replace("±", "").Replace("()", "").Replace("（）", "").Replace("@", "").Replace(" ", "");
                            if (value.Length > 1)
                            {
                                dao.insertYaoPinChengFen(subject, value, sentence, yaopin);
                            }
                        }
                    }
                }
            }
        }

        public void getComponentWord()
        {
            List<string> componentList = dao.getValue("YaoPinChengFen", "value");
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < componentList.Count; i++)
            {
                String[] values = componentList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    values[j] = values[j].Replace("【处方】", "");
                    int index1 = values[j].IndexOf("（");
                    int index2 = values[j].IndexOf("？");
                    if (index1 != 0 && index2 != 0)
                    {
                        dao.insertValue("component", values[j]);
                    }
                }
            }
            List<string> componentGroupList = dao.getValueGroup("component");
            for (int i = 0; i < componentGroupList.Count; i++)
            {
                dao.insertValueGroup("component", "componentName", componentGroupList[i].ToString());
            }
        }

        public void saveYaoPinShiYingZheng()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = dao.getYaoPinShiYingZhengFromBaiKeDetail();
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "适应症";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        for (int listI = 0; listI < auxiliaryVerbPrepositionList.Count; listI++)
                        {
                            int index = values[j].IndexOf(auxiliaryVerbPrepositionList[listI]);
                            if (index != -1)
                            {
                                values[j] = values[j].Substring(index + auxiliaryVerbPrepositionList[listI].Length);
                                listI = 0;
                            }
                        }
                        int flag = 0;
                        String[] deleteValues = new String[] { "但不", "不", "本品", "苗医", "中医", "一般", "其他", "医院", "无改善", "其他", "其它", "使用", "以下", "作用", "科" };
                        for (int k = 0; k < deleteValues.Length; k++)
                        {
                            int index = values[j].IndexOf(deleteValues[k]);
                            if (index >= 0)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        if (flag == 0)
                        {
                            String value = values[j];
                            for (int k = 0; k < Common.SemanticHelper.other.Length; k++)
                            {
                                value = value.Replace(Common.SemanticHelper.other[k], "");
                            }
                            String[] firstReplace = { "1", "—", "】" };
                            for (int k = 0; k < firstReplace.Length; k++)
                            {
                                value = value.Replace(firstReplace[k], "");
                            }
                            int chineseFlag = 0;
                            for (int k = 0; k < value.Length; k++)
                            {
                                if (Convert.ToInt32(Convert.ToChar(values[j].Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                                {
                                    chineseFlag = 1;
                                    break;
                                }
                            }
                            if (chineseFlag==1 && value.Length > 1)
                            {
                                dao.insertYaoPinShiYingZheng(subject, value, sentence, yaopin);
                            }
                        }
                    }
                }
            }
        }

        public void getSymptomWord()
        {
            List<string> symptomList = dao.getValue("YaoPinShiYingZheng", "value");
            String[] splitValues = new String[] { " ", "," };
            for (int i = 0; i < symptomList.Count; i++)
            {
                String[] values = symptomList[i].Split(splitValues, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    int index1 = values[j].IndexOf("（");
                    if (index1 != 0)
                    {
                        dao.insertValue("symptom", values[j]);
                    }
                }
            }
            List<string> symptomGroupList = dao.getValueGroup("symptom");
            for (int i = 0; i < symptomGroupList.Count; i++)
            {
                dao.insertValueGroup("symptom", "symptomName", symptomGroupList[i].ToString());
            }
        }

        public void getPopulation()
        {
            String whereStr = "where (name like '%儿%' or name like '%老%' or name like '%女%' or name like '%妇%' or name like '%孕%' or name like '%男%' or name like '%人%' or name like '%者%') and value not like '%不明确%' and value not like '%不清楚%' and value not like '%未确立%' and value not like '%缺乏%' group by name";
            List<string> populationList = dao.getValue("BaiKeDetail", "name", whereStr);
            for (int i = 0; i < populationList.Count; i++)
            {
                String[] values = populationList[i].Split(Common.SemanticHelper.conjection2, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < values.Length; j++)
                {
                    String value = values[j];
                    int flag = 0;
                    String[] deleteValues = { "执行", "科", "适应","用法","用量","有些" };
                    for (int k = 0; k < deleteValues.Length; k++)
                    {
                        int index = value.IndexOf(deleteValues[k]);
                        if (index != -1)
                        {
                            flag = 1;
                            break;
                        }
                    }
                    if(flag==1)
                    {
                        continue;
                    }
                    flag = 0;
                    String[] needValues = { "儿", "老", "女", "妇", "孕", "男", "人", "者" };
                    for (int k = 0; k < needValues.Length; k++)
                    {
                        int index = value.IndexOf(needValues[k]);
                        if (index!=-1)
                        {
                            flag = 1;
                            break;
                        }
                    }
                    if (flag == 1)
                    {
                        String[] other = new String[] { "慎用", "慎服", "禁用","用药", "禁服", "忌用", "忌服", "注意事项", "注意", "消化不良","减半","酌减","禁忌","本方", " " };
                        for (int k = 0; k < other.Length; k++)
                        {
                            value = value.Replace(other[k], "");
                        }
                        dao.insertValue("population", value);
                    }
                }
            }
        }
    }
}
