﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    /// <summary>
    /// 疾病的整合
    /// </summary>
    public class DiseaseIntegration
    {
        //获取数据库连接
        static SqlConnection conn = DBHelper.getConnection();

        #region 中国健康网——病和身体部位一对多
        /// <summary>
        /// 疾病 数据整合  疾病和身体
        /// </summary>
        public void Disease_Body()
        {
            try
            {
                string sql = "select name,position from ZhongGuoJianKangWang";
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string name = result.Rows[i]["name"].ToString();
                        var body = result.Rows[i]["position"];
                        if (body != null)
                        {
                            var positions = body.ToString().Split(',');
                            List<string> sqls = new List<string>();
                            foreach (var p in positions)
                            {
                                if (!string.IsNullOrEmpty(p.Trim()))
                                    sqls.Add("insert into Disease_Body(Disease,Body_Part) values('" + name + "','" + p + "')");
                            }
                            DBHelper.ExecuteTransaction(sqls, conn);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        #endregion

        #region 中国健康网——病和科室一对多
        /// <summary>
        /// 疾病 数据整合  疾病和科室
        /// </summary>
        public void Disease_Office()
        {
            try
            {
                string sql = "select name,office from ZhongGuoJianKangWang";
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string name = result.Rows[i]["name"].ToString();
                        var offices = result.Rows[i]["office"];
                        if (offices != null)
                        {
                            var ofs = offices.ToString().Split(',');
                            List<string> sqls = new List<string>();
                            foreach (var p in ofs)
                            {
                                if (!string.IsNullOrEmpty(p.Trim()))
                                    sqls.Add("insert into Disease_Office(Disease,Office) values('" + name + "','" + p + "')");
                            }
                            DBHelper.ExecuteTransaction(sqls, conn);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        #endregion

        #region 中国健康网——病和症状一对多
        /// <summary>
        /// 疾病 数据整合  疾病和病状
        /// </summary>
        public void Disease_Symptom()
        {
            try
            {
                string sql = "select name,symptom from ZhongGuoJianKangWang";
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string name = result.Rows[i]["name"].ToString();
                        var symptoms = result.Rows[i]["symptom"];
                        if (symptoms != null && !string.IsNullOrEmpty(symptoms.ToString().Trim()))
                        {
                            var syms = symptoms.ToString().Split(' ');
                            List<string> sqls = new List<string>();
                            foreach (var p in syms)
                            {
                                sqls.Add("insert into Disease_Symptom(Disease,Symptom) values('" + name + "','" + p + "')");
                            }
                            DBHelper.ExecuteTransaction(sqls, conn);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        #endregion

        #region 5120查疾病——病和宜吃一对多
        /// <summary>
        /// 5120查疾病  宜吃 忌吃
        /// </summary>
        public void Disease_Eat()
        {
            try
            {
                string sql = "select name,dietTyerapy from ChaJiBing";
                var result = DBHelper.ExecuteWithReset(sql, conn);
                if (result != null && result.Rows.Count >= 1)
                {
                    for (int i = 0; i < result.Rows.Count; i++)
                    {
                        string name = result.Rows[i]["name"].ToString();
                        var dietTyerapy = result.Rows[i]["dietTyerapy"].ToString();
                        if (dietTyerapy != null && !string.IsNullOrEmpty(dietTyerapy.ToString().Trim()))
                        { 
                           
                            int middle = dietTyerapy.IndexOf("忌吃食物列表||忌吃理由||");

                            var eat = dietTyerapy.Substring(0, middle).Split('@');
                            var noteat = dietTyerapy.Substring(middle).Split('@');

                            List<string> sqls1 = new List<string>();
                            List<string> sqls = new List<string>();
                            for (int eacount = 1; eacount < eat.Count(); eacount++)
                            {
                                if (!string.IsNullOrEmpty(eat[eacount].Trim()))
                                {
                                    string food = "";
                                    string reason = "";
                                    string advice = "";
                                    string[] sArr = eat[eacount].Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                                    if (sArr.Count() <= 1)
                                    {
                                        food = sArr[0].ToString();
                                    }
                                    else if (sArr.Count() == 2)
                                    {
                                        food = sArr[0].ToString();
                                        if (eat[eacount].ToString().Contains("||||"))
                                        {
                                            advice = sArr[1].ToString();
                                        }
                                        else
                                        {
                                            reason = sArr[1].ToString();
                                        }
                                    }
                                    else
                                    {
                                        food = sArr[0].ToString();
                                        reason = sArr[1].ToString();
                                        advice = sArr[2].ToString();
                                    }
                                    sqls.Add("insert into Disease_Eat(Disease,Eat_Food,Eat_Reason,Eat_Advice) values('" + name + "','" + food + "','" + reason + "','" + advice + "')");
                                }
                            }

                            for (int noteacount = 1; noteacount < noteat.Count(); noteacount++)
                            {
                                if (!string.IsNullOrEmpty(noteat[noteacount].Trim()))
                                {
                                    string food = "";
                                    string reason = "";
                                    string advice = "";
                                    string[] sArr = noteat[noteacount].Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                                    if (sArr.Count() <= 1)
                                    {
                                        food = sArr[0].ToString();
                                    }
                                    else if (sArr.Count() == 2)
                                    {
                                        food = sArr[0].ToString();
                                        if (noteat[noteacount].ToString().Contains("||||"))
                                        {
                                            advice = sArr[1].ToString();
                                        }
                                        else
                                        {
                                            reason = sArr[1].ToString();
                                        }
                                    }
                                    else
                                    {
                                        food = sArr[0].ToString();
                                        reason = sArr[1].ToString();
                                        advice = sArr[2].ToString();
                                    }
                                    sqls.Add("insert into Disease_NotEat(Disease,NotEat_Food,NotEat_Reason,NotEat_Advice)  values('" + name + "','" + food + "','" + reason + "','" + advice + "')");
                                }
                            }
                            DBHelper.ExecuteTransaction(sqls, conn);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        #endregion

        #region 整合5120查疾病和中国健康网疾病数据
        /// <summary>
        /// 整合5120查疾病和中国健康网疾病数据
        /// </summary>
        public void IntegrationDisease()
        {
            try
            {
                //第一步，把5120查疾病的数据复制到新表中
                string sqlGetData = "select name,summary,cause,prevention,complication,identify,symptom,inspection,treatment,dietHealth from ChaJiBing";
                var dataResult = DBHelper.ExecuteWithReset(sqlGetData, conn);
                List<string> sqls = new List<string>();
                for (int i = 0; i < dataResult.Rows.Count; i++)
                {
                    string name = dataResult.Rows[i]["name"].ToString();
                    string summary = dataResult.Rows[i]["summary"].ToString();
                    string cause = dataResult.Rows[i]["cause"].ToString();
                    string prevention = dataResult.Rows[i]["prevention"].ToString();
                    string complication = dataResult.Rows[i]["complication"].ToString();
                    string identify = dataResult.Rows[i]["identify"].ToString();
                    string symptom = dataResult.Rows[i]["symptom"].ToString();
                    string inspection = dataResult.Rows[i]["inspection"].ToString();
                    string treatment = dataResult.Rows[i]["treatment"].ToString();
                    string dietHealth = dataResult.Rows[i]["dietHealth"].ToString();
                    string insertSql = "insert into Disease_Detail(name,summary,cause,prevention,complication,identify,symptom,inspection,treatment,dietHealth)"
                                 + "values('" + name + "','" + summary + "','" + cause + "','" + prevention + "','" + complication + "','" + identify + "','" + symptom + "','" + inspection + "','" + treatment + "','" + dietHealth + "')";
                    sqls.Add(insertSql);
                    DBHelper.ExecuteNoResult(insertSql, conn);
                }
                
                //第二步，根据疾病名称更新表中的别名字段

                string sqlGetData2 = "select name,alias,basicDescribe,cause,symptomsSigns,inspectionTesting,diagnosis,complication,preventiveCare,treatment from ZhongGuoJianKangWang where name is not null";
                var dataResult2 = DBHelper.ExecuteWithReset(sqlGetData2, conn);
                List<ZhongguoJianKang> nameList = new List<ZhongguoJianKang>();
                for (int j = 0; j < dataResult2.Rows.Count; j++)
                {
                    nameList.Add(new ZhongguoJianKang()
                    {
                        Name = dataResult2.Rows[j]["name"].ToString(),
                        Alias = dataResult2.Rows[j]["alias"].ToString(),
                        BasicDescibe = dataResult2.Rows[j]["basicDescribe"].ToString(),
                        Cause = dataResult2.Rows[j]["cause"].ToString(),
                        SymptomsSigns = dataResult2.Rows[j]["symptomsSigns"].ToString(),
                        InspectionTesting = dataResult2.Rows[j]["inspectionTesting"].ToString(),
                        Diagnosis = dataResult2.Rows[j]["diagnosis"].ToString(),
                        Complication = dataResult2.Rows[j]["complication"].ToString(),
                        PreventionCare = dataResult2.Rows[j]["preventiveCare"].ToString(),
                        Treatment = dataResult2.Rows[j]["treatment"].ToString()
                    });
                }
                List<string> sql2 = new List<string>();
                foreach (var model in nameList)
                {
                    string sqlcount = "select count(*) from Disease_Detail where name='" + model.Name + "'";
                    int count = Convert.ToInt32(DBHelper.ExecuteWithOneRow(sqlcount, conn));
                    if (count <= 0) //不存在 插入
                    {
                        string insertSql = "insert into Disease_Detail(name,summary,cause,prevention,complication,identify,symptom,inspection,treatment)"
                                + "values('" + model.Name + "','" + model.BasicDescibe + "','" + model.Cause + "','" + model.PreventionCare + "','" + model.Complication + "','" + model.Diagnosis + "','" + model.SymptomsSigns + "','" + model.InspectionTesting + "','" + model.Treatment + "')";
                        sql2.Add(insertSql);
                        DBHelper.ExecuteNoResult(insertSql, conn);
                    }
                    else //存在，更新别名
                    {
                        string updateSql = "update Disease_Detail set alias='" + model.Alias + "' where name='" + model.Name + "'";
                        sql2.Add(updateSql);
                        DBHelper.ExecuteNoResult(updateSql, conn);
                    }
                }
               
            }
            catch (Exception ex)
            {
            }
        }

        class ZhongguoJianKang
        {
            public string Name { set; get; }
            public string Alias { set; get; }
            public string BasicDescibe { set; get; }
            public string Cause { set; get; }
            public string SymptomsSigns { set; get; }
            public string InspectionTesting { set; get; }
            public string Diagnosis { set; get; }
            public string Complication { set; get; }
            public string PreventionCare { set; get; }
            public string Treatment { set; get; }
        }

        #endregion
    }
}
