﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class HealthProductInstrument
    {
        Dao.HealthProductInstrument dao = new Dao.HealthProductInstrument();
        public void saveYaoPinShiYingZheng()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            DataTable dt = dao.getSentence("HealthProductInstruction", "healthFunction");
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "保健功能";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        for (int listI = 0; listI < auxiliaryVerbPrepositionList.Count; listI++)
                        {
                            int index = values[j].IndexOf(auxiliaryVerbPrepositionList[listI]);
                            if (index != -1)
                            {
                                values[j] = values[j].Substring(index + auxiliaryVerbPrepositionList[listI].Length);
                                listI = 0;
                            }
                        }
                        String value = values[j];
                        for (int k = 0; k < Common.SemanticHelper.other.Length; k++)
                        {
                            value = value.Replace(Common.SemanticHelper.other[k], "");
                        }
                        int chineseFlag = 0;
                        for (int k = 0; k < value.Length; k++)
                        {
                            if (Convert.ToInt32(Convert.ToChar(value.Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                            {
                                chineseFlag = 1;
                                break;
                            }
                        }
                        if (chineseFlag == 1 && value.Length > 1)
                        {
                            dao.insertAnalysis(value,"symptom");
                        }
                    }
                }
            }
        }

        public void savePopulation()
        {
            DataTable dt = dao.getSentence("HealthProductInstruction", "taboopopulation");
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "人群";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        String value = values[j].Replace(" ","");
                        int flag = 0;
                        String[] deleteValues = { "无", "null" };
                        for (int k = 0; k < deleteValues.Length; k++)
                        {
                            if (value.Equals(deleteValues[k])==true)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        if (flag==0)
                        {
                            dao.insertAnalysis(value,"population");
                        }
                    }
                }
            }
        }

        public void saveComponent()
        {
            DataTable dt = dao.getSentence("HealthProductInstruction", "material");
            if (dt != null)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    String subject = "成分";
                    String sentence = dt.Rows[i][0].ToString();
                    String yaopin = dt.Rows[i][1].ToString();
                    String[] values = sentence.Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                    for (int j = 0; j < values.Length; j++)
                    {
                        String value = values[j].Replace(" ", "").Replace("等味","");
                        dao.insertAnalysis(value, "component");
                    }
                }
            }
            List<string> componentGroupList = dao.getValueGroup("component");
            for (int i = 0; i < componentGroupList.Count; i++)
            {
                dao.insertValueGroup("component", "componentName", componentGroupList[i].ToString());
            }
        }
    }
}
