﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Dao;
using System.Data;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class ShuoMingShuIntegration
    {
        Dao.YaoPinTong dao = new Dao.YaoPinTong();

        public void insertDetail()
        {
            DataTable dt = dao.getContent();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String shuoming = dt.Rows[i][1].ToString();
                String type = dt.Rows[i][2].ToString();
                String url = dt.Rows[i][3].ToString();
                String[] str = shuoming.Split(new string[] { "@" }, StringSplitOptions.RemoveEmptyEntries);
                for (int j = 0; j < str.Length; j++)
                {
                    int index = str[j].IndexOf("||");
                    if (index != -1)
                    {
                        String[] value = str[j].Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                        if (value.Length == 2)
                        {
                            String title = value[0].Replace("【", "").Replace("】", "");
                            String text = value[1];
                            dao.insertDetail(name, title, text, type, url);
                        }
                    }
                }
            }
        }

        public void insertMedicalInstrumentInstruction()
        {
            DataTable dt = dao.getDetail("医疗器械");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String shuoming = dt.Rows[i][1].ToString().Trim().Replace("每种规格型号", "每种规格"); ;
                String type = dt.Rows[i][2].ToString();
                String url = dt.Rows[i][3].ToString();
                int[] indexName = new int[4]{0,1,2,3};
                int[] index = new int[4];
                index[0] = shuoming.IndexOf("批准文号");
                index[1] = shuoming.IndexOf("规格型号");
                index[2] = shuoming.IndexOf("性能组成");
                index[3] = shuoming.IndexOf("适应范围");
                for (int m = 0; m < 3; m++)
                {
                    if (index[m] == -1)
                    {
                        continue;
                    }
                    int minIndex = m;
                    for (int n = m+1; n < 4; n++)
                    {
                        if (index[n]!=-1 && index[minIndex] > index[n])
                        {
                            minIndex = n;
                        }
                    }
                    if (minIndex != index[m])
                    {
                        int temp = index[m];
                        index[m] = index[minIndex];
                        index[minIndex] = temp;
                        temp = indexName[m];
                        indexName[m] = indexName[minIndex];
                        indexName[minIndex] = temp;
                    }
                }
                String[] text = shuoming.Split(new string[] { "批准文号", "规格型号", "性能组成", "适应范围" }, StringSplitOptions.RemoveEmptyEntries);
                String approveNumber = "";
                String specification = "";
                String performanceComponent = "";
                String adaption = "";
                string updateSql = "update MedicalInstrumentInstruction set name='" + name + "',";
                for (int m = 0; m < text.Length; m++)
                {
                    if (m >= 4)
                    {
                        adaption = text[text.Length-1];
                        updateSql += "adaption='" + adaption + "',";
                        break;
                    }
                    if (indexName[m] == 0 && index[m]!=-1)
                    {
                        approveNumber = text[m];
                        updateSql += "approveNumber='" + approveNumber + "',";
                    }
                    else if (indexName[m] == 1 && index[m] != -1)
                    {
                        specification = text[m];
                        updateSql += "specification='" + specification + "',";
                    }
                    else if (indexName[m] == 2 && index[m] != -1)
                    {
                        performanceComponent = text[m];
                        updateSql += "performanceComponent='" + performanceComponent + "',";
                    }
                    else if (indexName[m] == 3 && index[m] != -1)
                    {
                        adaption = text[m];
                        updateSql += "adaption='" + adaption + "',";
                    }
                }
                updateSql += "type='医疗器械' where url='" + url + "'";
                string insertSql = "insert into MedicalInstrumentInstruction(";
                insertSql += "name,";
                insertSql += "approveNumber,";
                insertSql += "specification,";
                insertSql += "performanceComponent,";
                insertSql += "adaption,";
                insertSql += "type,";
                insertSql += "url";
                insertSql += ") values(";
                insertSql += "'" + name + "',";
                insertSql += "'" + approveNumber + "',";
                insertSql += "'" + specification + "',";
                insertSql += "'" + performanceComponent + "',";
                insertSql += "'" + adaption + "',";
                insertSql += "'" + type + "',";
                insertSql += "'" + url + "'";
                insertSql += ")";
                bool exist = dao.isExist("MedicalInstrumentInstruction", url);
                if (exist == true)
                {
                    dao.saveInstruction(updateSql);
                }
                else
                {
                    dao.saveInstruction(insertSql);
                }
            }
        }

        public void insertChineseMaterialInstruction()
        {
            DataTable dt = dao.getDetail("中药材");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String title = dt.Rows[i][1].ToString();
                String text = dt.Rows[i][2].ToString();
                String type = dt.Rows[i][3].ToString();
                String url = dt.Rows[i][4].ToString();
                String otherName = "";
                String component = "";
                String mainFunction = "";
                String bodyPosition = "";
                String howUse = "";
                String indicationAndTaboo = "";
                String choosen = "";
                String clinicalApplication = "";
                string updateSql = "update ChineseMedicineMaterialInstruction set name='" + name + "',";
                if (title.Equals("别名") == true)
                {
                    otherName = text;
                    updateSql += "otherName='" + otherName + "'";
                }
                else if (title.Equals("成份") == true)
                {
                    component = text;
                    updateSql += "component='" + component + "'";
                }
                else if (title.Equals("功能主治") == true)
                {
                    mainFunction = text;
                    updateSql += "mainFunction='" + mainFunction + "'";
                }
                else if (title.Equals("药用部位") == true)
                {
                    bodyPosition = text;
                    updateSql += "bodyPosition='" + bodyPosition + "'";
                }
                else if (title.Equals("用法与用量") == true)
                {
                    howUse = text;
                    updateSql += "howUse='" + howUse + "'";
                }
                else if (title.Equals("宜忌") == true)
                {
                    indicationAndTaboo = text;
                    updateSql += "indicationAndTaboo='" + indicationAndTaboo + "'";
                }
                else if (title.Equals("选方") == true)
                {
                    choosen = text;
                    updateSql += "choosen='" + choosen + "'";
                }
                else if (title.Equals("临床应用") == true)
                {
                    clinicalApplication = text;
                    updateSql += "clinicalApplication='" + clinicalApplication + "'";
                }
                updateSql += " where url='" + url + "'";
                string insertSql = "insert into ChineseMedicineMaterialInstruction(";
                insertSql += "name,";
                insertSql += "otherName,";
                insertSql += "component,";
                insertSql += "mainFunction,";
                insertSql += "bodyPosition,";
                insertSql += "howUse,";
                insertSql += "indicationAndTaboo,";
                insertSql += "choosen,";
                insertSql += "clinicalApplication,";
                insertSql += "type,";
                insertSql += "url";
                insertSql += ") values(";
                insertSql += "'" + name + "',";
                insertSql += "'" + otherName + "',";
                insertSql += "'" + component + "',";
                insertSql += "'" + mainFunction + "',";
                insertSql += "'" + bodyPosition + "',";
                insertSql += "'" + howUse + "',";
                insertSql += "'" + indicationAndTaboo + "',";
                insertSql += "'" + choosen + "',";
                insertSql += "'" + clinicalApplication + "',";
                insertSql += "'" + type + "',";
                insertSql += "'" + url + "'";
                insertSql += ")";
                bool exist = dao.isExist("ChineseMedicineMaterialInstruction", url);
                if (exist == true)
                {
                    dao.saveInstruction(updateSql);
                }
                else
                {
                    dao.saveInstruction(insertSql);
                }
            }
        }

        public void insertHealthProductInstruction()
        {
            DataTable dt = dao.getDetail("保健品");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String title = dt.Rows[i][1].ToString();
                String text = dt.Rows[i][2].ToString();
                String type = dt.Rows[i][3].ToString();
                String url = dt.Rows[i][4].ToString();

                String address = "";
                String productName = "";
                String material = "";
                String howUse = "";
                String attention = "";
                String approveNumber = "";
                String enterprise = "";
                String saveMethod = "";
                String tabooPopulation = "";
                String healthyFunction = "";
                String indicationPopulation = "";
                String savePeriod = "";
                String other = "";
                string updateSql = "update HealthProductInstruction set name='" + name + "',";
                int index = title.IndexOf("生产地址");
                if (index != -1)
                {
                    address = title.Substring(5);
                    updateSql += "address='" + address + "'";
                }
                else
                {
                    if (title.Equals("产品名称") == true)
                    {
                        productName = text;
                        updateSql += "productName='" + productName + "'";
                    }
                    else if (title.Equals("用法用量") == true)
                    {
                        howUse = text;
                        updateSql += "howUse='" + howUse + "'";
                    }
                    else if (title.Equals("注意事项") == true)
                    {
                        attention = text;
                        updateSql += "attention='" + attention + "'";
                    }
                    else if (title.Equals("批准文号") == true)
                    {
                        approveNumber = text;
                        updateSql += "approveNumber='" + approveNumber + "'";
                    }
                    else if (title.Equals("生产厂家") == true || title.Equals("生产企业") == true)
                    {
                        enterprise = text;
                        updateSql += "enterprise='" + enterprise + "'";
                    }
                    else if (title.Equals("贮藏") == true || title.Equals("贮藏方法") == true)
                    {
                        saveMethod = text;
                        updateSql += "saveMethod='" + saveMethod + "'";
                    }
                    else if (title.Equals("不适宜人群") == true)
                    {
                        tabooPopulation = text;
                        updateSql += "tabooPopulation='" + tabooPopulation + "'";
                    }
                    else if (title.Equals("保健功能") == true)
                    {
                        healthyFunction = text;
                        updateSql += "healthFunction='" + healthyFunction + "'";
                    }
                    else if (title.Equals("适宜人群") == true)
                    {
                        indicationPopulation = text;
                        updateSql += "indicationPopulation='" + indicationPopulation + "'";
                    }
                    else if (title.Equals("保质期") == true)
                    {
                        savePeriod = text;
                        updateSql += "savePeriod='" + savePeriod + "'";
                    }
                    else if (title.Equals("主要原料") == true)
                    {
                        material = text;
                        updateSql += "material='" + material + "'";
                    }
                    else
                    {
                        other = title;
                        updateSql += "other='" + other + "'";
                    }
                }
                updateSql += " where url='" + url + "'";
                string insertSql = "insert into HealthProductInstruction(";
                insertSql += "name,";
                insertSql += "productName,";
                insertSql += "material,";
                insertSql += "howUse,";
                insertSql += "attention,";
                insertSql += "approveNumber,";
                insertSql += "enterprise,";
                insertSql += "address,";
                insertSql += "saveMethod,";
                insertSql += "tabooPopulation,";
                insertSql += "healthFunction,";
                insertSql += "indicationPopulation,";
                insertSql += "savePeriod,";
                insertSql += "other,";
                insertSql += "type,";
                insertSql += "url";
                insertSql += ") values(";
                insertSql += "'" + name + "',";
                insertSql += "'" + productName + "',";
                insertSql += "'" + material + "',";
                insertSql += "'" + howUse + "',";
                insertSql += "'" + attention + "',";
                insertSql += "'" + approveNumber + "',";
                insertSql += "'" + enterprise + "',";
                insertSql += "'" + address + "',";
                insertSql += "'" + saveMethod + "',";
                insertSql += "'" + tabooPopulation + "',";
                insertSql += "'" + healthyFunction + "',";
                insertSql += "'" + indicationPopulation + "',";
                insertSql += "'" + savePeriod + "',";
                insertSql += "'" + other + "',";
                insertSql += "'" + type + "',";
                insertSql += "'" + url + "'";
                insertSql += ")";
                bool exist = dao.isExist("HealthProductInstruction", url);
                if (exist == true)
                {
                    dao.saveInstruction(updateSql);
                }
                else
                {
                    dao.saveInstruction(insertSql);
                }
            }
        }

        public void insertMedicineInstruction()
        {
            DataTable dt = dao.getDetail("中西药");
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String title = dt.Rows[i][1].ToString();
                String text = dt.Rows[i][2].ToString();
                String type = dt.Rows[i][3].ToString();
                String url = dt.Rows[i][4].ToString();

                String address="";
                String medicineName="";
                String englishName="";
                String productName="";
                String mainFunction="";
                String component="";
                String material="";
                String howUse="";
                String badEffect="";
                String indication="";
                String taboo="";
                String attention="";
                String approveNumber="";
                String enterprise="";
                String saveMethod="";
                String validity="";
                String updateDate = "";
                String specialPopulation = "";
                String pharmacological = "";
                String interaction = "";
                String tabooPopulation = "";
                String healthyFunction = "";
                String indicationPopulation = "";
                String savePeriod = "";
                string updateSql = "update MedicineInstruction set name='" + name + "',";
                int index=title.IndexOf("生产地址");
                if(index!=-1)
                {
                    address = title.Substring(5);
                    updateSql += "address='" + address + "'";
                }
                else
                {
                    if(title.Equals("药品名称")==true)
                    {
                        int indexText=text.IndexOf("英文名称");
                        if (indexText != -1)
                        {
                            medicineName=text.Substring(0,indexText);
                            englishName = text.Substring(indexText);
                            updateSql += "medicineName='" + medicineName + "',";
                            updateSql += "englishName='" + englishName + "'";
                        }
                        else
                        {
                            medicineName = text;
                            updateSql += "medicineName='" + medicineName + "'";
                        }
                    }
                    else if(title.Equals("产品名称")==true)
                    {
                        productName = text;
                        updateSql += "productName='" + productName + "'";
                    }
                    else if(title.Equals("功能主治")==true)
                    {
                        mainFunction = text;
                        updateSql += "mainFunction='" + mainFunction + "'";
                    }
                    else if(title.Equals("成份")==true)
                    {
                        component = text;
                        updateSql += "component='" + component + "'";
                    }
                    else if(title.Equals("主要原料")==true)
                    {
                        material = text;
                        updateSql += "material='" + material + "'";
                    }
                    else if(title.Equals("用法用量")==true)
                    {
                        howUse = text;
                        updateSql += "howUse='" + howUse + "'";
                    }
                    else if(title.Equals("不良反应")==true)
                    {
                        badEffect = text;
                        updateSql += "badEffect='" + badEffect + "'";
                    }
                    else if(title.Equals("适应症")==true)
                    {
                        indication = text;
                        updateSql += "indication='" + indication + "'";
                    }
                    else if(title.Equals("禁忌")==true)
                    {
                        taboo = text;
                        updateSql += "taboo='" + taboo + "'";
                    }
                    else if(title.Equals("注意事项")==true)
                    {
                        attention = text;
                        updateSql += "attention='" + attention + "'";
                    }
                    else if(title.Equals("批准文号")==true)
                    {
                        approveNumber = text;
                        updateSql += "approveNumber='" + approveNumber + "'";
                    }
                    else if(title.Equals("生产企业")==true)
                    {
                        enterprise = text;
                        updateSql += "enterprise='" + enterprise + "'";
                    }
                    else if(title.Equals("贮藏")==true || title.Equals("贮藏方法")==true)
                    {
                        saveMethod = text;
                        updateSql += "saveMethod='" + saveMethod + "'";
                    }
                    else if(title.Equals("有效期")==true)
                    {
                        validity = text;
                        updateSql += "validity='" + validity + "'";
                    }
                    else if (title.Equals("说明书修订日期") == true)
                    {
                        updateDate = text;
                        updateSql += "updateDate='" + updateDate + "'";
                    }
                    else if (title.Equals("特殊人群用药") == true)
                    {
                        specialPopulation = text;
                        updateSql += "specialPopulation='" + specialPopulation + "'";
                    }
                    else if (title.Equals("药理作用") == true)
                    {
                        pharmacological = text;
                        updateSql += "pharmacological='" + pharmacological + "'";
                    }
                    else if (title.Equals("药物相互作用") == true)
                    {
                        interaction = text;
                        updateSql += "interaction='" + interaction + "'";
                    }
                    else if (title.Equals("不适宜人群") == true)
                    {
                        tabooPopulation = text;
                        updateSql += "tabooPopulation='" + tabooPopulation + "'";
                    }
                    else if (title.Equals("保健功能") == true)
                    {
                        healthyFunction = text;
                        updateSql += "healthyFunction='" + healthyFunction + "'";
                    }
                    else if (title.Equals("适宜人群") == true)
                    {
                        indicationPopulation = text;
                        updateSql += "indicationPopulation='" + indicationPopulation + "'";
                    }
                    else if (title.Equals("保质期") == true)
                    {
                        savePeriod = text;
                        updateSql += "savePeriod='" + savePeriod + "'";
                    }
                }
                updateSql += " where url='" + url + "'";
                string insertSql = "insert into MedicineInstruction(";
                insertSql += "name,";
                insertSql += "medicineName,";
                insertSql += "englishName,";
                insertSql += "productName,";
                insertSql += "component,";
                insertSql += "material,";
                insertSql += "howUse,";
                insertSql += "mainFunction,";
                insertSql += "badEffect,";
                insertSql += "indication,";
                insertSql += "taboo,";
                insertSql += "attention,";
                insertSql += "approveNumber,";
                insertSql += "enterprise,";
                insertSql += "address,";
                insertSql += "saveMethod,";
                insertSql += "validity,";
                insertSql += "updateDate,";
                insertSql += "specialPopulation,";
                insertSql += "pharmacological,";
                insertSql += "interaction,";
                insertSql += "tabooPopulation,";
                insertSql += "healthyFunction,";
                insertSql += "indicationPopulation,";
                insertSql += "savePeriod,";
                insertSql += "type,";
                insertSql += "url";
                insertSql += ") values(";
                insertSql += "'" + name + "',";
                insertSql += "'" + medicineName + "',";
                insertSql += "'" + englishName + "',";
                insertSql += "'" + productName + "',";
                insertSql += "'" + component + "',";
                insertSql += "'" + material + "',";
                insertSql += "'" + howUse + "',";
                insertSql += "'" + mainFunction + "',";
                insertSql += "'" + badEffect + "',";
                insertSql += "'" + indication + "',";
                insertSql += "'" + taboo + "',";
                insertSql += "'" + attention + "',";
                insertSql += "'" + approveNumber + "',";
                insertSql += "'" + enterprise + "',";
                insertSql += "'" + address + "',";
                insertSql += "'" + saveMethod + "',";
                insertSql += "'" + validity + "',";
                insertSql += "'" + updateDate + "',";
                insertSql += "'" + specialPopulation + "',";
                insertSql += "'" + pharmacological + "',";
                insertSql += "'" + interaction + "',";
                insertSql += "'" + tabooPopulation + "',";
                insertSql += "'" + healthyFunction + "',";
                insertSql += "'" + indicationPopulation + "',";
                insertSql += "'" + savePeriod + "',";
                insertSql += "'" + type + "',";
                insertSql += "'" + url + "'";
                insertSql += ")";
                bool exist = dao.isExist("MedicineInstruction", url);
                if (exist == true)
                {
                    dao.saveInstruction(updateSql);
                }
                else
                {
                    dao.saveInstruction(insertSql);
                }
            }
        }
    }
}
