﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class SymptomSemnatics
    {
        Dao.Symptom dao = new Dao.Symptom();
        static SqlConnection conn = DBHelper.getConnection();
        /// <summary>
        /// 症状分词（没有说明书）
        /// </summary>
        public void SaveSymptomSemanticsNonInstrunction()
        {
            List<string> symptomList = dao.getSymptomList_NonInstruction();
            string[] spliter = new string[] { "属", "所引起", "引起的", "引起", "见于", "（", "之", "伴", 
                "可于", "所引致", "所见", "可改善", "可缓解","各类","各期","表现","引致","防治","适于","于","证见","兼见","病见","而见","见" };
            if (symptomList != null && symptomList.Count > 0)
            {
                foreach (var s in symptomList)
                {
                    var sentence = ExpressionSplitWordHelper.expressionSplitWord(s);
                    if (sentence != null)
                    {
                        string sql = "update LinShiMedicineNonInstruction set flag=1 where indication='" + s + "'";
                        int result = DBHelper.ExecuteNoResult(sql, conn);

                        foreach (string sent in sentence)
                        {
                            var ss = sent.Split(SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries);
                            foreach (var value in ss)
                            {
                                int flag = 0;
                                var sss = Common.SemanticHelper.DealWithCPSymobol(value, "【", "】").Trim();
                                sss = Common.SemanticHelper.DealWithCPSymobol(value, "[", "]");
                                sss = Common.SemanticHelper.DealWithCPSymobol(value, "（", "）");
                                sss=sss.FilterStr();
                                for (int k = 0; k < Common.SemanticHelper.other.Length; k++) //删除其他
                                {
                                    sss = sss.Replace(Common.SemanticHelper.other[k], "");
                                }

                                String[] firstReplace = { "1", "—", "】" };
                                for (int k = 0; k < firstReplace.Length; k++)
                                {
                                    sss = sss.Replace(firstReplace[k], "");
                                }
                                String[] deleteValues = new String[] { "但不", "不", "本品", "苗医", "中医", "一般", "其他", "医院", "无改善", "其他", 
                                    "其它", "使用", "以下", "作用", "科", "每日","以上","液","个月","剂","麻醉","上述","该品","对","兵","膏","敌",
                                    "必要","藏医","但","别称","长期","手术","单位","按照","方法","疗效","之前","分钟","mg","成人","使","软件",
                                    "图","方案","辅助","医嘱","按","-","化疗","时间","可单独","更为","更好","诊断","部分","测","应","救","生活","必须",
                                    "%","根","检查","插管","作为","下列","氨基酸类","常见","体外","确立","基础上","效果",
                                    "一定",
                                    "批准文号" };
                                for (int k = 0; k < deleteValues.Length; k++)
                                {
                                    int index = sss.IndexOf(deleteValues[k]);
                                    if (index >= 0)
                                    {
                                        flag = 1;
                                        break;
                                    }
                                }
                                if (flag == 0)
                                {
                                    int chineseFlag = 0;
                                    for (int k = 0; k < sss.Length; k++)
                                    {
                                        if (Convert.ToInt32(Convert.ToChar(sss.Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                                        {
                                            chineseFlag = 1;
                                            break;
                                        }
                                    }
                                    if (chineseFlag == 1 && sss.Length > 1)
                                    {
                                        foreach (var insertValue in sss.Split(spliter,StringSplitOptions.RemoveEmptyEntries))
                                        {
                                            if (!(insertValue.EndsWith("菌") || insertValue.EndsWith("期") || insertValue.EndsWith("级") || insertValue.EndsWith("适应症")
                                                || insertValue.EndsWith("系统") || insertValue.EndsWith("型") || insertValue.EndsWith("品") || insertValue.EndsWith("小时")
                                                || insertValue.EndsWith("后") || insertValue.EndsWith("化") || insertValue.EndsWith("像")))
                                            {
                                                string sqlInsert = "insert into LinShiSymptom(symptom) values('" + insertValue + "')";  
                                                int ret = DBHelper.ExecuteNoResult(sqlInsert, conn);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        /// <summary>
        /// 症状分词
        /// </summary>
        public void SaveSymptomSemantics()
        {
            List<string> auxiliaryVerbPrepositionList = Common.SemanticHelper.getAuxiliaryVerbPreposition();
            List<string> symptomList = dao.getSymptomList();
            if (symptomList != null&&symptomList.Count>0)
            {
                for (int i = 0; i < symptomList.Count; i++)
                {
                    //String subject = "适应症";
                    //String sentence = dt.Rows[i][0].ToString();
                    //String yaopin = dt.Rows[i][1].ToString();
                    String[] values = symptomList[i].Split(Common.SemanticHelper.conjection, StringSplitOptions.RemoveEmptyEntries); //使用连词分割，如，。 、
                    for (int j = 0; j < values.Length; j++)  //使用介词、动词截取
                    {
                        for (int listI = 0; listI < auxiliaryVerbPrepositionList.Count; listI++)
                        {
                            int index = values[j].IndexOf(auxiliaryVerbPrepositionList[listI]);
                            if (index != -1)
                            {
                                values[j] = values[j].Substring(index + auxiliaryVerbPrepositionList[listI].Length);
                                listI = 0;
                            }
                        }
                        int flag = 0;
                        String[] deleteValues = new String[] { "但不", "不", "本品", "苗医", "中医", "一般", "其他", "医院", "无改善", "其他", "其它", "使用", "以下", "作用", "科", "每日" };
                        for (int k = 0; k < deleteValues.Length; k++)
                        {
                            int index = values[j].IndexOf(deleteValues[k]);
                            if (index >= 0)
                            {
                                flag = 1;
                                break;
                            }
                        }
                        if (flag == 0)
                        {
                            String value = values[j];
                            value = value.Trim();
                            value = Common.SemanticHelper.DealWithCPSymobol(value, "《", "》");
                            for (int k = 0; k < Common.SemanticHelper.other.Length; k++) //删除其他
                            {
                                value = value.Replace(Common.SemanticHelper.other[k], "");
                            }
                            String[] firstReplace = { "1", "—", "】" };
                            for (int k = 0; k < firstReplace.Length; k++)
                            {
                                value = value.Replace(firstReplace[k], "");
                            }
                           
                            int chineseFlag = 0;
                            for (int k = 0; k < value.Length; k++)
                            {
                                if (Convert.ToInt32(Convert.ToChar(values[j].Substring(k, 1))) >= Convert.ToInt32(Convert.ToChar(128)))
                                {
                                    chineseFlag = 1;
                                    break;
                                }
                            }
                            if (chineseFlag == 1 && value.Length > 1)
                            {
                                dao.InsertSymptom(value);
                            }
                        }
                    }
                }
            }
        }
    }
}
