﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;
using System.Data.SqlClient;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;
using Excel = Microsoft.Office.Interop.Excel;
using System.Reflection;

namespace YFDYFKnowledgeDiscovery.Semantics
{
    public class YFGoodInstruction
    {
        static SqlConnection conn = DBHelper.getConnection();

        public void insertYFGoodInstruction()
        {
            string sql = "select yfid,yfmedicinename,kdmedicinename from yfmedicine";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string YFId = dt.Rows[i][0].ToString();
                string YFMedicineName = dt.Rows[i][1].ToString();
                string KDMedicineName = dt.Rows[i][2].ToString();
                sql = "insert into yfgoodinstruction(id,yfid,yfmedicinename,kdmedicinename,type) values(newid(),'" + YFId + "','" + YFMedicineName + "','" + KDMedicineName + "','中西药')";
                int ret = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public void updateYFGoodInstruction()
        {
            string sql = "select kdmedicinename from yfgoodinstruction";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string KDMedicineName = dt.Rows[i][0].ToString();
                sql = "select mainfunction,indication,taboo from medicineinstruction where name = '" + KDMedicineName + "'";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                for(int j = 0; j < dt2.Rows.Count; j++)
                {
                    string mainFunction = dt2.Rows[j][0].ToString();
                    string indication = dt2.Rows[j][1].ToString();
                    string taboo = dt2.Rows[j][2].ToString();
                    if (mainFunction.Length > 0 || indication.Length > 0)
                    {
                        sql = "update yfgoodinstruction set mainfunction='" + mainFunction + "',indication='" + indication + "',taboo='" + taboo + "' where kdmedicinename='" + KDMedicineName + "'";
                        int ret = DBHelper.ExecuteNoResult(sql, conn);
                        break;
                    }
                }
            }
        }

        public void updateYFGoodInstructionFromBaike()
        {
            string sql = "select kdmedicinename from yfgoodinstruction where mainfunction is null and indication is null";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                string KDMedicineName = dt.Rows[i][0].ToString();
                sql = "select name,value from baikedetail where yaopin = '" + KDMedicineName + "' and name like '%适应症%'";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                string indication = "";
                if (dt2.Rows.Count > 0)
                {
                    if (dt2.Rows[0][1].ToString().Length > 2)
                    {
                        indication = dt2.Rows[0][1].ToString();
                    }
                    else
                    {
                        indication = dt2.Rows[0][0].ToString();
                    }
                }
                sql = "select name,value from baikedetail where yaopin = '" + KDMedicineName + "' and name like '%禁忌%'";
                dt2 = DBHelper.ExecuteWithReset(sql, conn);
                string taboo = "";
                if (dt2.Rows.Count > 0)
                {
                    if (dt2.Rows[0][1].ToString().Length > 2)
                    {
                        taboo = dt2.Rows[0][1].ToString();
                    }
                    else
                    {
                        taboo = dt2.Rows[0][0].ToString();
                    }
                }
                sql = "select name,value from baikedetail where yaopin = '" + KDMedicineName + "' and (name like '%功能%' or name like '%主治%')";
                dt2 = DBHelper.ExecuteWithReset(sql, conn);
                string mainFunction = "";
                if (dt2.Rows.Count > 0)
                {
                    if (dt2.Rows[0][1].ToString().Length > 2)
                    {
                        mainFunction = dt2.Rows[0][1].ToString();
                    }
                    else
                    {
                        mainFunction = dt2.Rows[0][0].ToString();
                    }
                }
                sql = "update yfgoodinstruction set mainfunction='" + mainFunction + "',indication='" + indication + "',taboo='" + taboo + "' where kdmedicinename='" + KDMedicineName + "' and mainfunction is null and indication is null";
                int ret = DBHelper.ExecuteNoResult(sql, conn);
            }
        }

        public void ReadExcel(String filePathName)
        {
            Excel.Application xapp = new Excel.Application();
            try
            {
                Excel.Workbook xbook = xapp.Workbooks._Open(filePathName, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value,
                                        Missing.Value, Missing.Value, Missing.Value, Missing.Value, Missing.Value);
                Excel.Worksheet xsheet = (Excel.Worksheet)xbook.Sheets[1];
                for (int i = 1; i <= 671; i++)
                {
                    Excel.Range rngA = xsheet.get_Range("A" + i.ToString(), Missing.Value);
                    string YFMedicineName = rngA.Text;
                    YFMedicineName = YFMedicineName.Trim();
                    Excel.Range rngB = xsheet.get_Range("B" + i.ToString(), Missing.Value);
                    string mainFunction = rngB.Text;
                    Excel.Range rngC = xsheet.get_Range("C" + i.ToString(), Missing.Value);
                    string indication = rngC.Text;
                    if (YFMedicineName != null && YFMedicineName.Equals("") == false)
                    {
                        string sql = "update yfgoodinstruction set mainfunction='" + mainFunction + "',indication='" + indication + "' where yfmedicinename='" + YFMedicineName + "' and ((mainFunction is null and indication is null)or (LEN(mainfunction)=0 and LEN(indication)=0))";
                        int ret = DBHelper.ExecuteNoResult(sql, conn);
                    }
                }
                xapp.Workbooks.Close();
            }
            catch
            {
                xapp.Workbooks.Close();
            }
        }

        public void YFGoodIndicationDisease()
        {
            List<string> diseases = new List<string>();
            string sql = "select diseasename from kddisease";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                diseases.Add(dt.Rows[i][0].ToString());
            }
            for (int i = 0; i < diseases.Count; i++)
            {
                string disease = diseases[i].Trim();
                sql = "select yfid,yfmedicinename from yfgoodinstruction where mainFunction like '%" + disease + "%' or indication like '%" + disease + "%'";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                if (dt2 == null)
                {
                    continue;
                }
                for (int j = 0; j < dt2.Rows.Count; j++)
                {
                    string YFId = dt2.Rows[j][0].ToString();
                    string YFMedicineName = dt2.Rows[j][1].ToString();
                    sql = "insert into yfgooddisease(id,yfid,yfmedicinename,diseasename,indicationortaboo) values(newid(),'" + YFId + "','" + YFMedicineName + "','" + disease + "','indication')";
                    int ret = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
        }

        public void YFGoodIndicationSymptom()
        {
            List<string> symptoms = new List<string>();
            string sql = "select symptomname from kdsymptom";
            DataTable dt = DBHelper.ExecuteWithReset(sql, conn);
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                symptoms.Add(dt.Rows[i][0].ToString());
            }
            for (int i = 0; i < symptoms.Count; i++)
            {
                string symptom = symptoms[i].Trim();
                sql = "select yfid,yfmedicinename from yfgoodinstruction where mainFunction like '%" + symptom + "%' or indication like '%" + symptom + "%'";
                DataTable dt2 = DBHelper.ExecuteWithReset(sql, conn);
                if (dt2 == null)
                {
                    continue;
                }
                for (int j = 0; j < dt2.Rows.Count; j++)
                {
                    string YFId = dt2.Rows[j][0].ToString();
                    string YFMedicineName = dt2.Rows[j][1].ToString();
                    sql = "insert into yfgoodsymptom(id,yfid,yfmedicinename,symptomname,indicationortaboo) values(newid(),'" + YFId + "','" + YFMedicineName + "','" + symptom + "','indication')";
                    int ret = DBHelper.ExecuteNoResult(sql, conn);
                }
            }
        }
    }
}
