﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HtmlAgilityPack;

namespace YFDYFKnowledgeDiscovery.Spider.BaiDuBaiKe
{
    public partial class BaiDuBaiKeForm : Form
    {
        List<String> urlList = new List<string>();
        Dao.BaiKe model = new Dao.BaiKe();
        Dao.Symptom symptomDao = new Dao.Symptom();
        private int id = 0;

        public BaiDuBaiKeForm()
        {
            InitializeComponent();
        }

        private void BaiDuBaiKeForm_Load(object sender, EventArgs e)
        {
            saveBaikeUrlButton.Visible = true;
        }

        private void saveBaikeUrlButton_Click(object sender, EventArgs e)
        {
            //List<String> nameList = model.getName();
            List<string> nameList = new List<string>();
            //string[] lines = System.IO.File.ReadAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\disease2.txt", Encoding.Default);
            //string[] lines = System.IO.File.ReadAllLines(@"E:\\JixinZhang\\益丰大药房知识库\\YFDYFKnowledgeDiscovery\\Doc\\symptom.txt", Encoding.Default);
            //for (int i = 0; i < lines.Length; i++)
            //{
            //    nameList.Add(lines[i]);
            //}
            //nameList = symptomDao.getDisease();
            nameList = symptomDao.getSymptom();
            List<string> link = new List<string>();
            //List<string> diseaseUrlList = new List<string>();
            for (int i = 0; i < nameList.Count; i++)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://baike.baidu.com/search?word=" + nameList[i].ToString() + "&pn=0&rn=0&enc=utf8", Encoding.UTF8);
                if (document == null)
                {
                    continue;
                }
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='searchResult']//a[@class='result-title']", document);
                if (nodeCollection != null)
                {
                    if (nodeCollection[0].InnerText.Trim().Replace("_百度百科", "").Equals(nameList[i].ToString()) == true)
                    {
                        link.Add(nodeCollection[0].GetAttributeValue("href", ""));
                        //model.insertBaikeUrl(nodeCollection[0].GetAttributeValue("href", ""));
                        //diseaseUrlList.Add(nameList[i] + "," + nodeCollection[0].GetAttributeValue("href", ""));
                        //symptomDao.insertBaikeDiseaseUrl(nameList[i], nodeCollection[0].GetAttributeValue("href", ""));
                        symptomDao.insertBaikeSymptomUrl(nameList[i], nodeCollection[0].GetAttributeValue("href", ""));
                    }
                }
            }
            //model.insertBaikeDiseaseUrlText(diseaseUrlList);
            //model.insertBaikeSymptomUrlText(diseaseUrlList);
            content.Text = "地址更新完成";
        }

        private void getBaikeUrlButton_Click(object sender, EventArgs e)
        {
            //urlList = model.getUrl();
            //urlList = model.getDiseaseUrlText();
            //urlList = model.getSymptomUrlText();
            //urlList = symptomDao.getDiseaseUrl();
            urlList = symptomDao.getSymptomUrl();
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功";
            }
            else
            {
                content.Text = "地址获取失败";
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            if (id < urlList.Count)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.UTF8);
                HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//span[@class='title-text']|//div[@class='para']", document);
                //HtmlNodeCollection nodeCollection2 = HTMLHelper.getHTMLNodeByXpath("//div[@class='para']", document);
                HtmlNodeCollection nodeCollection3 = HTMLHelper.getHTMLNodeByXpath("//title", document);
                if (nodeCollection1 != null && nodeCollection3 != null)
                {
                    String name = nodeCollection3[0].InnerText.Trim().Replace("_百度百科", "");
                    String str = "";
                    String title = "";
                    String text = "";
                    int flag = 0;
                    for (int j = 0; j < nodeCollection1.Count; j++)
                    {
                        if (nodeCollection1[j].GetAttributeValue("class", "").Equals("title-text"))
                        {
                            if (flag != 0)
                            {
                                //symptomDao.insertBaikeDiseaseDetail(name, title, text, urlList[id]);
                                symptomDao.insertBaikeSymptomDetail(name, title, text, urlList[id]);
                                text = "";
                            }
                            str += "||";
                            str += nodeCollection1[j].InnerText.Replace("\n", "").Replace("'", "");
                            str += "||";
                            title = nodeCollection1[j].InnerText.Replace("\n", "").Replace("'", "");
                            flag = 1;
                        }
                        else
                        {
                            str += nodeCollection1[j].InnerText.Replace("\n", "").Replace("'", "");
                            str += "||";
                            text += nodeCollection1[j].InnerText.Replace("\n", "").Replace("'", "");
                        }
                    }
                    //model.updateBaikeText(urlList[id].ToString(), str, name);
                    //symptomDao.updateBaikeDisease(str, urlList[id]);
                    //symptomDao.updateBaikeSymptom(str, urlList[id]);
                    content.Text = name+"——"+str;
                    urlAddress.Text = urlList[id];
                    XPath.Text = "//span[@class='title-text']|//div[@class='para']";
                    //string[] diseaseText = new string[3];
                    //diseaseText[0] = name;
                    //diseaseText[1] = urlList[id];
                    //diseaseText[2] = str;
                    //System.IO.File.WriteAllLines(@"D:\\Big Data & Cloud Computing\\项目\\益丰大药房数据分析项目\\临时\\" + name + ".txt", diseaseText, Encoding.UTF8);
                    //System.IO.File.WriteAllLines(@"E:\\JixinZhang\\益丰大药房知识库\\YFDYFKnowledgeDiscovery\\Doc\\symptomdata\\" + name + ".txt", diseaseText, Encoding.UTF8);
                }
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                return;
            }
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            startButton_Click(startButton, null);
        }
    }
}
