﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HtmlAgilityPack;

namespace YFDYFKnowledgeDiscovery.Spider.BaiDuZhiDao
{
    public partial class BaiDuZhiDaoForm : Form
    {
        List<String> urlList = new List<string>();
        Dao.ZhiDao model = new Dao.ZhiDao();
        private int id = 0;

        public BaiDuZhiDaoForm()
        {
            InitializeComponent();
        }

        private void BaiDuZhiDaoForm_Load(object sender, EventArgs e)
        {
            saveZhiDaoUrlButton.Visible = true;
        }

        private void saveZhiDaoUrlButton_Click(object sender, EventArgs e)
        {
            List<String> nameList = model.getName();
            List<string> link = new List<string>();
          

            for (int i = 0; i < nameList.Count; i++)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://zhidao.baidu.com/search?pn=0&&rn=10&lm=0&fr=bks0000&word=" + nameList[i].ToString() + "&pn=0&rn=0&enc=utf8", Encoding.UTF8);
                if (document == null)
                {
                    continue;
                }

                //获取首页的所有问题网址
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='list-inner']//a[@class='ti']", document);
                if (nodeCollection != null)
                {
                    for (int k = 0; k < nodeCollection.Count; k++)
                    {
                        String baiduurl = nodeCollection[k].GetAttributeValue("href", "");
                        if (baiduurl.Contains("baidu"))
                        {
                            link.Add(nodeCollection[k].GetAttributeValue("href", ""));
                            model.insertBaiDuZhiDaoUrl(nameList[i], baiduurl);
                        }
                    }
                }

                //获取第二页和尾页网址,并取出网址最后几位的数字（即页码）
                HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//div[@class='pager']//a", document);
                if (nodeCollection1 != null)
                {
                    String secondpaper = nodeCollection1[0].GetAttributeValue("href", "");   
                    int secondcount = secondpaper.Length;
                    String urlbase = secondpaper.Substring(0, secondcount - 2);

                    //获取页码数
                    String lastpaper = nodeCollection1[nodeCollection1.Count - 1].GetAttributeValue("href", "");
                    int lastcount = lastpaper.Length;
                    String scount = lastpaper.Substring(secondcount - 2, lastcount - secondcount + 2);
                    int icount = Convert.ToInt16(scount);         
   
                    //获取首页以后的网址
                    for (int j = 1; j  <= icount/10; j++) 
                    { 
                        int jcount = j*10;
                        String tempUrl = "http://zhidao.baidu.com/" + urlbase + " " + jcount.ToString() + "&rn=0&enc=utf8";
                        HtmlAgilityPack.HtmlDocument document1 = HTMLHelper.getHTMLContentByURL(tempUrl, Encoding.UTF8);
                        HtmlNodeCollection nodeCollection2 = HTMLHelper.getHTMLNodeByXpath("//div[@class='list']//a[@class='ti']", document1);
                        if (nodeCollection2 != null)
                        {
                            for (int k = 0; k < nodeCollection2.Count; k++)
                            {
                                String baiduurl = nodeCollection2[k].GetAttributeValue("href", "");
                                if (baiduurl.Contains("baidu"))
                                {
                                    link.Add(baiduurl);
                                    model.insertBaiDuZhiDaoUrl(nameList[i],baiduurl);
                                }
                            }
                        }
                    }
                }
               
            }
            urlList = link;
            content.Text = "地址更新完成";
        }

        private void getZhiDaoUrlButton_Click(object sender, EventArgs e)
        {
            urlList = model.getUrl();
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功";
            }
            else
            {
                content.Text = "地址获取失败";
            }
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            if (id < urlList.Count)
            {
                //宝宝知道
                int index = urlList[id].IndexOf("baobao.baidu.com");
                if (index != -1)
                {
                    HtmlAgilityPack.HtmlDocument document2 = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.UTF8);
                    if (document2 != null)
                    {
                        //问题
                        HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//title", document2);
                        //问题描述
                        HtmlNodeCollection nodeCollection2 = HTMLHelper.getHTMLNodeByXpath("//head//meta[@name ='description']", document2);
                        //问题详细描述
                        HtmlNodeCollection nodeCollection4 = HTMLHelper.getHTMLNodeByXpath("//div[@class='content']", document2);
                        //宝宝知道
                        HtmlNodeCollection nodeCollection7 = HTMLHelper.getHTMLNodeByXpath("//div[@class='answer-detail']", document2);
                        string question = "";
                        string answer = "";
                        if (nodeCollection1 != null)
                        {
                            question += "【问题】" + nodeCollection1[0].InnerText.Replace("\n", "").Replace("'", "");
                            question += "||";
                            if (nodeCollection2 != null)
                            {
                                question += "【问题描述】" + nodeCollection2[0].GetAttributeValue("content", "");
                                question += "||";
                            }
                            if (nodeCollection4 != null)
                            {
                                question += "【问题详细描述】" + nodeCollection4[0].InnerText.Replace("\n", "").Replace("'", "");
                                question += "||";
                            }
                            if (nodeCollection7 != null)
                            {
                                for (int j = 0; j < nodeCollection7.Count; j++)
                                {
                                    answer += "【宝宝知道】" + nodeCollection7[j].InnerText.Replace("\n", "").Replace("'", "");
                                    answer += "||";
                                }
                            }
                            urlAddress.Text = urlList[id];
                            content.Text = question + "                                " + answer;
                            XPath.Text = "";
                            model.updateText(urlList[id], question, answer);
                        }
                        if (nodeCollection4 != null)
                        {
                            question += "【问题详细描述】" + nodeCollection4[0].InnerText.Replace("\n", "").Replace("'", "");
                            question += "||";
                        }
                        if (nodeCollection7 != null)
                        {
                            for (int j = 0; j < nodeCollection7.Count; j++)
                            {
                                answer += "【宝宝知道】" + nodeCollection7[j].InnerText.Replace("\n", "").Replace("'", "");
                                answer += "||";
                            }
                        }
                        urlAddress.Text = urlList[id];
                        content.Text = question + "                                " + answer;
                        XPath.Text = "";
                        model.updateText(urlList[id], question, answer);
                    }
                }
                else
                {
                    index = urlList[id].IndexOf("zhidao.baidu.com");
                    if (index != -1)
                    {
                        HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.Default);
                        //问题
                        HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//title", document);
                        //问题描述
                        HtmlNodeCollection nodeCollection2 = HTMLHelper.getHTMLNodeByXpath("//head//meta[@name ='description']", document);
                        //问题详细描述
                        HtmlNodeCollection nodeCollection4 = HTMLHelper.getHTMLNodeByXpath("//div[@class='content']", document);
                        //百度最佳回答
                        HtmlNodeCollection nodeCollection3 = HTMLHelper.getHTMLNodeByXpath("//pre[@class='best-text mb-10']", document);
                        //百度网友采纳回答
                        HtmlNodeCollection nodeCollection6 = HTMLHelper.getHTMLNodeByXpath("//pre[@class='recommend-text mb-10']", document);
                        //百度其余所有回答
                        HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//span[@class='con']|//span[@class='con-all']", document);
                        //拇指百度回答
                        //HtmlNodeCollection nodeCollection5 = HTMLHelper.getHTMLNodeByXpath("//div[@class='answer-content']", document);
                        if (nodeCollection1 != null)
                        {
                            string question = "";
                            string answer = "";
                            question += "【问题】" + nodeCollection1[0].InnerText.Replace("\n", "").Replace("'", "");
                            question += "||";
                            if (nodeCollection2 != null)
                            {
                                question += "【问题描述】" + nodeCollection2[0].GetAttributeValue("content", "");
                                question += "||";
                            }
                            if (nodeCollection4 != null)
                            {
                                question += "【问题详细描述】" + nodeCollection4[0].InnerText.Replace("\n", "").Replace("'", "");
                                question += "||";
                            }
                            if (nodeCollection3 != null)
                            {
                                answer += "【最佳答案】";
                                answer += nodeCollection3[0].InnerText.Replace("\n", "").Replace("'", "");
                                answer += "||";
                            }
                            if (nodeCollection6 != null)
                            {
                                answer += "【网友采纳】";
                                answer += nodeCollection6[0].InnerText.Replace("\n", "").Replace("'", "");
                                answer += "||";
                            }
                            if (nodeCollection != null)
                            {
                                for (int j = 0; j < nodeCollection.Count; j++)
                                {
                                    if (j < nodeCollection.Count - 1)
                                    {
                                        if (nodeCollection[j].GetAttributeValue("class", "").Equals("con") && nodeCollection[j + 1].GetAttributeValue("class", "").Equals("con-all"))
                                        {
                                            answer += "【百度知道其他答案】";
                                            answer += nodeCollection[j + 1].InnerText.Replace("\n", "").Replace("'", "");
                                            answer += "||";
                                            j++;
                                        }
                                        else
                                        {
                                            answer += "【百度知道其他答案】";
                                            answer += nodeCollection[j].InnerText.Replace("\n", "").Replace("'", "");
                                            answer += "||";
                                        }
                                    }
                                    else
                                    {
                                        answer += "【百度知道其他答案】";
                                        answer += nodeCollection[j].InnerText.Replace("\n", "").Replace("'", "");
                                        answer += "||";
                                    }

                                }
                            }
                            //if (nodeCollection5 != null)
                            //{
                            //    for (int j = 0; j < nodeCollection5.Count; j++)
                            //    {
                            //        answer += "【拇指医生】" + nodeCollection5[j].InnerText.Replace("\n", "").Replace("'", "");
                            //        answer += "||";
                            //    }
                            //}
                            urlAddress.Text = urlList[id];
                            content.Text = question + "                                " + answer;
                            XPath.Text = "";
                            model.updateText(urlList[id], question, answer);
                        }
                    }
                }
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                return;
            }
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            startButton_Click(startButton, null);
        }

       
    }
}
