﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HtmlAgilityPack;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.ChaJiBing
{
    public partial class ChaJiBingForm : Form
    {
        List<string> urlList = new List<string>();//所有疾病的url地址

        private JiBing model = new JiBing();
        private JiBingModel jibingModel = new JiBingModel();

        private int id = 0;

        public ChaJiBingForm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// 获取疾病url存入数据库
        /// </summary>
        private void saveJiBingUrl()
        {
            MessageBox.Show("疾病地址已经获取完毕！");
            //获取所有疾病的url地址
            int pageCount = 366;
            for (int i = 1; i <= pageCount; i++) //共366页pageCount为366
            {
                //根据url地址获取某页的dom对象
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://cjb.5120.com/disease/lists/" + i.ToString(), Encoding.UTF8);
                //利用XPath分析该对象
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='symptom']/ul//a", document);
                if (nodeCollection != null)
                {
                    foreach (var node in nodeCollection)
                    {
                        string href = node.GetAttributeValue("href", "");
                        string title = node.InnerText;
                        urlList.Add(href);  //临时存储href
                        //model.InsertJiBingUrl(title, href);
                    }
                }
            }
            content.Text = "地址更新完成";
        }



        private void ChaJiBingForm_Load(object sender, EventArgs e)
        {
            //saveJiBingUrl(); //获取疾病的url地址并存储到数据库中
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            urlList = model.getUrl();
            content.Text = "获取地址完成";
            //List<string> nodediseaseAttribute = new List<string>();
            //List<string> nodediseaseContent = new List<string>();
            if (id < urlList.Count)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.UTF8);

                //HtmlNodeCollection nodeDiseaseTitle = HTMLHelper.getHTMLNodeByXpath("//div[@class='location']/span", document); //获取疾病名称（在获取url地址的时候已经获取）
                HtmlNodeCollection nodeDiseaseContentList = HTMLHelper.getHTMLNodeByXpath("//ul[@id='tab_conbox']/li[position()<10]", document); //疾病的属性内容(含有不定数个p标签)(前9个样式相同，都是p标签)
                //获取食疗页面
                HtmlNodeCollection nodeDiseaseContentList10 = HTMLHelper.getHTMLNodeByXpath("//table[@class='p_foodtab']//th|//table[@class='p_foodtab']//td", document);

                if (document != null)
                {
                    if (nodeDiseaseContentList != null)
                    {
                        if (nodeDiseaseContentList.Count>=1)
                        {
                            jibingModel.Summary = nodeDiseaseContentList[0].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 2)
                        {
                            jibingModel.Cause = nodeDiseaseContentList[1].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 3)
                        {
                            jibingModel.Prevention = nodeDiseaseContentList[2].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 4)
                        {
                            jibingModel.Complication = nodeDiseaseContentList[3].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 5)
                        {
                            jibingModel.Identify = nodeDiseaseContentList[4].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 6)
                        {
                            jibingModel.Symptom = nodeDiseaseContentList[5].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 7)
                        {
                            jibingModel.Inspection = nodeDiseaseContentList[6].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 8)
                        {
                            jibingModel.Treatment = nodeDiseaseContentList[7].InnerText.FilterStr();
                        }
                        if (nodeDiseaseContentList.Count >= 9)
                        {
                            jibingModel.DietHealth = nodeDiseaseContentList[8].InnerText.FilterStr();
                        }
                    }
                    if (nodeDiseaseContentList10 != null)
                    {
                        StringBuilder dietTyerapy = new StringBuilder();
                        int n = 0;
                        while (n < nodeDiseaseContentList10.Count)
                        {
                            dietTyerapy.Append(nodeDiseaseContentList10[n].InnerText.FilterStr());
                            n++;
                            if (n % 3 == 0)
                                dietTyerapy.Append("@"); //行间隔
                            else
                                dietTyerapy.Append("||"); //列间隔
                        }
                        jibingModel.DietTyerapy = dietTyerapy.ToString();
                    }
                }
                model.UpdateJiBingAttributeByUrl(urlList[id], jibingModel);

                content.Text = urlList[id] + "爬取完成";
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                return;
            }
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            startButton_Click(startButton, null);
        }

        private void saveJiBingUrlButton_Click(object sender, EventArgs e)
        {
            urlList = model.getUrl();
            content.Text = "获取地址完成";
        }

    }
}
