﻿using HtmlAgilityPack;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Common;
using YFDYFKnowledgeDiscovery.Semantics;

namespace YFDYFKnowledgeDiscovery.Spider.JDWebBrowserForm
{
    public partial class JDWebBrowserForm : Form
    {
        private Dao.JD model = new Dao.JD();

        private int id = 1;

        private int urlId = 0;

        List<string> productUrlList = new List<string>();
        int commentTotal = 0;
        /// <summary>
        /// json数据url地址列表
        /// </summary>
        List<string> commentJsonList = new List<string>(); //
        public JDWebBrowserForm()
        {
            InitializeComponent();
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            Uri uri = new Uri("http://search.jd.com/Search?keyword=%E7%9B%8A%E4%B8%B0%E5%A4%A7%E8%8D%AF%E6%88%BF%E6%97%97%E8%88%B0%E5%BA%97&enc=utf-8&pvid=pg3slpii.gvhtj6#keyword=%E7%9B%8A%E4%B8%B0%E5%A4%A7%E8%8D%AF%E6%88%BF%E6%97%97%E8%88%B0%E5%BA%97&enc=utf-8&qrst=1&rt=1&stop=1&vt=2&sid=69359&page="+(id)+"&click=0");
            browser.Url = uri;
            urlAddress.Text = uri.ToString();
            XPath.Text = "a";
            id++;
            startButtonTrigger.Start();
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            //获取商品评价json数据地址
            //button_start_Detail_Click(button_start_Detail, null);
            //获取商品的列表地址
            //startButton_Click(startButton, null);
            button_getComment_Click(button_getComment, null);
        }

        private void browser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            //String str = browser.Document.Body.InnerHtml;
           
            //model.saveData2("http://shixin.court.gov.cn/findDetai?id=" + id.ToString(), str);

            HtmlElementCollection elements = browser.Document.GetElementsByTagName("a");
            string allStr = "";
            int i = 0;
            foreach (HtmlElement element in elements)
            {
                String tempStr = element.GetAttribute("href");
                int index1 = tempStr.IndexOf("http://item.jd.com/");
                int index2 = tempStr.IndexOf("#");
                if (index1 != -1 && index2 == -1)
                {
                    i++;
                    allStr += i + ":" + tempStr + "||";
                    //插入数据库
                    model.InsertJDShangPinUrl(tempStr, "");
                }
            }
            content.Text = allStr;
        }

       
        
        /// <summary>
        /// 获取商品首页的数据
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_start_Detail_Click(object sender, EventArgs e)
        {
            productUrlList = model.getProductUrl(); //获取商品的链接

            if (urlId < productUrlList.Count)
            {
                int commentTotalPage = 0;
                //获取商品的首页数据
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(productUrlList[urlId], Encoding.Default);
                if (document == null) //未获取到
                {
                    content.Text = productUrlList[urlId].ToString() + "未获取到页面";
                }
                else
                {
                    HtmlNodeCollection nodeTitle = HTMLHelper.getHTMLNodeByXpath("//div[@id='name']/h1", document); //获取共多少条 中药材每页是8个
                    //名称
                    string productName = nodeTitle[0].InnerText;
                    HtmlNodeCollection nodePrice = HTMLHelper.getHTMLNodeByXpath("//strong[@id='jd-price']", document); //获取共多少条 中药材每页是8个
                    //价位暂时取不到
                    //double price = Convert.ToDouble(nodePrice[0].InnerText.Trim('￥'));
                    HtmlNodeCollection nodeTotal = HTMLHelper.getHTMLNodeByXpath("//em[@class='hl_blue hide']", document); //获取共多少条 中药材每页是8个
                    //总数暂时取不到
                    //int total = Convert.ToInt32(nodeTotal[0].InnerText.Trim('(').Trim(')'));
                    //获取商品ID
                    var productid = getProductId(productUrlList[urlId].ToString());
                    var commenturl = "http://club.jd.com/productpage/p-" + productid + "-s-0-t-3-p-0.html";
                    content.Text = "开始获取" + commenturl;

                    PackageHttpRequest(commenturl, "", "", "");
                    commentTotalPage = getTotalPage(commentTotal, 10);

                    if (commentTotalPage > 1)
                    {
                        for (int commentIndex = 0; commentIndex < commentTotalPage; commentIndex++)
                        {
                            commenturl = "http://club.jd.com/productpage/p-" + productid + "-s-0-t-3-p-" + commentIndex + ".html";
                            model.InsertJsonUrl(productName, commenturl);
                            content.Text = commenturl + "存储完成";
                            //PackageHttpRequest(commenturl, "", "", "");
                        }
                        //model.UpdateFlagByUrl(productUrlList[urlId]);
                    }
                    else
                    {
                        content.Text = commenturl + "没有评论";
                    }
                    model.UpdateFlagByUrl(productUrlList[urlId]);
                }
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
            }
            urlId++;
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            //button1_Click(button1, null);
        }

        public void PackageHttpRequest(string strRequestUri, string strReferer, string strContent, string strCookie)
        {
            // 初始化HttpWebRequest
            HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(strRequestUri);

            // 封装Cookie
            Uri uri = new Uri(strRequestUri);
            Cookie cookie = new Cookie("Name", strCookie); // 设置key、value形式的Cookie
            CookieContainer cookies = new CookieContainer();
            cookies.Add(uri, cookie);
            httpRequest.CookieContainer = cookies;

            // 封装Http Header
            httpRequest.Method = "Post";
            httpRequest.Referer = strReferer;
            httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.89 Safari/537.36";
            httpRequest.Accept = "text/plain, */*; q=0.01";
            httpRequest.ContentType = "application/x-www-form-urlencoded; charset=UTF-8";
            httpRequest.Timeout = 1000 * 30;
            httpRequest.KeepAlive = true;

            // 通过流写入请求数据
            byte[] bytes = System.Text.Encoding.UTF8.GetBytes(strContent); // 编码形式按照个人需求来设置
            httpRequest.ContentLength = bytes.Length;
            Stream requestStream = httpRequest.GetRequestStream();
            requestStream.Write(bytes, 0, bytes.Length);
            requestStream.Close(); // 不要忘记关闭流

            // 获得应答报文
            HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
            Stream responseStream = httpResponse.GetResponseStream();
            StreamReader reader = new StreamReader(responseStream, System.Text.Encoding.Default);
            string strResponse = reader.ReadToEnd();
            if (!string.IsNullOrEmpty(strResponse.Trim()))
            {
                JObject jo = JObject.Parse(strResponse);
                var values = jo.Properties().Select(item => item.Value).ToArray();
                ///commentTotal = Convert.ToInt32(values[7][""]);
                commentTotal = Convert.ToInt32(values[1]["commentCount"].ToString());
                if (commentTotal == 0)
                {
                    content.Text = strRequestUri + "没有评论";
                }
                else
                {
                    foreach (var v in values[7].ToList())
                    {
                        string commnent = v["content"].ToString();
                        int comment_star = Convert.ToInt32(v["score"].ToString());
                        string name = v["referenceName"].ToString();
                        //model.InsertJDProductCommnent(name, 0.0f, commnent, comment_star);
                    }
                    content.Text = strRequestUri + "获取评论完成";
                }
            }
            else
            {
                content.Text = strRequestUri + "获取数据失败";
            }
            reader.Close();
            responseStream.Close();
        }

        private string getProductId(string str)
        {
            int begin = str.IndexOf("http://item.jd.com/") + 19;
            int end = str.IndexOf(".html");
            return str.Substring(begin, end - begin);
        }

        /// <summary>
        /// 根据总数和每页的个数计算总页数
        /// </summary>
        /// <param name="totalCount">总数</param>
        /// <param name="perCount">每页数</param>
        /// <returns></returns>
        private int getTotalPage(int totalCount, int perCount)
        {
            if (totalCount > 0)
            {
                if (totalCount % perCount == 0)
                {
                    return totalCount / perCount;
                }
                else
                {
                    return 1 + (totalCount / perCount);
                }
            }
            return 0;
        }
        int commentjsonId = 0;

        /// <summary>
        /// 更新
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button_getComment_Click(object sender, EventArgs e)
        {
            commentJsonList = model.getCommentJsonUrl();
            if (commentjsonId < commentJsonList.Count)
            {
                PackageHttpRequest2(commentJsonList[commentjsonId], "", "", "");
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
            }
            commentjsonId++;
        }
        public void PackageHttpRequest2(string strRequestUri, string strReferer, string strContent, string strCookie)
        {
            // 初始化HttpWebRequest
            HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(strRequestUri);

            // 封装Cookie
            Uri uri = new Uri(strRequestUri);
            Cookie cookie = new Cookie("Name", strCookie); // 设置key、value形式的Cookie
            CookieContainer cookies = new CookieContainer();
            cookies.Add(uri, cookie);
            httpRequest.CookieContainer = cookies;

            // 封装Http Header
            httpRequest.Method = "Post";
            httpRequest.Referer = strReferer;
            httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.89 Safari/537.36";
            httpRequest.Accept = "text/plain, */*; q=0.01";
            httpRequest.ContentType = "application/x-www-form-urlencoded; charset=UTF-8";
            httpRequest.Timeout = 1000 * 30;
            httpRequest.KeepAlive = true;

            // 通过流写入请求数据
            byte[] bytes = System.Text.Encoding.UTF8.GetBytes(strContent); // 编码形式按照个人需求来设置
            httpRequest.ContentLength = bytes.Length;
            Stream requestStream = httpRequest.GetRequestStream();
            requestStream.Write(bytes, 0, bytes.Length);
            requestStream.Close(); // 不要忘记关闭流

            // 获得应答报文
            HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
            Stream responseStream = httpResponse.GetResponseStream();
            StreamReader reader = new StreamReader(responseStream, System.Text.Encoding.Default);
            string strResponse = reader.ReadToEnd();
            if (!string.IsNullOrEmpty(strResponse.Trim()))
            {
                JObject jo = JObject.Parse(strResponse);
                var values = jo.Properties().Select(item => item.Value).ToArray();
                StringBuilder sb = new StringBuilder();
                foreach (var v in values[7].ToList())
                {
                    string commnent = v["content"].ToString();
                    string comment_star = v["score"].ToString();
                    sb.Append(commnent);
                    sb.Append("||");
                    sb.Append(comment_star);
                    sb.Append("@");
                }
                model.UpdateJsonDataByUrl(strRequestUri, sb.ToString());
                content.Text = strRequestUri + "获取评论完成";
            }
            else
            {
                content.Text = strRequestUri + "获取数据失败";
            }
            reader.Close();
            responseStream.Close();
        }

        private void JDWebBrowserForm_Load(object sender, EventArgs e)
        {

        }
    }
}
