﻿using HtmlAgilityPack;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;
using YFDYFKnowledgeDiscovery.Semantics;

namespace YFDYFKnowledgeDiscovery.Spider.TMall
{
    public partial class TMallWebBrowerForm : Form
    {
        private int productPageIndex = 1;//商品列表页码的索引 从1开始
        private Dao.TMall model = new Dao.TMall();
        private List<string> productUrlList = new List<string>(); //商品的url列表
        public TMallWebBrowerForm()
        {
            InitializeComponent();
            this.browser.ScriptErrorsSuppressed = true;
        }
      
        /// <summary>
        /// 通过webBrowers的方式获取商品的列表
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void getProductUrlButton_Click(object sender, EventArgs e)
        {
            //MessageBox.Show("健一网已爬取完成");
            //return;
            //益丰
            //Uri uri = new Uri("https://yfdyf.tmall.com/search.htm?pageNo=" + productPageIndex);  //该方法会弹出脚本错误
            //Uri uri = new Uri(" https://list.tmall.com/search_shopitem.htm?&s=" + (productPageIndex - 1) * 60 + "&oq=%D2%E6%B7%E1%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&sort=s&user_id=761832027");
            
            //康爱多
            //Uri uri = new Uri("https://kangaiduo.tmall.com/search.htm?pageNo=" + productPageIndex); //该方法会弹出脚本错误
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BF%B5%B0%AE%B6%E0&style=sg&sort=s&user_id=761832027");

            //健一网大药房旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BD%A1%D2%BB%CD%F8%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=740783227");

            //好护士器械旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BA%C3%BB%A4%CA%BF%C6%F7%D0%B5%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2074722020");
           
            //健客大药房
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BD%A1%BF%CD%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=720248198");

            //醉清风旗舰
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D7%ED%C7%E5%B7%E7%C6%EC%BD%A2&style=sg&sort=s&user_id=2380958892");

            //欧姆龙官方旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%C5%B7%C4%B7%C1%FA%B9%D9%B7%BD%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2098506058");

            //老百姓大药房
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%C0%CF%B0%D9%D0%D5%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=1964521445");

            //壹号大药房旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D2%BC%BA%C5%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=764853586");

            //durex杜蕾斯官方旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=durex%B6%C5%C0%D9%CB%B9%B9%D9%B7%BD%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=1986899349");

            //叶同仁大药房旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D2%B6%CD%AC%C8%CA%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=1674413158");
            
            //鱼跃官方旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D3%E3%D4%BE%B9%D9%B7%BD%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2107759029");

            //德开大药房旗舰
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%B5%C2%BF%AA%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2&style=sg&sort=s&user_id=2115363345");

            //九州大药房
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BE%C5%D6%DE%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=699484863");

            //华佗大药房旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BB%AA%D9%A2%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=825279296");

            //海王星辰大药房旗舰店
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%BA%A3%CD%F5%D0%C7%B3%BD%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=729345368");
            //------------

            //新华大药房旗舰店 28
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D0%C2%BB%AA%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2047661386");

            //亚洲大药房旗舰店 9
            //Uri uri = new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 + "&oq=%D1%C7%D6%DE%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=764934870");

            //德生堂大药房旗舰店 63
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s=" + (productPageIndex - 1) * 60 +"&oq=%B5%C2%C9%FA%CC%C3%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=1014237390");

            //瑞人堂大药房旗舰店 33
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s="+ (productPageIndex - 1) * 60 +"&oq=%C8%F0%C8%CB%CC%C3%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2041451147");

            //九安医疗器械 1
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?user_id=2599134047&cat=2&spm=a220m.1000862.a2227oh.d100&oq=%BE%C5%B0%B2%D2%BD%C1%C6%C6%F7%D0%B5%C6%EC%BD%A2%B5%EA&suggest=0_1&ds=1&stype=search");

            //好药师大药房旗舰店 88
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s="+ (productPageIndex - 1) * 60 +"&oq=%BA%C3%D2%A9%CA%A6%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=1612646209");

            //康佰医疗器械 2
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s="+(productPageIndex - 1) * 60+"&oq=%BF%B5%B0%DB%D2%BD%C1%C6%C6%F7%D0%B5%D7%A8%D3%AA%B5%EA&style=sg&sort=s&user_id=2699760003");

            //都市大药房旗舰店 52
            //Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s="+(productPageIndex - 1) * 60+"&oq=%B6%BC%CA%D0%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=2002400747");

            //健民大药店 30
            Uri uri=new Uri("https://list.tmall.com/search_shopitem.htm?s="+(productPageIndex - 1) * 60+"&oq=%BD%A1%C3%F1%B4%F3%D2%A9%B7%BF%C6%EC%BD%A2%B5%EA&style=sg&sort=s&user_id=880320734");

            browser.Url = uri;
            urlAddress.Text = uri.ToString();

            if (productPageIndex > 88) 
            {
                startButtonTrigger.Stop();
            }
            else
            {
                startButtonTrigger.Start();
                productPageIndex++;
            }
        }

        private void browser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            HtmlElementCollection elements = browser.Document.GetElementsByTagName("a");

            string allStr = "";
            int i = 0;
            foreach (HtmlElement element in elements)
            {
                var result2 = element.GetAttribute("href");
                int index1 = result2.IndexOf("detail.tmall.com/item.htm");
                if (index1 != -1)
                {
                    i++;
                    allStr += i + ":" + result2 + "\r\t";
                    //插入数据库
                    model.InsertTMallShangPinUrl(result2);
                }
            }
            if(allStr=="")
            {
                startButtonTrigger.Stop();
                MessageBox.Show(productPageIndex + "需要登录!", "是否登录？", MessageBoxButtons.OKCancel);

                startButtonTrigger.Start();

            }
            content.Text = allStr+"爬取完成";

        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            //获取商品的url地址
            //getProductUrlButton_Click(getProductUrlButton, null);
            //评论Json数据的url地址
            //button_start_Detail_Click(button_start_Detail, null); 
            //根据URL获取评论
            button_getComment_Click(button_getComment, null);
        }

        int productUrlid = 0;
        int commentTotal = 0;
       
        string commenturl = "";
        private void button_start_Detail_Click(object sender, EventArgs e)
        {
            if (productUrlid < productUrlList.Count)
            {
                int commentTotalPage = 0;
                //获取商品的首页数据
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(productUrlList[productUrlid], Encoding.Default);
                if (document == null) //未获取到
                {
                    content.Text = productUrlList[productUrlid].ToString() + "未获取到页面";
                }
                else
                {
                    HtmlNodeCollection nodeTitle = HTMLHelper.getHTMLNodeByXpath("//title", document);
                    //名称
                    string productName = nodeTitle[0].InnerText.Replace("-tmall.com天猫", "");
                   
                    HtmlNodeCollection nodeTotal = HTMLHelper.getHTMLNodeByXpath("//em[@class='hl_blue hide']", document); //获取共多少条 中药材每页是8个
                    HtmlNodeCollection selleridNode = HTMLHelper.getHTMLNodeByXpath("//input[@id='dsr-userid']", document);
                    string sellerId = "";
                    sellerId = selleridNode[0].GetAttributeValue("value"," ").ToString();
                    //<input type="hidden" id="dsr-userid" value="740783227"/>


                    //获取商品ID
                    var productid = getProductId(productUrlList[productUrlid].ToString());
                    commenturl = "https://rate.tmall.com/list_detail_rate.htm?itemId=" + productid + "&sellerId="+sellerId+"&currentPage=1";

                    content.Text = "开始获取" + commenturl;

                    PackageHttpRequest(commenturl, "", "", ""); //为了获取总数
                    //PackageHttpRequest("https://rate.tmall.com/list_detail_rate.htm?itemId=35652209205&sellerId=761832027&currentPage=1", "", "", "");

                    commentTotalPage = getTotalPage(commentTotal, 20);

                    if (commentTotalPage >= 1)
                    {
                        for (int commentIndex = 0; commentIndex < commentTotalPage; commentIndex++)
                        {
                            commenturl = "https://rate.tmall.com/list_detail_rate.htm?itemId=" + productid + "&sellerId=" + sellerId + "&currentPage=" + commentIndex;

                            model.InsertJsonUrl(productName, commenturl);
                            content.Text = commenturl + "存储完成";
                            //PackageHttpRequest(commenturl, "", "", "");
                        }
                    }
                    else
                    {
                        content.Text = commenturl + "没有评论";
                    }
                    model.UpdateFlagByUrl(productUrlList[productUrlid]);
                }
                startButtonTrigger.Start();
            }
            else
            {
                content.Text = "获取URL完成";
                startButtonTrigger.Stop();
            }
            productUrlid++;
        }

        /// <summary>
        /// 根据总数和每页的个数计算总页数
        /// </summary>
        /// <param name="totalCount">总数</param>
        /// <param name="perCount">每页数</param>
        /// <returns></returns>
        private int getTotalPage(int totalCount, int perCount)
        {
            if (totalCount > 0)
            {
                if (totalCount % perCount == 0)
                {
                    return totalCount / perCount;
                }
                else
                {
                    return 1 + (totalCount / perCount);
                }
            }
            return 0;
        }

        public void PackageHttpRequest(string strRequestUri, string strReferer, string strContent, string strCookie)
        {
            // 初始化HttpWebRequest
            HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(strRequestUri);

            // 封装Cookie
            Uri uri = new Uri(strRequestUri);
            Cookie cookie = new Cookie("Name", strCookie); // 设置key、value形式的Cookie
            CookieContainer cookies = new CookieContainer();
            cookies.Add(uri, cookie);
            httpRequest.CookieContainer = cookies;

            // 封装Http Header
            httpRequest.Method = "Post";
            httpRequest.Referer = strReferer;
            httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.89 Safari/537.36";
            httpRequest.Accept = "text/plain, */*; q=0.01";
            httpRequest.ContentType = "application/x-www-form-urlencoded; charset=UTF-8";
            httpRequest.Timeout = 1000 * 30;
            httpRequest.KeepAlive = true;

            // 通过流写入请求数据
            byte[] bytes = System.Text.Encoding.UTF8.GetBytes(strContent); // 编码形式按照个人需求来设置
            httpRequest.ContentLength = bytes.Length;
            Stream requestStream = httpRequest.GetRequestStream();
            requestStream.Write(bytes, 0, bytes.Length);
            requestStream.Close(); // 不要忘记关闭流

            // 获得应答报文
            HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
            if(httpResponse!=null)
            {
                Stream responseStream = httpResponse.GetResponseStream();
                StreamReader reader = new StreamReader(responseStream, System.Text.Encoding.Default);
                string strResponse = reader.ReadToEnd().FilterStr().Substring(13);
                if (!string.IsNullOrEmpty(strResponse))
                {
                    JObject jo = JObject.Parse(strResponse);
                    var values = jo.Properties().Select(item => item.Value).ToArray();
                    StringBuilder sb = new StringBuilder();
                    commentTotal = Convert.ToInt32(values[1]["total"]);
                    foreach (var v in values[3].ToList())
                    {
                        string commnent = v["rateContent"].ToString();
                        sb.Append(commnent);
                        sb.Append("@");
                    }
                    //model.UpdateJsonDataByUrl(strRequestUri, sb.ToString());
                    content.Text = strRequestUri + "获取评论完成";
                }
                else
                {
                    content.Text = strRequestUri + "获取数据失败";
                }
                reader.Close();
                responseStream.Close();
            }
            
        }

        public void PackageHttpRequest2(string strRequestUri, string strReferer, string strContent, string strCookie)
        {
            // 初始化HttpWebRequest
            HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(strRequestUri);

            // 封装Cookie
            Uri uri = new Uri(strRequestUri);
            Cookie cookie = new Cookie("Name", strCookie); // 设置key、value形式的Cookie
            CookieContainer cookies = new CookieContainer();
            cookies.Add(uri, cookie);
            httpRequest.CookieContainer = cookies;

            // 封装Http Header
            httpRequest.Method = "Post";
            httpRequest.Referer = strReferer;
            httpRequest.UserAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.89 Safari/537.36";
            httpRequest.Accept = "text/plain, */*; q=0.01";
            httpRequest.ContentType = "application/x-www-form-urlencoded; charset=UTF-8";
            httpRequest.Timeout = 1000 * 30;
            httpRequest.KeepAlive = true;

            // 通过流写入请求数据
            byte[] bytes = System.Text.Encoding.UTF8.GetBytes(strContent); // 编码形式按照个人需求来设置
            httpRequest.ContentLength = bytes.Length;
            Stream requestStream = httpRequest.GetRequestStream();
            requestStream.Write(bytes, 0, bytes.Length);
            requestStream.Close(); // 不要忘记关闭流

            // 获得应答报文
            HttpWebResponse httpResponse = (HttpWebResponse)httpRequest.GetResponse();
            Stream responseStream = httpResponse.GetResponseStream();
            StreamReader reader = new StreamReader(responseStream, System.Text.Encoding.Default);
            string strResponse = reader.ReadToEnd().FilterStr().Substring(13);
            if (!string.IsNullOrEmpty(strResponse))
            {
                JObject jo = JObject.Parse(strResponse);
                var values = jo.Properties().Select(item => item.Value).ToArray();
                StringBuilder sb = new StringBuilder();
                commentTotal = Convert.ToInt32(values[1]["total"]);
                foreach (var v in values[3].ToList())
                {
                    string commnent = v["rateContent"].ToString(); 
                    sb.Append(commnent);
                    sb.Append("@");
                }
                model.UpdateJsonDataByUrl(strRequestUri, sb.ToString());
                content.Text = strRequestUri + "获取评论完成";
            }
            else
            {
                content.Text = strRequestUri + "获取数据失败";
            }
            reader.Close();
            responseStream.Close();
        }

        private string getProductId(string s)
        {
            int start = s.IndexOf("id=") + 3;
            int end = s.IndexOf("&is_b=");
            return s.Substring(start, end - start);
        }
        List<string> commentJsonList = new List<string>();
        int commentjsonId = 1000;

        private void button_getComment_Click(object sender, EventArgs e)
        {
            if (commentjsonId < commentJsonList.Count)  //14万
            {
                PackageHttpRequest2(commentJsonList[commentjsonId], "", "", "");
                startButtonTrigger.Start();
            }
            else
            {
                content.Text = "获取完成";
                startButtonTrigger.Stop();
            }
            commentjsonId++;
        }

        private void button_getUrl_Click(object sender, EventArgs e)
        {
            commentJsonList = model.getCommentJsonUrl();
            content.Text = "获取完成";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            productUrlList = model.GetProductUrlList();//获取商品的链接
            content.Text = "获取完成";
        }

        private void TMallWebBrowerForm_Load(object sender, EventArgs e)
        {

        }
    }
}
