﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.YaoPinTongJianKang
{
    public partial class YaoPinTongForm : Form
    {
        private List<string> urlList = new List<string>();
        //中西药分类连接
        private List<string> zhongxiyaoList = new List<string>() { 
        "http://ypk.39.net/ganmao/", //已存
        "http://ypk.39.net/pifu/",  //已存
        "http://ypk.39.net/weichang/",//已存
        "http://ypk.39.net/wuguan/",
        "http://ypk.39.net/huxixitong/",
        "http://ypk.39.net/jiating/",
        "http://ypk.39.net/nanke/",
        "http://ypk.39.net/fuke/",
        "http://ypk.39.net/erke/",
        "http://ypk.39.net/wssjyy/",
        "http://ypk.39.net/xingbingyongyao/",
        "http://ypk.39.net/zhongliu/",
        "http://ypk.39.net/jiehe/",
        "http://ypk.39.net/xueye/",
        "http://ypk.39.net/dianjiezhi/",
        "http://ypk.39.net/jishengchong/",
        "http://ypk.39.net/mianyi/",
        "http://ypk.39.net/shenbing/",
        "http://ypk.39.net/neifenmi/",
        "http://ypk.39.net/shenjing/",
        "http://ypk.39.net/gandanyi/",
        "http://ypk.39.net/xinnaoxueguan/",
        }; 

        private YaoPinTong model = new YaoPinTong();
        //private int id = 0;

        public YaoPinTongForm()
        {
            InitializeComponent();
        }

        private void timer_zhongxiyao_Tick(object sender, EventArgs e)
        {
            button_zhongxiyao_Click(button_zhongxiyao, null);
        }

        private string getURlFromStr(string s)
        {
            int start = s.IndexOf("href=") + 1;
            if (start != -1)
            {
                int end = s.IndexOf("\">");
                return s.Substring(start, end - start);
            }
            else
            {
                return "不合法的url地址";
            }
        }
        int id = 1; //页数
        private void saveURL()
        {
            var baseurl = "http://ypk.39.net";

            if (id <= 282)
            {
                var pageurl = zhongxiyaoList[3] + "p" + id.ToString();
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(pageurl, Encoding.Default);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs']/strong/a", document);
                if (document != null)
                {
                    foreach (var node in nodelist)
                    {
                        var url = node.GetAttributeValue("href", "");
                        var name = node.InnerText;

                        model.InsertYaoPinShuoMingUrl(name, baseurl + url + "manual");
                        content.Text = baseurl + url + "存储完成";
                    }
                }

                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                return;
            }
            return;
        }
        //通过http://ypk.39.net/search/+关键词获取数据(稍后做)
        //中西药
        int shuomingUrlIndex = 0; //
        private void button_zhongxiyao_Click(object sender, EventArgs e)
        {
            var shuomingUrl = model.getUrl();
            if (shuomingUrlIndex < shuomingUrl.Count())
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(shuomingUrl[shuomingUrlIndex], Encoding.Default);
                //HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='tab_box']//dt|//div[@class='tab_box']//dd", document);//中西药
                //HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@id='tab2_con_1']//dt|//div[@id='tab2_con_1']//dd", document);//中药材（一部分获取不到节点数据）
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='tab_box']//dt|//div[@class='tab_box']//dd", document);//保健品
                //HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='gs_right']//p", document);
                if (document != null)
                {
                    StringBuilder text = new StringBuilder();
                    int n = 0;
                    if (nodelist != null)
                    {
                        //医疗器械
                        //foreach (var node in nodelist)
                        //{
                        //    text.Append(node.InnerText);
                        //}

                        //医疗器械之外
                        while (n < nodelist.Count)
                        {
                            text.Append(nodelist[n].InnerText.Trim().Replace("\r", "").Replace("\n", "").Replace("&nbsp;", "").Replace("'", "").Replace(" ", ""));
                            n++;
                            if (n % 2 == 0)
                                text.Append("@"); //行间隔
                            else
                                text.Append("||"); //列间隔
                        }
                        model.UpdateShuoMingShuByUrl(text.ToString().FilterStr(), shuomingUrl[shuomingUrlIndex]);
                        content.Text = shuomingUrl[shuomingUrlIndex] + "存储完成";
                    }
                    else
                    {
                        content.Text = shuomingUrl[shuomingUrlIndex] + "获取节点失败";
                    }
                }
                else
                {
                    content.Text = shuomingUrl[shuomingUrlIndex] + "获取页面失败";
                }
                shuomingUrlIndex++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                content.Text = "数据爬取完成";
                return;
            }
        }
        /// <summary>
        /// 获取中西药的url地址(临时表)
        /// </summary>
        private void saveZhongxiyaoUrl()
        {
            foreach (var url in zhongxiyaoList)
            {
                //string url = zhongyaocaiUrlpart1 + urlIndex.ToString() + "/1.shtml"; //每个分类的第一页，取得其中的该分类的总页数
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.Default);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//span[@class='pgleft']/b", document); //获取共多少条 中药材每页是8个
                if (document != null)
                {
                    if (nodelist != null)
                    {
                        StringBuilder text = new StringBuilder();
                        int n = 0;
                        if (nodelist != null)
                        {
                            int totalCount = Convert.ToInt32(nodelist[0].InnerText.Trim(new char[] { '共', '条' }));
                            int totalPage = getTotalPage(totalCount, 15);
                            string fenleiUrl = url;
                            //插入数据库
                            model.insertLinShiZhongXiYao(fenleiUrl, totalPage, totalCount);
                        }
                    }
                }
            }
        }

        /// <summary>
        /// 中西药的url
        /// </summary>
        private void getZhongXiYaoUrl()
        {
            var BaseUrl = "http://ypk.39.net";
            var dic = model.getUrlFromLinShiZhongXiYao();
            foreach (var v in dic)
            {
                for (int i = 1; i <= v.Value; i++)
                {
                    var url1 = v.Key + "p" + i.ToString();
                    HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url1, Encoding.Default);
                    HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs']/strong/a", document);
                    if (document != null)
                    {
                        if (nodelist != null)
                        {
                            foreach (var node in nodelist)
                            {
                                var url = node.GetAttributeValue("href", "");
                                var name = node.InnerText;
                                url = BaseUrl + url;
                                //插入数据库
                                model.InsertYaoPinShuoMingUrl(name, url, "中西药");
                            }
                        }
                        content.Text = url1 + "存储完成";
                    }
                }
            }
        }

        //第一步，存储中药材分类码：如861。
        //第二部，存储中药材的每个分类的总页码
        private void SaveZhongYaoCaiUrl()
        {
            //string zhongyaocaiUrlpart1 = "http://ypk.39.net/tcm/861/1.shtml";
            //string zhongyaocaiUrlpart1 = "http://ypk.39.net/tcm/";
            //for (int urlIndex = 861; urlIndex <= 885; urlIndex++)
            //{
            //    string url = zhongyaocaiUrlpart1 + urlIndex.ToString() + "/1.shtml"; //每个分类的第一页，取得其中的该分类的总页数
            //    HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.Default);
            //    HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//span[@class='pgleft']/b", document); //获取共多少条 中药材每页是8个
            //    if (document != null)
            //    {
            //        if (nodelist != null)
            //        StringBuilder text = new StringBuilder();
            //        int n = 0;
            //        if (nodelist != null)
            //        {
            //            int totalCount = Convert.ToInt32(nodelist[0].InnerText.Trim(new char[] { '共', '条' }));
            //            int totalPage = getTotalPage(totalCount, 8);
            //            string fenleiUrl = zhongyaocaiUrlpart1 + urlIndex.ToString() + "/";
            //            //插入数据库
            //            model.insertLinShiZhongYaoCai(fenleiUrl, totalPage, totalCount);
            //            while (n < nodelist.Count)
            //            {
            //                text.Append(nodelist[n].InnerText.Trim().Replace("\r", "").Replace("\n", "").Replace("&nbsp;", "").Replace("'", "").Replace(" ", ""));
            //                n++;
            //                if (n % 2 == 0)
            //                    text.Append("@"); //行间隔
            //                else
            //                    text.Append("||"); //列间隔
            //            }
            //        }
            //    }
            //}
        }
        /// <summary>
        /// 根据总数和每页的个数计算总页数
        /// </summary>
        /// <param name="totalCount">总数</param>
        /// <param name="perCount">每页数</param>
        /// <returns></returns>
        private int getTotalPage(int totalCount,int perCount)
        {
            if (totalCount > 0)
            {
                if (totalCount % perCount == 0)
                {
                    return totalCount / perCount;
                }
                else
                {
                    return 1 + (totalCount / perCount);
                }
            }
            return 0;
        }
        
        /// <summary>
        /// 中药材的url
        /// </summary>
        private void GetZhongYaoCaiUrl()
        {
            var zhongyaocaiBaseUrl = "http://ypk.39.net";
            var dic = model.getUrlFromLinShiZhongYaoCai();
            foreach(var v in dic)
            {
               for(int i=1;i<=v.Value;i++)
               {
                   var url1 = v.Key + i + ".shtml";
                   HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url1, Encoding.Default);
                   HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs msgs3']/strong/a", document);
                   if (document != null)
                   {
                       if (nodelist != null)
                       {
                           foreach (var node in nodelist)
                           {
                               var url = node.GetAttributeValue("href", "");
                               var name = node.InnerText;
                               url = zhongyaocaiBaseUrl + url;
                               //插入数据库
                               model.InsertYaoPinShuoMingUrl(name, url, "中药材");
                           }
                       }
                       content.Text = url1 + "存储完成";
                   }
               }
            } 
        }
        /// <summary>
        /// 获取所有保健品的url和名字,存入数据库
        /// </summary>
        private void getBaoJianPinUrl()
        {
            int pageindex = 1; //pageindex 从1到812页
            string baojingpinUrl = "http://ypk.39.net/search/t3_did3_field0_p";
            var zhongyaocaiBaseUrl = "http://ypk.39.net";
            for (pageindex=601; pageindex <= 812; pageindex++)  
            {                
                var url1 = baojingpinUrl + pageindex.ToString() + "/";
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url1, Encoding.Default);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs']/strong/a", document);
                if (document != null)
                {
                    if (nodelist != null)
                    {
                        foreach (var node in nodelist)
                        {
                            var url = node.GetAttributeValue("href", "");
                            var name = node.InnerText;
                            url = zhongyaocaiBaseUrl + url + "manual";
                            //插入数据库
                            model.InsertYaoPinShuoMingUrl(name, url, "保健品");
                        }
                    }
                    content.Text = url1 + "存储完成";
                }
            }
        }
        //获取医疗器械的URL
        private void getYiLiaoQiXie() 
        {
            int pageindex = 1; //pageindex 从1到414页
            string baojingpinUrl = "http://ypk.39.net/search/t4_did3_p";
            var zhongyaocaiBaseUrl = "http://ypk.39.net";
            for (pageindex = 1; pageindex <= 414; pageindex++)
            {
                var url1 = baojingpinUrl + pageindex.ToString() + "/";
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url1, Encoding.Default);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs']/strong/a", document);
                if (document != null)
                {
                    if (nodelist != null)
                    {
                        foreach (var node in nodelist)
                        {
                            var url = node.GetAttributeValue("href", "");
                            var name = node.InnerText;
                            url = zhongyaocaiBaseUrl + url;
                            //插入数据库
                            model.InsertYaoPinShuoMingUrl(name, url, "医疗器械");
                        }
                    }
                    content.Text = url1 + "存储完成";
                }
            }
        }
        /// <summary>
        /// search爬虫
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void seach_button_Click(object sender, EventArgs e)
        {
            SearchSpider("感冒");
        }

        private void SearchSpider(string param)
        {
            string url = "http://ypk.39.net/search/" + param;
            HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.Default);
            HtmlNodeCollection totalPageNode = HTMLHelper.getHTMLNodeByXpath("//span[@class='pgleft']/b", document);
            int searchTotalCount = Convert.ToInt32(totalPageNode[0].InnerText.Trim(new char[] { '共', '条' }));
            int searchTotalPage = getTotalPage(searchTotalCount, 15);
            for (int i = 1; i <= searchTotalPage; i++)
            {
                HtmlAgilityPack.HtmlDocument document2 = HTMLHelper.getHTMLContentByURL(url+"-p"+i.ToString()+"/", Encoding.Default);
                HtmlNodeCollection nodelist = HTMLHelper.getHTMLNodeByXpath("//div[@class='msgs']/strong/a", document2);
                if (document != null)
                {
                    if (nodelist != null)
                    {
                        foreach (var node in nodelist)
                        {
                            var name = node.InnerText;
                        }
                    }
                    content.Text = url + "-p" + i.ToString() + "/";
                }
            }
        }
    }
}
