﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HtmlAgilityPack;
using YFDYFKnowledgeDiscovery.Semantics;

namespace YFDYFKnowledgeDiscovery.Spider.YiHaoDian
{
    public partial class YiHaoDian : Form
    {
        Dao.YiHaoDian dao = new Dao.YiHaoDian();
        List<String> urlList = new List<string>();
        private int id = 0;

        public YiHaoDian()
        {
            InitializeComponent();
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            String allStr = "";
            if (id >= urlList.Count)
            {
                startButtonTrigger.Stop();
                return;
            }
            HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.UTF8);
            if (document != null)
            {
                //获得药品评价总页数
                int totalPages = 1;
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//li[@class='latestnewtotalpage']", document);
                if (nodeCollection != null && nodeCollection[0].InnerText.Length > 2)
                {
                    try
                    {
                        totalPages = Convert.ToInt32(nodeCollection[0].InnerText.Substring(1, 1));
                    }
                    catch
                    {
                        totalPages = 1;
                    }
                }
                //获得药品评价和评分
                int flag = urlList[id].IndexOf(".html");
                for (int page = 1; page <= totalPages; page++)
                {
                    String url = urlList[id].Substring(0, flag) + "-" + page.ToString() + ".html";
                    document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                    nodeCollection = HTMLHelper.getHTMLNodeByXpath("//span[@class='name']|//dt[@class='user_info']//span|//a[@class='btn']", document);
                    if (nodeCollection == null)
                    {
                        continue;
                    }
                    for (int i = 0; i < nodeCollection.Count; i++)
                    {
                        if (nodeCollection[i].GetAttributeValue("class", "") != null && nodeCollection[i].GetAttributeValue("class", "").ToString().Equals("name") == true)
                        {
                            allStr += "@【用户名】" + nodeCollection[i].InnerText.Trim() + "||";
                        }
                        if (nodeCollection[i].GetAttributeValue("class", "") != null && nodeCollection[i].GetAttributeValue("class", "").Length > 5 && nodeCollection[i].GetAttributeValue("class", "").ToString().Substring(0, 4).Equals("star") == true)
                        {
                            allStr += "【评分】" + nodeCollection[i].GetAttributeValue("class", "").ToString().Substring(5).Trim() + "||";
                        }
                        if (nodeCollection[i].GetAttributeValue("href", "") != null)
                        {
                            int index = nodeCollection[i].GetAttributeValue("href", "").ToString().IndexOf("http://club.yhd.com/review/s");
                            if (index != -1)
                            {
                                allStr += "【评论】" + nodeCollection[i].InnerText.Trim();
                            }
                        }
                    }
                }
                content.Text = allStr;
            }
            dao.updateText(urlList[id], allStr);
            id++;
            startButtonTrigger.Start();
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            startButton_Click(startButton, null);
        }

        private void saveUrlButton_Click(object sender, EventArgs e)
        {
            List<string> link = new List<string>();

            //获取2-35页的所有药品网址
            for (int i = 0; i < 37; i++)
            {
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL("http://shop.yhd.com/dpzx/search-0-144675-0-0-0.html?pageSize=48&pageNo=" + i.ToString() + "&keyword=", Encoding.UTF8);
                HtmlNodeCollection nodeCollection = HTMLHelper.getHTMLNodeByXpath("//div[@class='item4line1 shop-goods clearfix']//a", document);
                for (int j = 0; j < nodeCollection.Count; j++)
                {
                    link.Add(nodeCollection[j].GetAttributeValue("href", ""));
                    dao.saveUrl(nodeCollection[j].InnerText, nodeCollection[j].GetAttributeValue("href", ""));
                }
            }

            DataTable dt = dao.getNameAndUrl();
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                String name = dt.Rows[i][0].ToString();
                String url = dt.Rows[i][1].ToString();
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(url, Encoding.UTF8);
                HtmlNodeCollection nodeCollection1 = HTMLHelper.getHTMLNodeByXpath("//input[@id='mainProductId']", document);
                dao.saveCommentsUrl(name, "http://club.yhd.com/review/" + nodeCollection1[0].GetAttributeValue("value", "").ToString() + ".html");
            }
            content.Text = "地址更新完成";
        }

        private void getUrlButton_Click(object sender, EventArgs e)
        {
            urlList = dao.getUrl();
            if (urlList != null && urlList.Count != 0)
            {
                content.Text = "地址获取成功";
            }
            else
            {
                content.Text = "地址获取失败";
            }
        }

        private void button_Integration_Click(object sender, EventArgs e)
        {
            CommentIntegration integration = new CommentIntegration();
            integration.IntegrationYhd();
        }
    }
}
