﻿using HtmlAgilityPack;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using YFDYFKnowledgeDiscovery.Dao;
using YFDYFKnowledgeDiscovery.Common;

namespace YFDYFKnowledgeDiscovery.Spider.ZhongGuoJianKangWang
{
    public partial class ZhongGuoJianKangWangForm : Form
    {
        List<string> urlList = new List<string>();

        private Dao.ZhongGuoJianKangWang model = new Dao.ZhongGuoJianKangWang();
        private ZhongGuoJianKangWangModel zhongguojiankangModel = new ZhongGuoJianKangWangModel();

        private int id = 0;

        public ZhongGuoJianKangWangForm()
        {
            InitializeComponent();
        }

        private void saveJiankangUrl()
        {
            int pageCount = 8656;
            string urlpart1 = "http://www.jiankang.cn/disease/";
            string urlpart2 = ".html";
            for (int i = 1; i <= pageCount; i++)
            {
                string url = urlpart1 + i.ToString() + urlpart2;
                model.InsertJiBingUrl(url);
            }
        }

        private void startButtonTrigger_Tick(object sender, EventArgs e)
        {
            startButton_Click(startButton, null);
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            urlList = model.getUrl();
          

            if (id < urlList.Count)
            {
                //gb2312
                HtmlAgilityPack.HtmlDocument document = HTMLHelper.getHTMLContentByURL(urlList[id], Encoding.Default);
                if (document != null)
                {
                    HtmlNodeCollection title = HTMLHelper.getHTMLNodeByXpath("//div[@class='bk_title']", document);
                    if (title.Count >= 1)
                    {
                        zhongguojiankangModel.Name = title[0].InnerText.FilterStr();
                    }

                    //别名等等。。。
                    HtmlNodeCollection nodelist1 = HTMLHelper.getHTMLNodeByXpath("//div[@class='edit_text']//em", document);
                    zhongguojiankangModel.Alias = nodelist1[0].InnerText.FilterStr();
                    zhongguojiankangModel.Position = nodelist1[1].InnerText.FilterStr();
                    zhongguojiankangModel.Office = nodelist1[2].InnerText.FilterStr();
                    zhongguojiankangModel.Symptom = nodelist1[3].InnerText.FilterStr();

                    //其他属性
                    HtmlNodeCollection nodelist2 = HTMLHelper.getHTMLNodeByXpath("//div[@class='edit_text02']", document);
                    zhongguojiankangModel.BasicDescribe = nodelist2[0].InnerText.FilterStr();
                    zhongguojiankangModel.Cause = nodelist2[1].InnerText.FilterStr();
                    zhongguojiankangModel.SymptomsSigns = nodelist2[2].InnerText.FilterStr();
                    zhongguojiankangModel.InspectionTesting = nodelist2[3].InnerText.FilterStr();
                    zhongguojiankangModel.Diagnosis = nodelist2[4].InnerText.FilterStr();
                    zhongguojiankangModel.Complication = nodelist2[5].InnerText.FilterStr();
                    zhongguojiankangModel.PreventiveCare = nodelist2[6].InnerText.FilterStr();
                    zhongguojiankangModel.Treatment = nodelist2[7].InnerText.FilterStr();
                    
                }
                model.UpdateJiBingAttributeByUrl(urlList[id], zhongguojiankangModel);
                content.Text = urlList[id] + "爬取完成";
                id++;
                startButtonTrigger.Start();
            }
            else
            {
                startButtonTrigger.Stop();
                content.Text = "获取数据完成";
            }
        }

        private void saveJiBingUrlButton_Click(object sender, EventArgs e)
        {
            saveJiankangUrl();
        }
    }
}
